#include "GBCommon.h"


//NX`
class GGetNameCategory : public GBase
{
public:
	bool get(const char* url, char* title, char* category)
	{
		char* buff;
		char* token;
		UINT buffsize;

		if      (strstr(url, "auto"))     strcpy(category, "ԁEoCN");
		else if (strstr(url, "computer")) strcpy(category, "p\RElbg");
		else if (strstr(url, "game"))     strcpy(category, "Q[");
		else if (strstr(url, "movie"))    strcpy(category, "TVEfE{");
		else if (strstr(url, "music"))    strcpy(category, "|\Ey");
		else if (strstr(url, "shop"))     strcpy(category, "VbsO");
		else if (strstr(url, "sports"))   strcpy(category, "EX|[c");
		else if (strstr(url, "travel"))   strcpy(category, "sEn");
		else if (strstr(url, "business")) strcpy(category, "rWlXEo");
		else if (strstr(url, "study"))    strcpy(category, "lEȊw");
		else if (strstr(url, "news"))     strcpy(category, "j[XE");
		else                              strcpy(category, "");

		strcpy(title, "");
		if ((buff = get_html(url, &buffsize)) == NULL)
			return false;
		token = strtok(buff, "<>");
		while (token != NULL)
		{
			if (stricmp(token, "TITLE") == 0)
			{
				if ((token = strtok(NULL, "<>")) != NULL)
				{
					strcpy(title, token);
					break;
				}
			}
			token = strtok(NULL, "<>");
		}
		free(buff);

		if (strlen(title) == 0)
			return false;
		return true;
	};
};


//OQ
extern HINSTANCE instance;
extern HWND hwnd_main;
extern HWND hwnd_tree;
extern GItaList* italist_fav;
extern GItaList* italist_2ch;
extern GItaList* italist_etc;


//vCx[g֐vg^Cv
BOOL CALLBACK dlg_addita_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
LPARAM get_tree_param(HTREEITEM item);


/*--------------------------------------------------------------------------
 
  create_ita_tree

  c[Rg[쐬

--------------------------------------------------------------------------*/

void create_ita_tree(HIMAGELIST imagelist)
{
	hwnd_tree = CreateWindowEx(
		WS_EX_CLIENTEDGE,
		WC_TREEVIEW,
		"",
		WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP | WS_VISIBLE |
		TVS_HASLINES /*| TVS_HASBUTTONS | TVS_LINESATROOT*/ | TVS_SHOWSELALWAYS,
		0, 0, 0, 0,
		hwnd_main,
		(HMENU)ID_TREE,
		instance,
		NULL
	);
	TreeView_SetImageList(hwnd_tree, imagelist, TVSIL_NORMAL);
}


/*--------------------------------------------------------------------------

  make_ita_tree

  c[쐬

--------------------------------------------------------------------------*/

void make_tree(void)
{
	TVINSERTSTRUCT tvi;
	HTREEITEM cat_item;
	char catg[MAX_CATG_NAME];
	char name[MAX_ITA_NAME];
	UINT i;

	TreeView_DeleteAllItems(hwnd_tree);

	//Cɓ
	strcpy(catg, "Cɓ");
	tvi.hParent = TVI_ROOT;
	tvi.hInsertAfter = TVI_LAST;
	tvi.item.mask = TVIF_TEXT | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
	tvi.item.state = TVIS_BOLD | TVIS_EXPANDED;
	tvi.item.stateMask = tvi.item.state;
	tvi.item.pszText = catg;
	tvi.item.cchTextMax = strlen(catg);
	tvi.item.iImage = 2;
	tvi.item.iSelectedImage = 2;
	tvi.item.lParam = -1;
	cat_item = TreeView_InsertItem(hwnd_tree, &tvi);
	TreeView_SelectItem(hwnd_tree, cat_item);
	
	for (i = 0; i < italist_fav->count(); i++)
	{
		tvi.hParent = cat_item;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
		strcpy(name, italist_fav->get_name(i));
		tvi.item.pszText = name;
		tvi.item.cchTextMax = strlen(name);
		tvi.item.iImage = 2;
		tvi.item.iSelectedImage = 2;
		tvi.item.lParam = MAKELPARAM(i, 0);
		TreeView_InsertItem(hwnd_tree, &tvi);
	}

	//2channel.brd
	strcpy(catg, "");
	for (i = 0; i < italist_2ch->count(); i++)
	{
		if (strcmp(italist_2ch->get_category(i), catg) != 0)
		{
			strcpy(catg, italist_2ch->get_category(i));
			tvi.hParent = TVI_ROOT;
			tvi.hInsertAfter = TVI_LAST;
			tvi.item.mask = TVIF_TEXT | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
			tvi.item.state = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.stateMask = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.pszText = catg;
			tvi.item.cchTextMax = strlen(catg);
			tvi.item.iImage = 0;
			tvi.item.iSelectedImage = 0;
			tvi.item.lParam = -1;
			cat_item = TreeView_InsertItem(hwnd_tree, &tvi);
		}
		
		tvi.hParent = cat_item;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
		strcpy(name, italist_2ch->get_name(i));
		tvi.item.pszText = name;
		tvi.item.cchTextMax = strlen(name);
		tvi.item.iImage = 1;
		tvi.item.iSelectedImage = 1;
		tvi.item.lParam = MAKELPARAM(i, 1);
		TreeView_InsertItem(hwnd_tree, &tvi);
	}

	//etc.brd
	strcpy(catg, "");
	for (i = 0; i < italist_etc->count(); i++)
	{
		if (strcmp(italist_etc->get_category(i), catg) != 0)
		{
			strcpy(catg, italist_etc->get_category(i));
			tvi.hParent = TVI_ROOT;
			tvi.hInsertAfter = TVI_LAST;
			tvi.item.mask = TVIF_TEXT | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
			tvi.item.state = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.stateMask = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.pszText = catg;
			tvi.item.cchTextMax = strlen(catg);
			tvi.item.iImage = 0;
			tvi.item.iSelectedImage = 0;
			tvi.item.lParam = -1;
			cat_item = TreeView_InsertItem(hwnd_tree, &tvi);
		}
		
		tvi.hParent = cat_item;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
		strcpy(name, italist_etc->get_name(i));
		tvi.item.pszText = name;
		tvi.item.cchTextMax = strlen(name);
		tvi.item.iImage = 1;
		tvi.item.iSelectedImage = 1;
		tvi.item.lParam = MAKELPARAM(i, 2);
		TreeView_InsertItem(hwnd_tree, &tvi);
	}
}


/*--------------------------------------------------------------------------
 
  open_ita

  JiX擾j

--------------------------------------------------------------------------*/

void open_ita(HTREEITEM item)
{
	unsigned int taddr;
	LPARAM param;
	UINT idx;

	if ((param = get_tree_param(item)) == -1)
		return;

/*
	list_type = 0;
	mainwnd_OnTabSelChange(1);
	if (handle_get_thread != NULL)
	{
		if (!TerminateThread(handle_get_thread, 0))
		{
			return;
		}
		CloseHandle(handle_get_thread);
	}
	handle_get_thread = (HANDLE)_beginthreadex(NULL, 0,
 		                          threadentry_get_threadlist, item, 0, &taddr);
*/
}


/*--------------------------------------------------------------------------
 
  open_ita_by_browser

  uEUŊJ

--------------------------------------------------------------------------*/

void open_ita_by_browser(HTREEITEM item)
{
	LPARAM param;
	char cmdline[1024];
	char url[256];

	if ((param = get_tree_param(item)) != -1)
	{
		switch (HIWORD(param))
		{
		case 0:
			italist_fav->get_topurl(LOWORD(param), url);
			break;
		case 1:
			italist_2ch->get_topurl(LOWORD(param), url);
			break;
		case 2:
			italist_etc->get_topurl(LOWORD(param), url);
			break;
		}
	}
	wsprintf(cmdline, "exec.exe %s", url);
	WinExec(cmdline, SW_SHOWNORMAL);
}


/*--------------------------------------------------------------------------
 
  add_favorite_ita

  Cɓɒǉ

--------------------------------------------------------------------------*/

void add_favboard_item(HTREEITEM item)
{
	TVINSERTSTRUCT tvis;
	GItaList* italist;
	LPARAM param;
	int idx;
	UINT i;
	char name[MAX_ITA_NAME];

	if ((param = get_tree_param(item)) == -1)
		return;

	switch (HIWORD(param))
	{
	case 0:
		return;
	case 1:
		italist = italist_2ch;
		break;
	case 2:
		italist = italist_etc;
		break;
	}
	idx = LOWORD(param);

	//ɂCɓɑ݂邩H
	for (i = 0; i < italist_fav->count(); i++)
	{
		if (strcmp(italist->get_server(idx), italist_fav->get_server(i)) == 0 &&
			strcmp(italist->get_bbs(idx),    italist_fav->get_bbs(i))    == 0)
		{
			return;
		}
	}
	
	//Reiɒǉ
	italist_fav->add(
		italist->get_name(idx),
		"",
		italist->get_server(idx),
		italist->get_bbs(idx),
		0);

	//c[ɒǉ
	tvis.hParent = TreeView_GetRoot(hwnd_tree);
	tvis.hInsertAfter = TVI_LAST;
	tvis.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
	strcpy(name, italist->get_name(idx));
	tvis.item.pszText = name;
	tvis.item.cchTextMax = strlen(name);
	tvis.item.iImage = 1;
	tvis.item.iSelectedImage = 1;
	tvis.item.lParam = MAKELPARAM(italist_fav->count() - 1, 0);
	TreeView_InsertItem(hwnd_tree, &tvis);

	save_ini();
}


/*--------------------------------------------------------------------------
 
  del_favorite_ita

  Cɓ̍폜

--------------------------------------------------------------------------*/

void del_favboard_item(HTREEITEM item)
{
	LPARAM param;

	if ((param = get_tree_param(item)) == -1)
		return;

	if (HIWORD(param) != 0)
		return;

	TreeView_DeleteItem(hwnd_tree, item);
	italist_fav->del(LOWORD(param));

	save_ini();
}


/*--------------------------------------------------------------------------
 
  show_add_ita_dlg

  ǉ

--------------------------------------------------------------------------*/

void show_add_ita_dlg(HTREEITEM item)
{
	DialogBox(instance, MAKEINTRESOURCE(IDD_ADD_ITA), hwnd_main, dlg_addita_Proc);
}


/*--------------------------------------------------------------------------
 
  dlg_addita_Proc

  ǉ_CAOEvV[W

--------------------------------------------------------------------------*/

BOOL CALLBACK dlg_addita_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	GGetNameCategory* ggnc;
	HWND h;
	char category[MAX_CATG_NAME];
	char name[MAX_ITA_NAME];
	char server[MAX_SERVER_NAME];
	char bbs[MAX_BBS_NAME];
	char topurl[256];
	UINT i;

	switch (msg)
	{
	case WM_INITDIALOG:
		Edit_LimitText(GetDlgItem(hwnd, IDC_TOPURL),       sizeof(topurl) - 1);
		Edit_LimitText(GetDlgItem(hwnd, IDC_ITA_NAME),     sizeof(name) - 1);
		ComboBox_LimitText(GetDlgItem(hwnd, IDC_CATEGORY), sizeof(category) - 1);

		h = GetDlgItem(hwnd, IDC_CATEGORY);
		strcpy(category, "");
		for (i = 0; i < italist_etc->count(); i++)
		{
			if (strcmp(category, italist_etc->get_category(i)) != 0)
			{
				strcpy(category, italist_etc->get_category(i));
				ComboBox_AddString(h, category);
			}
		}
		ComboBox_SetCurSel(h, 0);
		set_window_pos_best(hwnd);
		break;

	case WM_COMMAND:
		switch (LOWORD(wp))
		{
		//擾
		case IDC_AUTOGET:
			h = GetDlgItem(hwnd, IDC_TOPURL);
			Edit_GetText(h, topurl, sizeof(topurl));
			if (strlen(topurl) == 0) { SetFocus(h); break; }

			EnableWindow(GetDlgItem(hwnd, IDC_TOPURL), FALSE);
			EnableWindow(GetDlgItem(hwnd, IDC_AUTOGET), FALSE);
			EnableWindow(GetDlgItem(hwnd, IDC_ITA_NAME), FALSE);
			EnableWindow(GetDlgItem(hwnd, IDC_CATEGORY), FALSE);


			SetTimer(hwnd, IDT_GETNAMECATEGORY, 500, NULL);
			break;

		//OK
		case IDOK:
			h = GetDlgItem(hwnd, IDC_TOPURL);
			Edit_GetText(h, topurl, sizeof(topurl));
			if (strlen(topurl) == 0) { SetFocus(h); break; }

			h = GetDlgItem(hwnd, IDC_ITA_NAME);
			Edit_GetText(h, name, sizeof(name));
			if (strlen(name) == 0) { SetFocus(h); break; }

			h = GetDlgItem(hwnd, IDC_CATEGORY);
			ComboBox_GetText(h, category, sizeof(category));
			if (strlen(category) == 0) { SetFocus(h); break; }
			
			italist_etc->add(name, category, server, bbs, 0);

		//CANCEL
		case IDCANCEL:
			EndDialog(hwnd,  LOWORD(wp));
			break;
		}
		break;

	case WM_TIMER:
		//擾
		KillTimer(hwnd, IDT_GETNAMECATEGORY);
		Edit_GetText(GetDlgItem(hwnd, IDC_TOPURL), topurl, sizeof(topurl));
		ggnc = new GGetNameCategory();
		if (ggnc->get(topurl, name, category))
		{
			Edit_SetText(GetDlgItem(hwnd, IDC_ITA_NAME), name);
			Edit_SetText(GetDlgItem(hwnd, IDC_CATEGORY), category);
		}
		else
		{
			MessageBox(hwnd, "擾s", NULL, MB_OK | MB_ICONWARNING);
		}

		EnableWindow(GetDlgItem(hwnd, IDC_TOPURL), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_AUTOGET), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_ITA_NAME), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CATEGORY), TRUE);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/*--------------------------------------------------------------------------
 
  get_tree_param

  c[ACelParam擾

--------------------------------------------------------------------------*/

LPARAM get_tree_param(HTREEITEM item)
{
	TVITEM tvi;

	tvi.hItem = item;
	tvi.mask = TVIF_PARAM;
	TreeView_GetItem(hwnd_tree, &tvi);
	return tvi.lParam;
}
