/***************************************************************************
  Etc.cpp

  Copyright (C) 2001 Hachimaki. All rights reserved.
  Licensed under the GPL(v2).
***************************************************************************/

#include "GBCommon.h"

	
/*--------------------------------------------------------------------------
 
  get_bytetype

  ASCII/}`oCg1/}`oCg2

--------------------------------------------------------------------------*/

#define BYTETYPE1(c) (((((unsigned char)(c))>=0x81)&&(((unsigned char)(c))<=0x9F))||((((unsigned char)(c))>=0xE0)&&(((unsigned char)(c))<=0xFC)))
#define BYTETYPE2(c) ((((unsigned char)(c))!=0x7F)&&(((unsigned char)(c))>=0x40)&&(((unsigned char)(c))<=0xFC))

int get_bytetype(const char* str, int n)
{
	int type;
	int i;
	
	if (n < 0 || n >= (signed)strlen(str))
		return -1;

	type = 0;
	for(i = 0; i <= n; i++)
	{
		if      (type == 0 && BYTETYPE1(*(str + i))) type = 1;
		else if (type == 1 && BYTETYPE2(*(str + i))) type = 2;
		else if (type == 2 && BYTETYPE1(*(str + i))) type = 1;
		else                                         type = 0;
	}

	return type;
}


/*--------------------------------------------------------------------------
 
  change_to_moduledir

  exêfBNgɈړ

--------------------------------------------------------------------------*/

void change_to_moduledir(void)
{

#ifdef _DEBUG
    char path[_MAX_PATH];
    char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];

    GetModuleFileName(NULL, path, _MAX_PATH);
    _splitpath(path, drive, dir, NULL, NULL);
    wsprintf(path, "%s%s\\..", drive, dir);
    SetCurrentDirectory(path);
#else
    char path[_MAX_PATH];
    char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];

    GetModuleFileName(NULL, path, _MAX_PATH);
    _splitpath(path, drive, dir, NULL, NULL);
    wsprintf(path, "%s%s", drive, dir);
    SetCurrentDirectory(path);
#endif
}


/*--------------------------------------------------------------------------
 
  set_window_pos_best

  EBhEʒu̒

--------------------------------------------------------------------------*/

void set_window_pos_best(HWND hwnd)
{
    POINT p;
    RECT r;
    int cx1, cy1, cx2, cy2;

    GetCursorPos(&p);
    GetWindowRect(hwnd, &r);

    cx1 = GetSystemMetrics(SM_CXSCREEN) / 2;
    cy1 = GetSystemMetrics(SM_CYSCREEN) / 2;
    cx2 = (r.right - r.left) / 2;
    cy2 = (r.bottom - r.top) / 2;

    p.x = (p.x - cx1) * (cx1 - cx2) / cx1 / 2 + cx1;
    p.y = (p.y - cy1) * (cy1 - cy2) / cy1 / 2 + cy1;
    p.x -= cx2;
    p.y -= cy2;

    SetWindowPos(hwnd, NULL, p.x, p.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
}
