/***************************************************************************
  File.cpp

  Copyright (C) 2001 Hachimaki. All rights reserved.
  Licensed under the GPL(v2).
***************************************************************************/

#include "GBCommon.h"
#include "GickoViewer.h"

extern GViewer* viewer;
extern HWND hwnd_main;
extern HWND hwnd_list;
extern int tab_max_strlen;
extern BOOL tab_automove_ita;
extern BOOL tab_automove_sure;
extern BOOL tab_automove_check;
extern int trecent_max;
extern int log_save;
extern char log_dir[MAX_PATH];
extern char image_file[MAX_PATH];
extern GItaList* italist_2ch;
extern GItaList* italist_fav;
extern GSureList* surelist_fav;
extern GSureList* surelist_rec;

extern BOOL proxy_status;
extern char write_proxy[256];
extern char read_proxy[256];
/*----------------------------------------------------------------------------
  load_ini
----------------------------------------------------------------------------*/

bool load_ini(void)
{
	FILE* fp;
	LOGFONT font = {0};
	RECT winr;
	char section[64];
	char title[256];
	char server[MAX_SERVER_NAME];
	char bbs[MAX_BBS_NAME];
	char key[MAX_THREAD_KEY];
	char buff[256];
	char* p1;
	char* p2;

	change_to_moduledir();
	SetRect(&winr, 0, 0, 500, 400);

	if ((fp = fopen(INI_FILE, "r")) == NULL)
		return false;

	while (fgets(buff, 256, fp) != NULL)
	{
        if (*buff == '\n')
            continue;

        *(buff + strlen(buff) - 1) = '\0';

		if (*buff == '[' && *(buff + strlen(buff) - 1) == ']')
		{
			memset(section, 0, sizeof(section));
			strncpy(section, buff, strlen(buff));
			continue;
		}

		p1 = buff;
		p2 = strchr(p1, '=');
		if (p2 != NULL)
		{
			*p2 = '\0';
			p2++;
		}

		if (strcmp(section, "[GickoBrowser]") == 0)
		{
			if (strcmp(p1, "lfHeight") == 0)              { font.lfHeight = atol(p2); }
			else if (strcmp(p1, "lfWidth") == 0)          { font.lfWidth = atol(p2); }
			else if (strcmp(p1, "lfEscapement") == 0)     { font.lfEscapement = atol(p2); }
			else if (strcmp(p1, "lfOrientation") == 0)    { font.lfOrientation = atol(p2); }
			else if (strcmp(p1, "lfWeight") == 0)         { font.lfWeight = atol(p2); }
			else if (strcmp(p1, "lfItalic") == 0)         { font.lfItalic = atoi(p2); }
			else if (strcmp(p1, "lfUnderline") == 0)      { font.lfUnderline = atoi(p2); }
			else if (strcmp(p1, "lfStrikeOut") == 0)      { font.lfStrikeOut = atoi(p2); }
			else if (strcmp(p1, "lfCharSet") == 0)        { font.lfCharSet = atoi(p2); }
			else if (strcmp(p1, "lfOutPrecision") == 0)   { font.lfOutPrecision = atoi(p2); }
			else if (strcmp(p1, "lfClipPrecision") == 0)  { font.lfClipPrecision = atoi(p2); }
			else if (strcmp(p1, "lfQuality") == 0)        { font.lfQuality = atoi(p2); }
			else if (strcmp(p1, "lfPitchAndFamily") == 0) { font.lfPitchAndFamily = atoi(p2); }
			else if (strcmp(p1, "lfFaceName") == 0)       { strcpy(font.lfFaceName, p2); }
			
			else if (strcmp(p1, "body_bo") == 0)          { viewer->body_bo = atoi(p2); }
			else if (strcmp(p1, "body_it") == 0)          { viewer->body_it = atoi(p2); }
			else if (strcmp(p1, "body_ul") == 0)          { viewer->body_ul = atoi(p2); }
			else if (strcmp(p1, "body_cl") == 0)          { viewer->body_cl = atol(p2); }
			
			else if (strcmp(p1, "link_bo") == 0)          { viewer->link_bo = atoi(p2); }
			else if (strcmp(p1, "link_it") == 0)          { viewer->link_it = atoi(p2); }
			else if (strcmp(p1, "link_ul") == 0)          { viewer->link_ul = atoi(p2); }
			else if (strcmp(p1, "link_cl") == 0)          { viewer->link_cl = atol(p2); }
			
			else if (strcmp(p1, "numb_on") == 0)          { viewer->numb_on = atoi(p2); }
			else if (strcmp(p1, "numb_bo") == 0)          { viewer->numb_bo = atoi(p2); }
			else if (strcmp(p1, "numb_it") == 0)          { viewer->numb_it = atoi(p2); }
			else if (strcmp(p1, "numb_ul") == 0)          { viewer->numb_ul = atoi(p2); }
			else if (strcmp(p1, "numb_cl") == 0)          { viewer->numb_cl = atol(p2); }
			
			else if (strcmp(p1, "name_on") == 0)          { viewer->name_on = atoi(p2); }
			else if (strcmp(p1, "name_bo") == 0)          { viewer->name_bo = atoi(p2); }
			else if (strcmp(p1, "name_it") == 0)          { viewer->name_it = atoi(p2); }
			else if (strcmp(p1, "name_ul") == 0)          { viewer->name_ul = atoi(p2); }
			else if (strcmp(p1, "name_cl") == 0)          { viewer->name_cl = atol(p2); }
			
			else if (strcmp(p1, "date_on") == 0)          { viewer->date_on = atoi(p2); }
			else if (strcmp(p1, "date_bo") == 0)          { viewer->date_bo = atoi(p2); }
			else if (strcmp(p1, "date_it") == 0)          { viewer->date_it = atoi(p2); }
			else if (strcmp(p1, "date_ul") == 0)          { viewer->date_ul = atoi(p2); }
			else if (strcmp(p1, "date_cl") == 0)          { viewer->date_cl = atol(p2); }
			
			else if (strcmp(p1, "idid_on") == 0)          { viewer->idid_on = atoi(p2); }
			else if (strcmp(p1, "idid_bo") == 0)          { viewer->idid_bo = atoi(p2); }
			else if (strcmp(p1, "idid_it") == 0)          { viewer->idid_it = atoi(p2); }
			else if (strcmp(p1, "idid_ul") == 0)          { viewer->idid_ul = atoi(p2); }
			else if (strcmp(p1, "idid_cl") == 0)          { viewer->idid_cl = atol(p2); }
			
			else if (strcmp(p1, "back_cl") == 0)          { viewer->back_cl = atol(p2); }
			else if (strcmp(p1, "mailout") == 0)          { viewer->mailout = (atol(p2) ? true : false); }

			else if (strcmp(p1, "post_name") == 0)        { if (p2) viewer->post_name.push_back(p2); }
			else if (strcmp(p1, "post_mail") == 0)        { if (p2) viewer->post_mail.push_back(p2); }

			else if (strcmp(p1, "col_width0") == 0)		  { ListView_SetColumnWidth(hwnd_list, 0, atoi(p2)); }
			else if (strcmp(p1, "col_width1") == 0)		  { ListView_SetColumnWidth(hwnd_list, 1, atoi(p2)); }
			else if (strcmp(p1, "col_width2") == 0)		  { ListView_SetColumnWidth(hwnd_list, 2, atoi(p2)); }
			else if (strcmp(p1, "col_width3") == 0)		  { ListView_SetColumnWidth(hwnd_list, 3, atoi(p2)); }
			else if (strcmp(p1, "log_save") == 0)		  { log_save = atoi(p2); }
			else if (strcmp(p1, "log_dir") == 0)		  { strcpy(log_dir, p2); }
			else if (strcmp(p1, "image_file") == 0)		  { strcpy(image_file, p2); }
			else if (strcmp(p1, "tab_max_strlen") == 0)	  { tab_max_strlen = atoi(p2); }
			else if (strcmp(p1, "tab_automove_ita") == 0) { tab_automove_ita = atoi(p2); }
			else if (strcmp(p1, "tab_automove_sure") == 0){ tab_automove_sure = atoi(p2); }
			else if (strcmp(p1, "tab_automove_check") == 0){ tab_automove_check = atoi(p2); }
			else if (strcmp(p1, "trecent_max") == 0)	  { trecent_max = atoi(p2); }

			else if (strcmp(p1, "win_left") == 0)         { winr.left = atoi(p2); }
			else if (strcmp(p1, "win_top") == 0)          { winr.top = atoi(p2); }
			else if (strcmp(p1, "win_right") == 0)        { winr.right = atoi(p2); }
			else if (strcmp(p1, "win_bottom") == 0)       { winr.bottom = atoi(p2); }

//
//v1.0.0 -->
//
			else if (strcmp(p1, "cache_save") == 0)		  { log_save = atoi(p2); if (log_save == 2) log_save = 1; }
			else if (strcmp(p1, "cache_dir") == 0)		  { strcpy(log_dir, p2); }

//
// 117 modify
//
			else if( strcmp(p1, "proxy_stat") == 0)		  { proxy_status = (atoi(p2)?TRUE:FALSE);}
			else if( strcmp(p1, "read_proxy") == 0)
			{ 
				if( proxy_status){
					strcpy( read_proxy,p2);
				}else{
					strcpy( read_proxy,"" );
				}
			}
			else if( strcmp(p1, "write_proxy")== 0)
			{
				if( proxy_status ){
					strcpy( write_proxy,p2);
				}else{
					strcpy( write_proxy,"");
				}
			}

		}
		else if (strcmp(section, "[Bfavorite]") == 0)
		{
			if (italist_2ch->get_server(p1) != 0)
			{
				italist_fav->add(
					p1,
					"Cɓ",
					italist_2ch->get_server(p1),
					italist_2ch->get_bbs(p1),
					0);
			}
		}
		else if (strcmp(section, "[Tfavorite]") == 0 ||
			     strcmp(section, "[Trecent]") == 0)
		{
			strcpy(title, p1);
			p2 = strtok(p2, "/");
			strcpy(server, p2);
			p2 = strtok(NULL, "/");
			strcpy(bbs, p2);
			p2 = strtok(NULL, "/");
			strcpy(key, p2);

			if (strcmp(section, "[Tfavorite]") == 0)
				surelist_fav->insert(surelist_fav->count(), server, bbs, key, title, 0, 0, "2ch");
			else
				surelist_rec->insert(surelist_rec->count(), server, bbs, key, title, 0, 0, "2ch");
		}
//
//<--
//
	}

	fclose(fp);

	if (strlen(font.lfFaceName) != 0)
		viewer->set_font(&font);
	SetWindowPos(
		hwnd_main, NULL, 
		winr.left, winr.top,
		winr.right - winr.left, winr.bottom - winr.top,
		SWP_NOZORDER);

	return true;
}


/*----------------------------------------------------------------------------
  save_ini
----------------------------------------------------------------------------*/

bool save_ini(void)
{
	WINDOWPLACEMENT wp;
	FILE* fp;
	RECT winr;
	UINT i;

	change_to_moduledir();
	if ((fp = fopen(INI_FILE, "w")) == NULL)
		return false;

	//[GickoBrowser]
    fprintf(fp, "[GickoBrowser]\n");
	fprintf(fp, "lfHeight=%ld\n",        viewer->font.lfHeight);
	fprintf(fp, "lfWidth=%ld\n",         viewer->font.lfWidth);
	fprintf(fp, "lfEscapement=%ld\n",    viewer->font.lfEscapement);
	fprintf(fp, "lfOrientation=%ld\n",   viewer->font.lfOrientation);
	fprintf(fp, "lfWeight=%ld\n",        viewer->font.lfWeight);
	fprintf(fp, "lfItalic=%d\n",         viewer->font.lfItalic);
	fprintf(fp, "lfUnderline=%d\n",      viewer->font.lfUnderline);
	fprintf(fp, "lfStrikeOut=%d\n",      viewer->font.lfStrikeOut);
	fprintf(fp, "lfCharSet=%d\n",        viewer->font.lfCharSet);
	fprintf(fp, "lfOutPrecision=%d\n",   viewer->font.lfOutPrecision);
	fprintf(fp, "lfClipPrecision=%d\n",  viewer->font.lfClipPrecision);
	fprintf(fp, "lfQuality=%d\n",        viewer->font.lfQuality);
	fprintf(fp, "lfPitchAndFamily=%d\n", viewer->font.lfPitchAndFamily);
	fprintf(fp, "lfFaceName=%s\n",       viewer->font.lfFaceName);
	
	fprintf(fp, "body_bo=%d\n", viewer->body_bo);
	fprintf(fp, "body_it=%d\n", viewer->body_it);
	fprintf(fp, "body_ul=%d\n", viewer->body_ul);
	fprintf(fp, "body_cl=%ld\n", viewer->body_cl);
	
	fprintf(fp, "link_bo=%d\n", viewer->link_bo);
	fprintf(fp, "link_it=%d\n", viewer->link_it);
	fprintf(fp, "link_ul=%d\n", viewer->link_ul);
	fprintf(fp, "link_cl=%ld\n", viewer->link_cl);
	
	fprintf(fp, "numb_on=%d\n", viewer->numb_on);
	fprintf(fp, "numb_bo=%d\n", viewer->numb_bo);
	fprintf(fp, "numb_it=%d\n", viewer->numb_it);
	fprintf(fp, "numb_ul=%d\n", viewer->numb_ul);
	fprintf(fp, "numb_cl=%ld\n", viewer->numb_cl);
	
	fprintf(fp, "name_on=%d\n", viewer->name_on);
	fprintf(fp, "name_bo=%d\n", viewer->name_bo);
	fprintf(fp, "name_it=%d\n", viewer->name_it);
	fprintf(fp, "name_ul=%d\n", viewer->name_ul);
	fprintf(fp, "name_cl=%ld\n", viewer->name_cl);
	
	fprintf(fp, "date_on=%d\n", viewer->date_on);
	fprintf(fp, "date_bo=%d\n", viewer->date_bo);
	fprintf(fp, "date_it=%d\n", viewer->date_it);
	fprintf(fp, "date_ul=%d\n", viewer->date_ul);
	fprintf(fp, "date_cl=%ld\n", viewer->date_cl);
	
	fprintf(fp, "idid_on=%d\n", viewer->idid_on);
	fprintf(fp, "idid_bo=%d\n", viewer->idid_bo);
	fprintf(fp, "idid_it=%d\n", viewer->idid_it);
	fprintf(fp, "idid_ul=%d\n", viewer->idid_ul);
	fprintf(fp, "idid_cl=%ld\n", viewer->idid_cl);
	
	fprintf(fp, "back_cl=%ld\n", viewer->back_cl);
	fprintf(fp, "mailout=%d\n", viewer->mailout);

	for (i = 0; i < viewer->post_name.size(); i++)
		fprintf(fp, "post_name=%s\n", viewer->post_name[i].c_str());
	for (i = 0; i < viewer->post_mail.size(); i++)
		fprintf(fp, "post_mail=%s\n", viewer->post_mail[i].c_str());

    fprintf(fp, "col_width0=%d\n", ListView_GetColumnWidth(hwnd_list, 0));
    fprintf(fp, "col_width1=%d\n", ListView_GetColumnWidth(hwnd_list, 1));
    fprintf(fp, "col_width2=%d\n", ListView_GetColumnWidth(hwnd_list, 2));
	fprintf(fp, "col_width3=%d\n", ListView_GetColumnWidth(hwnd_list, 3));
	fprintf(fp, "log_save=%d\n", log_save);
	fprintf(fp, "log_dir=%s\n", log_dir);
	fprintf(fp, "image_file=%s\n", image_file);
	fprintf(fp, "tab_max_strlen=%d\n", tab_max_strlen);
	fprintf(fp, "tab_automove_ita=%d\n", tab_automove_ita);
	fprintf(fp, "tab_automove_sure=%d\n", tab_automove_sure);
	fprintf(fp, "tab_automove_check=%d\n", tab_automove_check);
	fprintf(fp, "trecent_max=%d\n", trecent_max);

	wp.length = sizeof(wp);
	GetWindowPlacement(hwnd_main, &wp);
	if (wp.showCmd != SW_MINIMIZE && wp.showCmd != SW_SHOWMINIMIZED)
	{
		GetWindowRect(hwnd_main, &winr);
		fprintf(fp, "win_left=%d\n", winr.left);
		fprintf(fp, "win_top=%d\n", winr.top);
		fprintf(fp, "win_right=%d\n", winr.right);
		fprintf(fp, "win_bottom=%d\n", winr.bottom);
	}

//117 modifiy
	fprintf(fp, "proxy_stat=%s\n",(proxy_status?"1":"0"));
	fprintf(fp, "write_proxy=%s\n",write_proxy);
	fprintf(fp, "read_proxy=%s\n",read_proxy);

    fprintf(fp, "\n");

	fclose(fp);
	return true;
}


/*----------------------------------------------------------------------------
  load_thread
----------------------------------------------------------------------------*/

bool load_thread(void)
{
	FILE* fp;
	char section[64];
	char title[256];
	char server[MAX_SERVER_NAME];
	char bbs[MAX_BBS_NAME];
	char key[MAX_THREAD_KEY];
	char from[64];
	char buff[1024];
	UCHAR type;
	char sep[] = "\t\r\n";
	char* p1;
	char* p2;

	if ((fp = fopen(THREAD_FILENAME, "r")) == NULL)
		return false;

	while (fgets(buff, 1024, fp) != NULL)
	{
		if ((p1 = strchr(buff, '\r')) != NULL)
			*p1 = '\0';
		if ((p1 = strchr(buff, '\n')) != NULL)
			*p1 = '\0';

		if (*buff == '[' && *(buff + strlen(buff) - 1) == ']')
		{
			memset(section, 0, sizeof(section));
			strncpy(section, buff, strlen(buff));
			continue;
		}

		p1 = buff;

		if ((p2 = strchr(p1, '\t')) == NULL) continue;
		*p2 = '\0';
		type = atoi(p1);
		p1 = p2 + 1;

		if ((p2 = strchr(p1, '\t')) == NULL) continue;
		*p2 = '\0';
		strcpy(title, p1);
		p1 = p2 + 1;

		if ((p2 = strchr(p1, '\t')) == NULL) continue;
		*p2 = '\0';
		strcpy(server, p1);
		p1 = p2 + 1;

		if ((p2 = strchr(p1, '\t')) == NULL) continue;
		*p2 = '\0';
		strcpy(bbs, p1);
		p1 = p2 + 1;

		if ((p2 = strchr(p1, '\t')) == NULL) continue;
		*p2 = '\0';
		strcpy(key, p1);
		p1 = p2 + 1;

		strcpy(from, p1);

		if (strcmp(section, "[Favorite]") == 0)
			surelist_fav->insert(surelist_fav->count(), server, bbs, key, title, 0, type, from);
		else
			surelist_rec->insert(surelist_rec->count(), server, bbs, key, title, 0, type, from);
	}

	fclose(fp);
	return true;
}


/*----------------------------------------------------------------------------
  save_thread
----------------------------------------------------------------------------*/

bool save_thread(void)
{
	FILE* fp;
	UINT i;

	if ((fp = fopen(THREAD_FILENAME, "w")) == NULL)
		return false;

	fprintf(fp, "[Favorite]\n");
	for (i = 0; i < surelist_fav->count(); i++)
	{
		fprintf(fp, "%d\t%s\t%s\t%s\t%s\t%s\n", surelist_fav->get_type(i),
			                                    surelist_fav->get_title(i),
										        surelist_fav->get_server(i),
										        surelist_fav->get_bbs(i),
										        surelist_fav->get_key(i),
												surelist_fav->get_from(i));
	}

	fprintf(fp, "[Recent]\n");
	for (i = 0; i < surelist_rec->count(); i++)
	{
		fprintf(fp, "%d\t%s\t%s\t%s\t%s\t%s\n", surelist_rec->get_type(i),
			                                    surelist_rec->get_title(i),
										        surelist_rec->get_server(i),
										        surelist_rec->get_bbs(i),
										        surelist_rec->get_key(i),
												surelist_rec->get_from(i));
	}

	fclose(fp);
	return true;
}
