/***************************************************************************
  GBCommon.h

  Copyright (C) 2001 Hachimaki. All rights reserved.
  Licensed under the GPL(v2).
***************************************************************************/

#ifndef __GBCOMMON_H__
#define __GBCOMMON_H__

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "resource.h"
#include "Gicko.h"


/*--------------------------------------------------------------------------
  NX`
--------------------------------------------------------------------------*/

class TabParam : public GUrl
{
public:
	char url[256];
	char title[256];
	char cgiver[6];
	UINT top_line;
	UINT flag;
	TabParam(void)
	{
		strcpy(url, "");
		strcpy(title, "");
		strcpy(cgiver, "");
		top_line = 0;
		flag = 0;
	}
};


/*--------------------------------------------------------------------------
  }N`
--------------------------------------------------------------------------*/

#define CLASS_NAME				"Gicko browser"
#define WINDOW_TITLE			"Gicko browser"
#define ITALIST_2CH_FILENAME	"2channel.brd"
#define ITALIST_ETC_FILENAME	"etc.brd"
#define ITALIST_FAV_FILENAME	"favorite.brd"
#define THREAD_FILENAME			"thread.lst"
#define INI_FILE                "GickoBrowser.ini"
#define DEFAULT_LOG_DIR			"log"
#define ID_LAMP					1
#define ID_TAB					2
#define ID_TREE					3
#define ID_LIST					4
#define ID_EDIT					5
#define ID_STATUS				6
#define ID_VIEWER				7
#define IDM_OPTION				1
#define IDM_ABOUT				2
#define IDT_LAMPBLINK			1
#define IDT_GETNAMECATEGORY		2
#define UM_URLSEND_START		WM_USER + 1
#define UM_URLSEND_ADDCHAR		WM_USER + 2
#define UM_URLSEND_END			WM_USER + 3
#define UM_VIEWER_CALLBACK		WM_USER + 4
#define UM_INET_CALLBACK		WM_USER + 5
#define TABFLAG_NONE			0
#define TABFLAG_WAIT			1
#define TABFLAG_LOADING			2


/*--------------------------------------------------------------------------
  ֐vg^Cv
--------------------------------------------------------------------------*/

//Main
void set_control_pos(void);
HIMAGELIST create_imagelist(void);

//Tab
void create_tab(void);
void tab_OnInetCallback(UINT message_id, LPARAM lp);
void tab_OnContextMenu(WORD x, WORD y);
void tab_OnSelChange(void);
void select_tab(int idx);
void select_next_tab(void);
void select_prev_tab(void);
void open_tab(const char* url, UCHAR type, const char* title);
void del_tab(int idx);
void set_tab_text(int idx, const char* text);
TabParam* get_tab_param(int idx);

//ItaTree
void create_itatree(void);
void set_itatree_image(void);
void itatree_OnContextMenu(WORD x, WORD y);
void make_itatree(void);
void open_ita(void);
void open_ita_by_browser(void);
void del_ita(void);
void add_favorite_ita(void);
void show_add_ita_dlg(void);
void show_ita_property(void);

//SureList
void create_surelist(void);
void set_surelist_image(void);
void surelist_OnColumnClick(int iSubItem);
void surelist_OnContextMenu(WORD x, WORD y);
void make_surelist(int type);
int get_list_type(void);
void add_favorite_sure(void);
void del_favorite_sure(void);
void open_sure(void);
void open_sure_by_browser(void);
void check_sure(bool all);
void find_sure(const char* keyword);
void show_sure_property(void);
bool import_dat(void);
bool export_dat(void);

//File
bool load_ini(void);
bool save_ini(void);
bool load_thread(void);
bool save_thread(void);

//Etc
int get_bytetype(const char* str, int n);
void change_to_moduledir(void);
void set_window_pos_best(HWND hwnd);


#endif
