/***************************************************************************
  Gicko.cpp

  Copyright (C) 2001 Hachimaki. All rights reserved.
  Licensed under the GPL(v2).
***************************************************************************/

#include "Gicko.h"
#include "zlib.h"

extern BOOL proxy_status;
extern char write_proxy[256];
extern char read_proxy[256];

/*****************************************************************************
  class GUrl
*****************************************************************************/

/*----------------------------------------------------------------------------
  GUrl::split
----------------------------------------------------------------------------*/

bool GUrl::split(const char* url)
{
	char* p1;
	char* p2;

	memset(server, 0, sizeof(server));
	memset(bbs, 0, sizeof(bbs));
	memset(key, 0, sizeof(key));
	ls = 0;
	st = 0;
	to = 0;
	nofirst = false;

	if (!strstr(url, "read.cgi"))
	{
		return false;
	}

	//2ch or jbbs?
	if (strstr(url, ".2ch.net") || strstr(url, ".bbspink.com"))
		type = 0;
	else
		type = 1;

	//server
	if ((p1 = strstr(url, "//")) != NULL)
	{
		p1 += 2;
		if ((p2 = strchr(p1, '/')) == NULL)
			return false;
		strncpy(server, p1, p2 - p1);
	}
	else
	{
		if ((p2 = strchr(url, '/')) == NULL)
			return false;
		strncpy(server, url, p2 - url);
	}
	//subdir
	if (type == 1)
	{
		p1 = p2 + 1;
		if ((p2 = strchr(p1, '/')) != NULL &&
			strncmp(p1, "bbs", p2 - p1) != 0 &&
			strncmp(p1, "test", p2 - p1) != 0)
		{
			strcat(server, "/");
			strncat(server, p1, p2 - p1);
		}
	}

	//path mode?
	if (!strstr(url, "read.cgi\?"))
		return split_pathmode(url);

	//bbs
	if ((p1 = strstr(url, "bbs=")) == NULL)
		if ((p1 = strstr(url, "BBS=")) == NULL)
			return false;
	p1 += 4;
	if ((p2 = strchr(p1, '&')) != NULL)
		strncpy(bbs, p1, p2 - p1);
	else
		strcpy(bbs, p1);
	
	//key
	if ((p1 = strstr(url, "key=")) == NULL)
		if ((p1 = strstr(url, "KEY=")) == NULL)
			return false;
	p1 += 4;
	if ((p2 = strchr(p1, '&')) != NULL)
		strncpy(key, p1, p2 - p1);
	else
		strcpy(key, p1);

	//ls
	if ((p1 = strstr(url, "ls=")) != NULL)
	{
		ls = atoi(p1 + 3);
	}

	//st
	if ((p1 = strstr(url, "st=")) != NULL)
	{
		st = atoi(p1 + 3);
	}

	//to
	if ((p1 = strstr(url, "to=")) != NULL)
	{
		to = atoi(p1 + 3);
	}

	//nofirst
	if (strstr(url, "nofirst=true"))
		nofirst = true;

	return true;
}

	
/*----------------------------------------------------------------------------
  GUrl::split_pathmode
----------------------------------------------------------------------------*/

bool GUrl::split_pathmode(const char* url)
{
	char* p1;
	char* p2;

	if ((p1 = strstr(url, "/read.cgi/")) == NULL)
		return false;
	p1 += 10;

	//bbs
	if ((p2 = strchr(p1, '/')) == NULL)
		return false;
	strncpy(bbs, p1, p2 - p1);
	p1 = p2 + 1;

	//key
	if ((p2 = strchr(p1, '/')) == NULL)
		return false;
	strncpy(key, p1, p2 - p1);
	p1 = p2 + 1;

	if (p1 == NULL)
		return true;

	if (*p1 == 'l')
	{
		ls = atoi(p1 + 1);
	}
	else if ((p2 = strchr(url, '-')) != NULL)
	{
		if (p1 == p2)
		{
			st = 1;
			to = atoi(p1 + 1);
		}
		else
		{
			st = atoi(p1);
			to = atoi(p2 + 1);
		}
	}
	else
	{
		st = to = atoi(p1);
	}
	return true;
}


/*----------------------------------------------------------------------------
  GUrl::make
----------------------------------------------------------------------------*/

void GUrl::make(char* url)
{
	if (type == 0)
		sprintf(url, "http://%s/test/read.cgi/%s/%s/",
		                                                  server, bbs, key);
	else
		sprintf(url, "http://%s/bbs/read.cgi?BBS=%s&KEY=%s",
								                          server, bbs, key);
}


/*****************************************************************************
  class GBase
*****************************************************************************/


/*----------------------------------------------------------------------------
  GBase::get_html
----------------------------------------------------------------------------*/

#define BUFLEN 16384
char* GBase::get_html(const char* url, size_t* buffsize)
{
    HINTERNET hInternet;
    HINTERNET hUrl;
    FILE* fp;
	DWORD len;
	DWORD asize;
    DWORD readlen;
    char* buff;
	char encode[16];

	gzFile gz_in;
	char   gz_fname[MAX_PATH];
	char   gz_buf[BUFLEN];
	bool   gz_error;

	if(!proxy_status ){
    //Win32 Internet֐̏
      hInternet = InternetOpen(AGENT, INTERNET_OPEN_TYPE_PRECONFIG,
                                                              NULL, NULL, 0);
	}else{
		if( strlen(read_proxy)){
	//ProxyΉ
		  hInternet = InternetOpen(AGENT, INTERNET_OPEN_TYPE_PROXY,
															   read_proxy,NULL,0);
		}else{
		  hInternet = InternetOpen(AGENT, INTERNET_OPEN_TYPE_PRECONFIG,
                                                              NULL, NULL, 0);
		}
	}

    if (hInternet == NULL)
    {
        return NULL;
    }

	//callback֐ݒ
	if (hwnd_callback != NULL)
	{
		if (InternetSetStatusCallback(hInternet, _inet_callback) == INTERNET_INVALID_STATUS_CALLBACK)
			OutputDebugString("ERROR: callback func\n");
    }

    //URLI[v
    hUrl = InternetOpenUrl(hInternet, url, HEADER, -1,
		                                      INTERNET_FLAG_RESYNCHRONIZE, (DWORD)this);
    if (hUrl == NULL)
    {
		InternetCloseHandle(hInternet);
        return NULL;
    }

	//Content-Encoding擾
	len = sizeof(encode);
	HttpQueryInfo(hUrl, HTTP_QUERY_CONTENT_ENCODING, encode, &len, 0);

	//HTML̎M
	InternetQueryDataAvailable(hUrl, &asize, 0, 0);
	buff = NULL;
	*buffsize = 0;
	while (asize > 0)
    {
		if (buff == NULL)
			buff = (char*)malloc(asize);
		else
			buff = (char*)realloc(buff, (*buffsize + asize));
        
        InternetReadFile(hUrl, (buff + *buffsize), asize, &readlen);
		*buffsize += asize;

    	InternetQueryDataAvailable(hUrl, &asize, 0, 0);
	}

	//URLN[Y
	InternetCloseHandle(hUrl);
    InternetCloseHandle(hInternet);

	//gzip
	if (strstr(encode, "gzip"))
	{
		//Ut@C֕ۑ
		sprintf(gz_fname, "%ld.gz", time(NULL));
		if ((fp = fopen(gz_fname, "wb")) == NULL)
		{
			free(buff);
			return NULL;
		}
		fwrite(buff, *buffsize, 1, fp);
		fclose(fp);

		//gzopen
		if ((gz_in = gzopen(gz_fname, "rb")) == NULL)
		{
			free(buff);
			remove(gz_fname);
			return NULL;
		}

		//𓀂Ɋi[
		gz_error = false;
		asize = 0; //get size

		while (!gz_error)
		{
			memset(gz_buf, 0, sizeof(gz_buf));
			readlen = gzread(gz_in, gz_buf, sizeof(gz_buf));
			if (readlen < 0) { gz_error = true; break; }
			if (readlen == 0) break;

			if (asize + readlen > *buffsize)
			{
				*buffsize = asize + readlen;
				buff = (char*)realloc(buff, *buffsize);
			}
			memcpy((buff + asize), gz_buf, readlen);
			asize += readlen;
		}

		//gzclose
		gzclose(gz_in);
		remove(gz_fname);

		if (gz_error)
		{
			free(buff);
			return NULL;
		}
	}

#ifdef _DEBUG
	sprintf(gz_fname, "%abc.html", time(NULL));
	if ((fp = fopen(gz_fname, "wb")) == NULL)
	{
		free(buff);
		return NULL;
	}
	fwrite(buff, *buffsize, 1, fp);
	fclose(fp);
#endif

    return buff;
}


/*----------------------------------------------------------------------------
  GBase::inet_callback
----------------------------------------------------------------------------*/

void GBase::inet_callback(DWORD status)
{
	switch (status)
	{
	case INTERNET_STATUS_CONNECTING_TO_SERVER:
		PostMessage(hwnd_callback, msg_callback, 0, data_callback);
		break;
	case INTERNET_STATUS_RESPONSE_RECEIVED:
		PostMessage(hwnd_callback, msg_callback, 1, data_callback);
		break;
	case INTERNET_STATUS_HANDLE_CLOSING:
		PostMessage(hwnd_callback, msg_callback, 2, data_callback);
		break;
	}
/*
	char abc[16];wsprintf(abc, "%d ", userdata);OutputDebugString(abc);
	switch (status)
	{
	case INTERNET_STATUS_CLOSING_CONNECTION:
		OutputDebugString("INTERNET_STATUS_CLOSING_CONNECTION\n");
		break;
	case INTERNET_STATUS_CONNECTED_TO_SERVER:
		OutputDebugString("INTERNET_STATUS_CONNECTED_TO_SERVER\n");
		break;
	case INTERNET_STATUS_CONNECTING_TO_SERVER:
		OutputDebugString("INTERNET_STATUS_CONNECTING_TO_SERVER\n");
		break;
	case INTERNET_STATUS_CONNECTION_CLOSED:
		OutputDebugString("INTERNET_STATUS_CONNECTION_CLOSED\n");
		break;
	case INTERNET_STATUS_HANDLE_CLOSING:
		OutputDebugString("INTERNET_STATUS_HANDLE_CLOSING\n");
		break;
	case INTERNET_STATUS_HANDLE_CREATED:
		OutputDebugString("INTERNET_STATUS_HANDLE_CREATED\n");
		break;
	case INTERNET_STATUS_INTERMEDIATE_RESPONSE:
		OutputDebugString("INTERNET_STATUS_INTERMEDIATE_RESPONSE\n");
		break;
	case INTERNET_STATUS_NAME_RESOLVED:
		OutputDebugString("INTERNET_STATUS_NAME_RESOLVED\n");
		break;
	case INTERNET_STATUS_PREFETCH:
		OutputDebugString("INTERNET_STATUS_PREFETCH\n");
		break;
	case INTERNET_STATUS_RECEIVING_RESPONSE:
		OutputDebugString("INTERNET_STATUS_RECEIVING_RESPONSE\n");
		break;
	case INTERNET_STATUS_REDIRECT:
		OutputDebugString("INTERNET_STATUS_REDIRECT\n");
		break;
	case INTERNET_STATUS_REQUEST_COMPLETE:
		OutputDebugString("INTERNET_STATUS_REQUEST_COMPLETE\n");
		break;
	case INTERNET_STATUS_REQUEST_SENT:
		OutputDebugString("INTERNET_STATUS_REQUEST_SENT\n");
		break;
	case INTERNET_STATUS_RESOLVING_NAME:
		OutputDebugString("INTERNET_STATUS_RESOLVING_NAME\n");
		break;
	case INTERNET_STATUS_RESPONSE_RECEIVED:
		OutputDebugString("INTERNET_STATUS_RESPONSE_RECEIVED\n");
		break;
	case INTERNET_STATUS_SENDING_REQUEST:
		OutputDebugString("INTERNET_STATUS_SENDING_REQUEST\n");
		break;
	case INTERNET_STATUS_STATE_CHANGE:
		OutputDebugString("INTERNET_STATUS_STATE_CHANGE\n");
		break;
	default:
		OutputDebugString("OTHER\n");
	}
*/
}


/*----------------------------------------------------------------------------
  GBase::convert_er
----------------------------------------------------------------------------*/

void GBase::convert_er(string &str)
{
	int pos;

	//̎QƂϊ
	while ((pos = str.find("&lt;")) != -1)
		str.replace(pos, 4, "<");
	while ((pos = str.find("&gt;")) != -1)
		str.replace(pos, 4, ">");
	while ((pos = str.find("&quot;")) != -1)
		str.replace(pos, 6, "\"");
	while ((pos = str.find("&amp")) != -1)
		str.replace(pos, 4, "&");
	
	//̎QƂځ[
	while ((pos = str.find("&hearts;")) != -1)
		str.erase(pos, 8);
	while ((pos = str.find("&clubs;")) != -1)
		str.erase(pos, 7);
	while ((pos = str.find("&spades;")) != -1)
		str.erase(pos, 8);
	while ((pos = str.find("&diams;")) != -1)
		str.erase(pos, 7);
}


/*****************************************************************************
  class GItaList
*****************************************************************************/

/*----------------------------------------------------------------------------
  RXgN^
----------------------------------------------------------------------------*/

GItaList::GItaList(void)
{
	strcpy(filename, "");
	strcpy(error_message, "");
}


/*----------------------------------------------------------------------------
  GItaList::get
----------------------------------------------------------------------------*/

bool GItaList::get(const char* url)
{
    ItaItem item;
	char* buff;
    char* p1;
	char* p2;
    char* token;
	size_t buffsize;

	//TCg
    if ((buff = get_html((url != NULL ? url : URL_BBSTABLE), &buffsize)) == NULL)
    {
        strcpy(error_message, "bbstable擾Ɏs");
        return false;
    }
	p1 = buff;

    if (items.size() != 0)
        items.clear();

	//擾
    while (p1 < (buff + buffsize))
    {
		//JeS
		if (strnicmp(p1, "<B>", 3) == 0)
		{
			p1 += 3;
			p2 = strchr(p1, '<');
			if (p1 == NULL || p2 == NULL)
				break;
			*p2 = '\0';
			strcpy(item.category, p1);
			p1 = p2 + 1;
			continue;
		}

		//URL
		if (*p1 == 'F' && *(p1 + 1) == '=')
		{
			p1 += 2;
			p2 = strchr(p1, '>');
			if (p2 == NULL)
				break;
			*p2 = '\0';

			if (strstr(p1, "2ch.net") == NULL &&
				strstr(p1, "bbspink.com") == NULL &&
				strstr(p1, "www.machibbs.com") == NULL)
				continue;
			if (strstr(p1, "www.2ch.net") != NULL || strstr(p1, "irc.2ch.net") != NULL)
				continue;

			//T[o
			if ((token = strtok(p1, " /")) == NULL) continue;
			if ((token = strtok(NULL, " /")) == NULL) continue;
			strcpy(item.server, token);

			//BBS or TufBNg
			if ((token = strtok(NULL, " /")) == NULL) continue;
			if (strncmp(token, "TARGET=", 7) == 0) continue;
			strcpy(item.bbs, token);

			//TufBNgT[oɘA
			if ((token = strtok(NULL, " /")) != NULL &&
				strncmp(token, "TARGET=", 7) != 0 &&
				strchr(token, '.') == NULL)
			{
				strcat(item.server, "/");
				strcat(item.server, item.bbs);
				strcpy(item.bbs, token);
			}

			//
			p1 = p2 + 1;
			p2 = strchr(p1, '<');
			if (p2 == NULL)
				break;
			*p2 = '\0';
			strcpy(item.name, p1);

			//Xgɒǉ
			(is_2ch(item.server) ? item.type = 0 : item.type = 1);
			item.param = 0;
			items.push_back(item);

			p1 = p2 + 1;
			continue;
		}

		p1++;
	}

	free(buff);

	if (items.size() == 0)
	{
        strcpy(error_message, "bbstable擾Ɏs");
        return false;
	}
	return true;
}


/*----------------------------------------------------------------------------
  GItaList::load
----------------------------------------------------------------------------*/

bool GItaList::load(void)
{
	ItaItem item;
	FILE* fp;
	char catg[MAX_CATG_NAME];
	char buff[1024];
	char sep[] = "\t\r\n";
	char* token;

	if ((fp = fopen(filename, "r")) == NULL)
	{
		sprintf(error_message, "%sI[vɎs", filename);
		return false;
	}

	if (count() > 0)
		items.clear();

	while (fgets(buff, 1024, fp) != NULL)
	{
		if ((token = strchr(buff, '\r')) != NULL)
			*token = '\0';
		if ((token = strchr(buff, '\n')) != NULL)
			*token = '\0';

		if (strspn(buff, "0123456789") == strlen(buff))
			continue;

		if (*buff != '\t')
		{
			if ((token = strtok(buff, sep)) != NULL)
				strcpy(catg, buff);
		}
		else
		{
			strcpy(item.category, catg);
			if ((token = strtok(buff, sep)) == NULL)
				continue;
			strcpy(item.server, token);
			if ((token = strtok(NULL, sep)) == NULL)
				continue;
			strcpy(item.bbs, token);
			if ((token = strtok(NULL, sep)) == NULL)
				continue;
			strcpy(item.name, token);
			if (is_2ch(item.server))
				item.type = 0;
			else
				item.type = 1;
			item.param = 0;
			items.push_back(item);
		}
	}
	fclose(fp);
	return true;
}
	

/*----------------------------------------------------------------------------
  GItaList::save
----------------------------------------------------------------------------*/

bool GItaList::save(void)
{
	FILE* fp;
	char catg[MAX_CATG_NAME];

	if ((fp = fopen(filename, "w")) == NULL)
	{
		sprintf(error_message, "%sI[vɎs", filename);
		return false;
	}

	strcpy(catg, "");
	fprintf(fp, "2\n");

	for (UINT i = 0; i < items.size(); i++)
	{
		if (strcmp(items[i].category, catg) != 0)
		{
			strcpy(catg, items[i].category);
			fprintf(fp, "%s\t0\n", catg);
		}
		fprintf(fp, "\t%s\t%s\t%s\n",items[i].server, items[i].bbs, items[i].name);
	}

	fclose(fp);
	return true;
}


/*----------------------------------------------------------------------------
  GItaList::set_filename
----------------------------------------------------------------------------*/

void GItaList::set_filename(const char* _filename)
{
	strcpy(filename, _filename);
}


/*----------------------------------------------------------------------------
  GItaList::get_no
----------------------------------------------------------------------------*/

int GItaList::get_no(const char* name)
{
	for (unsigned int i = 0; i != items.size(); i++)
		if (strcmp(items[i].name, name) == 0)
			return i;
	return -1;
}


/*----------------------------------------------------------------------------
  GItaList::get_name
----------------------------------------------------------------------------*/

const char* GItaList::get_name(int index)
{
	CHECKINDEX(index,NULL)
    return items[index].name;
}


/*----------------------------------------------------------------------------
  GItaList::get_category
----------------------------------------------------------------------------*/

const char* GItaList::get_category(int index)
{
	CHECKINDEX(index,NULL)
    return items[index].category;
}
const char* GItaList::get_category(const char* name)
{
	vector<ItaItem>::iterator it =
		find_if(items.begin(), items.end(), bind1st(pred_itamei_equal(), name));
	if (it != items.end())
	    return it->category;
	return NULL;
}


/*----------------------------------------------------------------------------
  GItaList::get_server
----------------------------------------------------------------------------*/

const char* GItaList::get_server(int index)
{
	CHECKINDEX(index,NULL)
    return items[index].server;
}
const char* GItaList::get_server(const char* name)
{
	vector<ItaItem>::iterator it =
		find_if(items.begin(), items.end(), bind1st(pred_itamei_equal(), name));
	if (it != items.end())
	    return it->server;
	return NULL;
}


/*----------------------------------------------------------------------------
  GItaList::get_bbs
----------------------------------------------------------------------------*/

const char* GItaList::get_bbs(int index)
{
	CHECKINDEX(index,NULL)
    return items[index].bbs;
}
const char* GItaList::get_bbs(const char* name)
{
	vector<ItaItem>::iterator it =
		find_if(items.begin(), items.end(), bind1st(pred_itamei_equal(), name));
	if (it != items.end())
	    return it->bbs;
	return NULL;
}


/*----------------------------------------------------------------------------
  GItaList::get_type
----------------------------------------------------------------------------*/

UCHAR GItaList::get_type(int index)
{
	CHECKINDEX(index,0)
    return items[index].type;
}
UCHAR GItaList::get_type(const char* name)
{
	vector<ItaItem>::iterator it =
		find_if(items.begin(), items.end(), bind1st(pred_itamei_equal(), name));
	if (it != items.end())
	    return it->type;
	return NULL;
}


/*----------------------------------------------------------------------------
  GItaList::get_topurl
----------------------------------------------------------------------------*/

bool GItaList::get_topurl(int index, char* url)
{
	CHECKINDEX(index,false)
    sprintf(url, "http://%s/%s/", items[index].server, items[index].bbs);
    return true;
}
bool GItaList::get_topurl(const char* name, char* url)
{
	vector<ItaItem>::iterator it =
		find_if(items.begin(), items.end(), bind1st(pred_itamei_equal(), name));
	if (it != items.end())
	{
		sprintf(url, "http://%s/%s/", it->server, it->bbs);
		return true;
	}
	return false;
}


/*----------------------------------------------------------------------------
  GItaList::count
----------------------------------------------------------------------------*/

UINT GItaList::count(void)
{
    return items.size();
}


/*----------------------------------------------------------------------------
  GItaList::set_param
----------------------------------------------------------------------------*/

bool GItaList::set_param(int index, long param)
{
	CHECKINDEX(index,false)
    items[index].param = param;
	return true;
}
bool GItaList::set_param(const char* name, long param)
{
	vector<ItaItem>::iterator it =
		find_if(items.begin(), items.end(), bind1st(pred_itamei_equal(), name));
	if (it != items.end())
	{
		it->param = param;
	    return true;
	}
	return false;
}


/*----------------------------------------------------------------------------
  GItaList::get_param
----------------------------------------------------------------------------*/

long GItaList::get_param(int index)
{
	CHECKINDEX(index,0)
    return items[index].param;
}

long GItaList::get_param(const char* name)
{
	vector<ItaItem>::iterator it =
		find_if(items.begin(), items.end(), bind1st(pred_itamei_equal(), name));
	if (it != items.end())
	    return it->param;
	return 0;
}


/*----------------------------------------------------------------------------
  GItaList::add
----------------------------------------------------------------------------*/

void GItaList::add(const char* n, const char* c, const char* s, const char* b,
				                                                       long p)
{
	ItaItem item;
	bool found;
	UINT i;

	strcpy(item.name, n);
	strcpy(item.category, c);
	strcpy(item.server, s);
	strcpy(item.bbs, b);
	if (is_2ch(s))
		item.type = 0;
	else
		item.type = 1;
	item.param = p;

	found = false;
	for (i = 0; i < items.size(); i++)
	{
		if (!found && strcmp(items[i].category, c) == 0)
		{
			found = true;
		}
		else if (found && strcmp(items[i].category, c) != 0)
		{
			items.insert(&items[i], item);
			return;
		}
	}
	items.push_back(item);
}


/*----------------------------------------------------------------------------
  GItaList::modify
----------------------------------------------------------------------------*/

bool GItaList::modify(int index, const char* n, const char* c, const char* s, const char* b)
{
	CHECKINDEX(index,false)
	strcpy(items[index].name, n);
	strcpy(items[index].category, c);
	strcpy(items[index].server, s);
	strcpy(items[index].bbs, b);
	return true;
}


/*----------------------------------------------------------------------------
  GItaList::del
----------------------------------------------------------------------------*/

bool GItaList::del(int index)
{
	CHECKINDEX(index,false)
	items.erase(&items[index]);
	return false;
}


/*----------------------------------------------------------------------------
  GItaList::clear
----------------------------------------------------------------------------*/

void GItaList::clear(void)
{
	items.clear();
}


/*----------------------------------------------------------------------------
  GItaList::get_error
----------------------------------------------------------------------------*/

const char* GItaList::get_error(void)
{
    return error_message;
}




/*****************************************************************************
  class GSureList
*****************************************************************************/


/*----------------------------------------------------------------------------
  RXgN^
----------------------------------------------------------------------------*/

GSureList::GSureList(void)
{
	strcpy(error_message, "");
}


/*----------------------------------------------------------------------------
  GSureList::get_from_subject_txt
----------------------------------------------------------------------------*/

bool GSureList::get_from_subject_txt(char* buff, size_t size, UCHAR type)
{
    Item item;
	char* p1 = buff;
	char* p2;
	char* p3;

	while (p1 < (buff + size))
	{
		if( p1[0] == '+' || p1[0] == '-' ){
			p1=strchr(p1,'\n')+1;
			continue;
		}

		if ((p2 = strchr(p1, '.')) == NULL)
			break;
		*p2 = '\0';
		strcpy(item.key, p1);

		if (type == 0)
		{
			if ((p1 = strchr(p2 + 1, '>')) == NULL)
				break;
		}
		else
		{
			if ((p1 = strchr(p2 + 1, ',')) == NULL)
				break;
		}
		p1++;
		if ((p2 = strchr(p1, '\n')) == NULL)
			break;
		*p2 = '\0';
		if ((p3 = strrchr(p1, '(')) == NULL)
			break;
		*p3 = '\0';

		item.title = p1;
		convert_er(item.title);
		item.res = atoi(p3 + 1);
		item.type = type;
		item.flag = 0;
		items.push_back(item);

		p1 = p2 + 1;
	}
	return true;
}


/*----------------------------------------------------------------------------
  GSureList::get
----------------------------------------------------------------------------*/

bool GSureList::get(const char* _s, const char* _b, const char* _f)
{
    char	url[256];
	char*	buff;
	size_t	size;
	bool	ret;
	UCHAR	type;
	UINT	i;
	bool	readcgi_ver;

    items.clear();

	(is_2ch(_s) ? type = 0 : type = 1);
	
	readcgi_ver = TRUE;
	if( strstr( _s,"machibbs"))//machibbs
		readcgi_ver=FALSE;

	//subject.txt擾
	if( readcgi_ver ){
		sprintf(url, "http://%s/test/read.cgi/%s/?raw=0.0", _s, _b);
	}else{
		sprintf(url, "http://%s/%s/subject.txt", _s, _b);
	}

    if ((buff = get_html(url, &size)) == NULL)
    {
        sprintf(error_message, "%s I[vɎs", url);
        ret = false;
    }
	else
	{
		ret = get_from_subject_txt(buff, size, type);
		free(buff);

		if (ret && items.size() == 0)
		{
			sprintf(error_message, "%s I[vɎs", url);
			ret = false;
		}

		for (i = 0; i < items.size(); i++)
		{
			strcpy(items[i].server, _s);
			strcpy(items[i].bbs, _b);
			strcpy(items[i].from, _f);
		}
	}

	return ret;
}


/*----------------------------------------------------------------------------
  GSureList::insert
----------------------------------------------------------------------------*/

void GSureList::insert(UINT i, const char* _s, const char* _b, const char* _k, const char* _t, UINT _r, UCHAR _ty, const char* _f)
{
	Item item;

	strcpy(item.server, _s);
	strcpy(item.bbs,    _b);
	strcpy(item.key,    _k);
	strcpy(item.from,   _f);
	item.title = _t;
	item.res = _r;
	item.type = _ty;
	item.flag = 0;

	items.insert(&items[i], item);
}


/*----------------------------------------------------------------------------
  GSureList::modifty
----------------------------------------------------------------------------*/

bool GSureList::modify(UINT i, const char* _t, const char* _f)
{
	CHECKINDEX(i,false);
	items[i].title = _t;
	strcpy(items[i].from, _f);
	return true;
}


/*----------------------------------------------------------------------------
  GSureList::del
----------------------------------------------------------------------------*/

bool GSureList::del(int i)
{
	CHECKINDEX(i,false);
	items.erase(&items[i]);
	return true;
}


/*----------------------------------------------------------------------------
  GSureList::get_url
----------------------------------------------------------------------------*/

bool GSureList::get_url(int i, int ls, char* url)
{
	CHECKINDEX(i,false);

	switch (items[i].type)
	{
	case 0:
		sprintf(url, "http://%s/test/read.cgi?bbs=%s&key=%s", items[i].server,
			                                                  items[i].bbs,
															  items[i].key);
		if (ls != 0)
			sprintf(url, "%s&ls=%d", url, ls);
		break;
	case 1:
		sprintf(url, "http://%s/bbs/read.cgi?BBS=%s&KEY=%s", items[i].server,
			                                                 items[i].bbs,
															 items[i].key);
		if (ls != 0)
			sprintf(url, "%s&LAST=%d", url, ls);
		break;
	case 255:
		strcpy(url, items[i].server);
		break;
	default:
		return false;
	}
    return true;
}


/*----------------------------------------------------------------------------
  GSureList::get_log_filename
----------------------------------------------------------------------------*/

bool GSureList::get_log_filename(char* logfile, const char* log_dir, int i)
{
	CHECKINDEX(i,false);
	_get_log_filename(logfile, log_dir, items[i].server, items[i].bbs, items[i].key, items[i].type);
	return true;
}


/*****************************************************************************
  class GSure
*****************************************************************************/


/*----------------------------------------------------------------------------
  RXgN^
----------------------------------------------------------------------------*/

GSure::GSure(void)
{
	type = 0;
	strcpy(server, "");
	strcpy(bbs, "");
	strcpy(key, "");
	strcpy(cgiver, "");
	strcpy(error_message, "");
}


/*----------------------------------------------------------------------------
  GSure::get_title_from_html
----------------------------------------------------------------------------*/

bool GSure::get_title_from_html(char** mp, char* title)
{
	char* p1;
	char* p2;

	strcpy(title, "");
	if (type == 0)
	{
		if ((p1 = strstr(*mp, " COLOR=red>")) == NULL)
		{
			if ((p1 = strstr(*mp, " color=red>")) == NULL)
				return false;
		}
		p1 += 11;
	}
	else
	{
		if ((p1 = strstr(*mp, " size=+1 color=")) == NULL)
			return false;
		if ((p1 = strchr(p1, '>')) == NULL)
			return false;
		p1++;
	}
	p2 = strchr(p1, '<');
	*p2 = '\0';
	strcpy(title, p1);
	p1 = p2 + 1;

	*mp = p1;
	return true;
}


/*----------------------------------------------------------------------------
  GSure::get_res_from_html
----------------------------------------------------------------------------*/

UINT GSure::get_res_from_html(char** mp, Res& re)
{
	string str;
	struct tm tm_wtime;
	char* p1 = *mp;
	char* p2;
	char* p3;
	int res_no;
	int pos;

	//<dt>
	if ((p1 = strstr(*mp, "<dt>")) == NULL)
		if ((p1 = strstr(*mp, "<DT>")) == NULL)
			return UINT_MAX;
	p1 += 4;

	//X
	p2 = strchr(p1, ' ');
	if (p2 == NULL)
		return UINT_MAX;
	*p2 = '\0';
	res_no = atoi(p1) - 1;
	p1 = p2 + 1;

	//[擾
	p1 = strchr(p1, '<') + 1;
	if (strnicmp(p1, "a href", 6) == 0)
	{
		p1 = strstr(p1, "mailto:") + 7;
		p2 = strchr(p1, '"');
		*p2 = '\0';
		re.mail = p1;
		p1 = p2 + 1;
	}
	else
	{
		re.mail = "";
	}
		
	//O擾
	p1 = strstr(p1, "<b>") + 3;
	p2 = strstr(p1, "</b>");
	if (p2 == NULL)
		return UINT_MAX;
	if ((p3 = strstr(p1, "</B>")) != NULL && p3 < p2)
		p2 = p3;
	*p2 = '\0';

	re.name = p1;
	p1 = p2 + 4;

	//gbvfushianaڑ
	if (strnicmp(p1, "</a>", 4) != 0 && strnicmp(p1, "</font>", 7) != 0)
	{
		//p1 += 3;
		p2 = strchr(p1, '<');
		if (p2 == NULL)
			return UINT_MAX;
		*p2 = '\0';
		re.name += p1;
	}
	p1 = p2 + 1;

	//e擾
	p1 = strstr(p1, "F") + 2;
	p2 = strchr(p1, '<');
	if (p2 == NULL)
		return UINT_MAX;
	*p2 = '\0';

	//ID𒊏o
	strcpy(re.id, "");
	if ((p3 = strstr(p1, "ID:")) != NULL)
	{
		strcpy(re.id, (p3 + 3));
	}
	//etime_t^ɕύX
	re.wtime = 0;
	if (strchr(p1, ':') != NULL)
	{
		memset(&tm_wtime, 0, sizeof(tm_wtime));
		p1 = strtok(p1, " /:()");
		if (strlen(p1) == 2)
			tm_wtime.tm_year = atoi(p1) + 100;
		else
			tm_wtime.tm_year = atoi(p1) - 1900;
		p1 = strtok(NULL, " /:()");
		tm_wtime.tm_mon = atoi(p1) - 1;
		p1 = strtok(NULL, " /:()");
		tm_wtime.tm_mday = atoi(p1);
		p1 = strtok(NULL, " /:()");
		if (strspn(p1, "0123456789") == 0)
			p1 = strtok(NULL, " /:()");
		tm_wtime.tm_hour = atoi(p1);
		p1 = strtok(NULL, " /:()");
		tm_wtime.tm_min = atoi(p1);
		re.wtime = mktime(&tm_wtime);
	}
	p1 = p2 + 1;

	//IP
	if (type == 1)
	{
		if ((p3 = strstr(p1, "font size=1>[ ")) == p1)
		{
			p1 = p3 + 12;
			p2 = strchr(p1, ']') + 1;
			*p2 = '\0';
			str = re.id;
			str += p1;
			while ((pos = str.find('\r')) != -1)
				str.erase(pos, 1);
			while ((pos = str.find('\n')) != -1)
				str.erase(pos, 1);
			strcpy(re.id, str.c_str());
			p1 = p2 + 1;
		}
	}

	if ((p1 = strstr(p1, "dd>")) == NULL)
		return UINT_MAX;

	p1 = p2 = p1 + 3;
		
	//e擾
	re.text.clear();
	while (true)
	{
		p2 = strchr(p2, '<');
		if (p2 == NULL)
			break;

		if (strnicmp(p2, "<br>", 4) == 0)
		{
			*p2 = '\0';
			re.text.push_back(p1);
			while ((pos = re.text[re.text.size() - 1].find('\t')) != -1)
				re.text[re.text.size() - 1].replace(pos, 1, "    ");
			p2 += 4;
			p1 = p2;
		}
		else if (strnicmp(p2, "<form", 5) == 0 || strnicmp(p2, "</dl>", 5) == 0 || strnicmp(p2, "<dt>", 4) == 0)
		{
			p1 = p2;
			break;
		}
		else
		{
			p2++;
		}
	}

	*mp = p1;
	return res_no;
}


/*----------------------------------------------------------------------------
  GSure::get_title_from_log
----------------------------------------------------------------------------*/

bool GSure::get_title_from_log(FILE* fp, char* title)
{
	char c;

	strcpy(title, "");
	while ((c = fgetc(fp)) != '\n')
	{ 
		if (c == EOF) return false;
		sprintf(title, "%s%c", title, c);
	}
	return true;
}


/*----------------------------------------------------------------------------
  GSure::get_res_from_log
----------------------------------------------------------------------------*/

UINT GSure::get_res_from_log(FILE* fp, Res& re)
{
	string str;
	char tmp[32];
	char c;
	long fpos;
	int res_no;

	fpos = ftell(fp);

	//Xԍ
	strcpy(tmp, "");
	while ((c = fgetc(fp)) != '\t')
	{ 
		if (c == EOF)
			REWINDRET(fpos, UINT_MAX)
		sprintf(tmp, "%s%c", tmp, c);
	}
	res_no = atoi(tmp);

	//O
	re.name = "";
	while ((c = fgetc(fp)) != '\t')
	{ 
		if (c == EOF)
			REWINDRET(fpos, UINT_MAX)
		re.name += c;
	}

	//[
	re.mail = "";
	while ((c = fgetc(fp)) != '\t')
	{ 
		if (c == EOF)
			REWINDRET(fpos, UINT_MAX)
		re.mail += c;
	}
		
	//e
	strcpy(tmp, "");
	while ((c = fgetc(fp)) != '\t')
	{ 
		if (c == EOF)
			REWINDRET(fpos, UINT_MAX)
		sprintf(tmp, "%s%c", tmp, c);
	}
	re.wtime = atol(tmp);

	//[
	strcpy(re.id, "");
	while ((c = fgetc(fp)) != '\t')
	{ 
		if (c == EOF)
			REWINDRET(fpos, UINT_MAX)
		sprintf(re.id, "%s%c", re.id, c);
	}

	//ݓe
	re.text.clear();
	str = "";
	while ((c = fgetc(fp)) != '\n')
	{
		if (c == EOF)
		{
			REWINDRET(fpos, UINT_MAX)
		}
		else if (c == '\t')
		{
			re.text.push_back(str);
			str = "";
		}
		else
		{
			str += c;
		}
	}
	re.text.push_back(str);

	return res_no;
}


/*----------------------------------------------------------------------------
  GSure::load_log
----------------------------------------------------------------------------*/

bool GSure::load_log(const char* log_dir)
{
	Res res1;
	Res res2;
	FILE* fp;
	char logfile[MAX_PATH];
	char buff[256];
	unsigned int no;

	//Ot@C
	_get_log_filename(logfile, log_dir, server, bbs, key, type);

	//Ot@CI[v
    if ((fp = fopen(logfile, "r")) == NULL)
	{
		sprintf(error_message, "ERROR(load): OJȂ(%s)", logfile);
        return false;
	}

	//^Cg擾
	if (!get_title_from_log(fp, buff))
	{
		sprintf(error_message, "ERROR(load): OɃ^CgȂ(%s)", logfile);
		fclose(fp);
		return false;
	}
	title = buff;

	//X擾
	res.clear();
	while ((no = get_res_from_log(fp, res1)) != UINT_MAX)
	{
		while (no > res.size())
		{
			//_~[
			res2.name = "";
			res2.mail = "";
			res2.wtime = 0;
			strcpy(res2.id, "");
			res2.text.clear();
			res.push_back(res2);
		}
		res.push_back(res1);
	}

	fclose(fp);

	return true;
}


/*----------------------------------------------------------------------------
  GSure::save_log
----------------------------------------------------------------------------*/

bool GSure::save_log(const char* log_dir)
{
	FILE* fp;
	char logfile[MAX_PATH];
	UINT i;
	UINT j;

	//Ot@C
	_get_log_filename(logfile, log_dir, server, bbs, key, type);

	//Ot@CI[v
    if ((fp = fopen(logfile, "w")) == NULL)
	{
		sprintf(error_message, "ERROR(get): OJȂ");
        return false;
	}

	//
	fprintf(fp, "%s\n", title.c_str());
	for (i = 0; i != res.size(); i++)
	{
		if (res[i].text.size() > 0)
		{
			fprintf(fp, "%d\t%s\t%s\t%ld\t%s", i,
											   res[i].name.c_str(),
					 						   res[i].mail.c_str(),
											   res[i].wtime,
											   res[i].id);
			for (j = 0; j != res[i].text.size(); j++)
			{
				fprintf(fp, "\t%s", res[i].text[j].c_str());
			}
			fprintf(fp, "\n");
		}
	}

	fclose(fp);
	return true;
}


/*----------------------------------------------------------------------------
  GSure::get
----------------------------------------------------------------------------*/

bool GSure::get(const char* url, const char* log_dir, int* st, bool offline)
{
	GUrl gurl;
	Res re1;
	Res re2;
	char _title[256];
	char url2[256];
	bool log_exist;
	bool modify;
	bool limitation;
	char* buff;
	char* p;
	size_t buffsize;
	UINT no;
	UINT i;

	*st = 0;

	//URL`FbN
	if (!gurl.split(url))
	{
		strcpy(error_message, "ERROR(get): ΉURL");
		return false;
	}

	//ݕێĂURLƓH
	if (res.size() == 0 ||
		strcmp(server, gurl.server) != 0 ||
		strcmp(bbs, gurl.bbs) != 0 ||
		strcmp(key, gurl.key) != 0)
	{
		//Ⴄꍇ͂܂Of[^擾
		strcpy(server, gurl.server);
		strcpy(bbs, gurl.bbs);
		strcpy(key, gurl.key);
		type = gurl.type;
		res.clear();
		log_exist = load_log(log_dir);
		*st = res.size();
	}
	else
	{
		log_exist = true;
	}

	//ItCwȂ炱ŏI
	if (offline)
		return true;

	//K؂URLɏC
	strcpy(url2, url);
	if (res.size() > 0)
	{
		//f[^擾ς݂Ȃ̂ɑS擾悤ƂĂꍇA
		//stōXV擾悤ɂ
		if (gurl.st == 0 && gurl.to == 0 && gurl.ls == 0)
		{
			*st = res.size() + 1;
			if (type == 0)
				sprintf(url2, "http://%s/test/read.cgi/%s/%s/%d-",
												server, bbs, key, *st);
			else
				sprintf(url2, "http://%s/bbs/read.cgi?BBS=%s&KEY=%s&START=%d",
										server, bbs, key, *st);
		}
		//st-towłꂪ擾ς݂ȂI
		else if (gurl.st != 0 && gurl.to != 0)
		{
			*st = gurl.st;
			bool exist = true;
			for (i = (gurl.st - 1); i <= (gurl.to - 1); i++)
			{
				if (i >= res.size()) { exist = false; break; }
				else if (res[i].text.size() == 0)  { exist = false; break; }
			}
			if (exist)
				return true;
		}
	}

	//HTML擾
    if ((buff = get_html(url2, &buffsize)) == NULL)
    {
		sprintf(error_message, "ERROR(get): HTML擾s");
        return false;
    }
	p = buff;

	//^Cg擾
	if (!get_title_from_html(&p, _title) && !log_exist)
	{
		sprintf(error_message, "ERROR(get): ^Cg擾s");
		return false;
	}
	if (!log_exist)
		title = _title;

	//eReiɕۑ
	modify = false;
	while ((no = get_res_from_html(&p, re1)) != UINT_MAX)
	{
		if (no < res.size())
		{
			if (res[no].text.size() == 0)
			{
				res[no].name = re1.name;
				res[no].mail = re1.mail;
				res[no].wtime = re1.wtime;
				strcpy(res[no].id, re1.id);
				res[no].text = re1.text;
				modify = true;
			}
		}
		else
		{
			while (res.size() < no)
			{
				re2.name = "";
				re2.mail = "";
				re2.wtime = 0;
				strcpy(re2.id, "");
				re2.text.clear();
				res.push_back(re2);
			}
			res.push_back(re1);
			modify = true;
		}
	}

	limitation = false;
	if (strstr(p, "CɑS") != NULL)
		limitation = true;

	//read.cgĩo[W擾
	if ((p = strstr(p, "read.cgi ver")) != NULL)
	{
		p += 12;
		strcpy(cgiver, "");
		while (*p != ' ')
		{
			sprintf(cgiver, "%s%c", cgiver, *p);
			p++;
		}
	}

	//J
	free(buff);

	//OXV
	if (modify)
	{
		save_log(log_dir);
	}
	else
	{
		*st = 0;
	}

	if (limitation)
	{
		if (type == 0)
			sprintf(url2, "http://%s/test/read.cgi/%s/%s/l100", server, bbs, key);
		else
			sprintf(url2, "http://%s/%s/bbs/read.cgi?BBS=%s&KEY=%s&LAST=100", server, bbs, key);
		get(url2, log_dir, st, offline);
	}

	return true;
}


/*----------------------------------------------------------------------------
  GSure::get_url
----------------------------------------------------------------------------*/

bool GSure::get_url(char* url)
{
	switch (type)
	{
	case 0:
		sprintf(url, "http://%s/test/read.cgi?bbs=%s&key=%s", server, bbs, key);
		break;
	case 1:
		sprintf(url, "http://%s/bbs/read.cgi?BBS=%s&KEY=%s", server, bbs, key);
		break;
	case 255:
		strcpy(url, "");
		break;
	default:
		return false;
	}
    return true;
}
