/***************************************************************************
  GickoBrowser.cpp

  Copyright (C) 2001 Hachimaki. All rights reserved.
  Licensed under the GPL(v2).
***************************************************************************/

#include "GBCommon.h"
#include <shlobj.h>
#include <process.h>
#include "GickoViewer.h"
#include "CDropTarget.h"
#include "resource.h"



/*----------------------------------------------------------------------------
  O[oϐ
----------------------------------------------------------------------------*/

//p[^
HINSTANCE instance;
CDropTarget *droptarget;
HWND hwnd_main;
HWND hwnd_lamp;
HWND hwnd_tab;
HWND hwnd_tree;
HWND hwnd_list;
HWND hwnd_dlg;
HWND hwnd_edit;
HWND hwnd_status;
FARPROC org_edit_proc;
LOGFONT lftab;
HFONT tabfont;
UINT timer_id;

HWND hwnd_find;
UINT WM_FINDSTRING;
FINDREPLACE fr;
char search_string[256];

HANDLE handle_open_url;
HANDLE handle_get_thread;
HANDLE handle_check_thread;

GItaList* italist_2ch;
GItaList* italist_etc;
GItaList* italist_fav;
GSureList* surelist_def;
GSureList* surelist_fav;
GSureList* surelist_rec;
GViewer* viewer;

LOGFONT lf_optdlg;
int lamp_width;
int tab_height;
int edit_height;
char url[256];
int psheet_ok;
int list_type;

//ݒp[^
int  tab_max_strlen;
BOOL tab_automove_ita;
BOOL tab_automove_sure;
BOOL tab_automove_check;
int  trecent_max;
int  log_save;
char log_dir[MAX_PATH];
char image_file[MAX_PATH];

BOOL proxy_status;
char write_proxy[256];
char read_proxy[256];

/*----------------------------------------------------------------------------
  ֐vg^Cv
----------------------------------------------------------------------------*/

//CEBhE
BOOL create_window(void);
LRESULT CALLBACK mainwnd_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
void mainwnd_OnCreate(void);
void mainwnd_OnDestroy(void);
void mainwnd_OnSize(UINT type, int cx, int cy);
void mainwnd_OnNotify(int id, NMHDR* pnmh);
void mainwnd_OnTabSelChange(void);
void mainwnd_OnCommand(WORD notify, WORD id, HWND hwnd);
BOOL mainwnd_OnSysCommand(int cmd);
void mainwnd_OnDrawItem(UINT id, DRAWITEMSTRUCT *lpdis);
void mainwnd_OnTimer(UINT id);
void mainwnd_OnViewerCallback(WPARAM wp, LPARAM lp);
void mainwnd_OnInetCallback(UINT message_id, LPARAM lp);

//IvV
void show_option_propsheet(int spage);
BOOL CALLBACK dlg_general_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
int CALLBACK BrowseCallbackProc(HWND hwnd, UINT msg, LPARAM lp, LPARAM data);
BOOL CALLBACK dlg_tab_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
BOOL CALLBACK dlg_style_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
void dlg_style_OnCommand(HWND hwnd, WORD nofity, WORD id, HWND hwnd_ctl);
void dlg_style_OnDrawItem(HWND hwnd, UINT id, DRAWITEMSTRUCT* lpdis);
void dlg_style_makesizebox(void);
int CALLBACK enum_font_proc1(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme, int fonttype, LPARAM lp);
int CALLBACK enum_font_proc2(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme, int fonttype, LPARAM lp);
int CALLBACK enum_font_proc3(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme, int fonttype, LPARAM lp);
BOOL CALLBACK dlg_about_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);

void create_lamp(void);
void create_edit(void);
LRESULT CALLBACK edit_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
void create_status(void);


/*----------------------------------------------------------------------------
  WinMain
----------------------------------------------------------------------------*/

int WINAPI WinMain(HINSTANCE inst, HINSTANCE pinst, LPSTR cmd, int show)
{
    MSG msg;

    if (FindWindow(CLASS_NAME, NULL) != NULL)
        return FALSE;

    instance = inst;
    if (!create_window())
        return FALSE;

    while (GetMessage(&msg, NULL, 0, 0))
    {
		if (hwnd_find != NULL && IsDialogMessage(hwnd_find, &msg))
			continue;
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}


/*----------------------------------------------------------------------------

  create_window

  CEBhẼNXo^E쐬

----------------------------------------------------------------------------*/

BOOL create_window(void)
{
    WNDCLASS wc;

    ZeroMemory(&wc, sizeof(wc));
    wc.style          = 0;
    wc.lpfnWndProc    = (WNDPROC)mainwnd_Proc;
    wc.cbClsExtra     = 0;
    wc.cbWndExtra     = 0;
    wc.hInstance      = instance;
    wc.hIcon          = LoadIcon(instance, MAKEINTRESOURCE(IDI_GICKO));
    wc.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground  = (HBRUSH)(COLOR_BTNFACE + 1);
    wc.lpszMenuName   = NULL;
    wc.lpszClassName  = CLASS_NAME;

    if(!RegisterClass(&wc))
    {
        return FALSE;
    }
    
    CreateWindowEx(
        0,
        CLASS_NAME,
        WINDOW_TITLE,
        WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        600,
        500,
        NULL,
        NULL,
        instance,
        NULL);

    if (hwnd_main == NULL)
    {
        return FALSE;
    }

    ShowWindow(hwnd_main, SW_SHOWNORMAL);
    UpdateWindow(hwnd_main);

    return TRUE;
}


/*----------------------------------------------------------------------------

  mainwnd_Proc

  CEBhEEvV[W

----------------------------------------------------------------------------*/

LRESULT CALLBACK mainwnd_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static char url[256];

    switch (msg)
    {
    case WM_CREATE:
        hwnd_main = hwnd;
        mainwnd_OnCreate();
        return 0;

	case WM_DESTROY:
        mainwnd_OnDestroy();
        PostQuitMessage(0);
        return 0;

    case WM_SIZE:
        set_control_pos();
        return 0;

	case WM_NOTIFY:
		mainwnd_OnNotify((int)wp, (NMHDR*)lp);
        return 0;

	case WM_COMMAND:
		mainwnd_OnCommand(HIWORD(wp), LOWORD(wp), (HWND)lp);
		return 0;

	case WM_CONTEXTMENU:
		if ((HWND)wp == hwnd_tab)       tab_OnContextMenu(LOWORD(lp), HIWORD(lp));
		else if ((HWND)wp == hwnd_tree) itatree_OnContextMenu(LOWORD(lp), HIWORD(lp));
		else if ((HWND)wp == hwnd_list) surelist_OnContextMenu(LOWORD(lp), HIWORD(lp));
		return 0;

	case WM_SYSCOMMAND:
		if (mainwnd_OnSysCommand(wp))
			return 0;
		break;

	case WM_DRAWITEM:
		mainwnd_OnDrawItem((UINT)wp, (DRAWITEMSTRUCT*)lp);
		return TRUE;

	case WM_TIMER:
		mainwnd_OnTimer(wp);
		return 0;

	case UM_URLSEND_START:
		strcpy(url, "");
		return 0;

	case UM_URLSEND_ADDCHAR:
		wsprintf(url, "%s%c", url, lp);
		return 0;

	case UM_URLSEND_END:
		open_tab(url, 0, NULL);
		return 0;

	case UM_VIEWER_CALLBACK:
		mainwnd_OnViewerCallback(wp, lp);
		return 0;

	case UM_INET_CALLBACK:
		mainwnd_OnInetCallback((UINT)wp, lp);
		return 0;
    
	case WM_ACTIVATE:
		if (LOWORD(wp) != WA_INACTIVE)
			if (IsWindowVisible(hwnd_tree))
				SetFocus(hwnd_tree);
			else if (IsWindowVisible(hwnd_list))
				SetFocus(hwnd_tree);
			else if (viewer != NULL && viewer->get_handle() != NULL)
				SetFocus(viewer->get_handle());
		return 0;

	default:
		if (msg == WM_FINDSTRING)
		{
			FINDREPLACE* pfr = (FINDREPLACE*)lp;
			if (pfr->Flags & FR_DIALOGTERM)
			{ 
				hwnd_find = NULL; 
			}
			else if (pfr->Flags & FR_FINDNEXT)
			{
				viewer->findstring(pfr);
			}
			return 0;
		}
    }
    return DefWindowProc(hwnd, msg, wp, lp);
}


/*----------------------------------------------------------------------------

  mainwnd_OnCreate

  WM_CREATȄ

----------------------------------------------------------------------------*/

void mainwnd_OnCreate(void)
{
	WM_FINDSTRING = RegisterWindowMessage(FINDMSGSTRING);

	//DropTarget
	if (OleInitialize(NULL) != NOERROR)
		return;
	UINT cf_idl = RegisterClipboardFormat(CFSTR_SHELLIDLIST);
	droptarget = new CDropTarget(cf_idl, hwnd_main);
	CoLockObjectExternal(droptarget, TRUE, TRUE);
	if (RegisterDragDrop(hwnd_main, droptarget) != S_OK)
		return;

	//Init objects
	italist_2ch = new GItaList();
	italist_2ch->set_filename(ITALIST_2CH_FILENAME);
	italist_etc = new GItaList();
	italist_etc->set_filename(ITALIST_ETC_FILENAME);
	italist_fav = new GItaList();
	italist_fav->set_filename(ITALIST_FAV_FILENAME);
	surelist_def = new GSureList();
	surelist_fav = new GSureList();
	surelist_rec = new GSureList();
    viewer = new GViewer();

	lamp_width = 5;
	tab_height = 0;
	tab_max_strlen = 20;
	tab_automove_ita = TRUE;
	tab_automove_sure = TRUE;
	tab_automove_check = TRUE;
	trecent_max = 50;
	log_save = 1;
	strcpy(log_dir, DEFAULT_LOG_DIR);
	strcpy(image_file, "");

	//Rg[쐬
	InitCommonControls();
	create_lamp();
	create_tab();
	create_itatree();
	create_surelist();
	create_edit();
	create_status();

	//ݒǂݍ
	load_ini();
	CreateDirectory(log_dir, NULL);

	//ǂݍ
	change_to_moduledir();
	if (!italist_2ch->load())
	{
		italist_2ch->get(NULL);
		italist_2ch->save();
	}
	italist_fav->load();
	italist_etc->load();
	load_thread();

	set_itatree_image();
	set_surelist_image();

	make_itatree();
	make_surelist(0);
	SetFocus(hwnd_tree);

	//VXej[C
    HMENU menu = GetSystemMenu(hwnd_main, FALSE);
	InsertMenu(menu, 6, MF_STRING | MF_BYPOSITION, IDM_OPTION, "IvV(&O)");
	InsertMenu(menu, 7, MF_STRING | MF_BYPOSITION, IDM_ABOUT, "o[W(&A)");
	InsertMenu(menu, 8, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);

	viewer->create(hwnd_main, ID_VIEWER, UM_VIEWER_CALLBACK);
    viewer->set_pos(0, tab_height + 1);
}


/*----------------------------------------------------------------------------

  mainwnd_OnDestroy

  WM_DESTROY̏

----------------------------------------------------------------------------*/

void mainwnd_OnDestroy(void)
{
	HANDLE h;
	WIN32_FIND_DATA wfd;
	char filename[MAX_PATH];
	bool match;
	UINT i;

	save_ini();

	if (log_save == 1)
	{
		SetCurrentDirectory(log_dir);
		if ((h =  FindFirstFile("*.*", &wfd)) != INVALID_HANDLE_VALUE)
		{
			do
			{
				match = false;
				for (i = 0; i < surelist_fav->count(); i++)
				{
					surelist_fav->get_log_filename(filename, NULL, i);
					if (strcmp(filename, wfd.cFileName) == 0)
					{
						match = true;
						break;
					}
				}
				for (i = 0; i < surelist_rec->count(); i++)
				{
					surelist_rec->get_log_filename(filename, NULL, i);
					if (strcmp(filename, wfd.cFileName) == 0)
					{
						match = true;
						break;
					}
				}
				if (!match)
				{
					DeleteFile(wfd.cFileName);
				}
			}
			while (FindNextFile(h, &wfd));
			FindClose(h);
		}
	}

	DeleteObject(tabfont);

	RevokeDragDrop(hwnd_main);
	droptarget->Release();  
	CoLockObjectExternal(droptarget, FALSE, TRUE);

	while (TabCtrl_GetItemCount(hwnd_tab) > 2)
	{
		del_tab(2);
	}

	if (italist_fav != NULL)
		delete italist_fav;
	if (italist_2ch != NULL)
		delete italist_2ch;
	if (italist_etc != NULL)
		delete italist_etc;

	if (surelist_def != NULL)
		delete surelist_def;
	if (surelist_fav != NULL)
		delete surelist_fav;
	if (surelist_rec != NULL)
		delete surelist_rec;

	if (viewer != NULL)
		delete viewer;
}


/*----------------------------------------------------------------------------

  mainwnd_OnNotify

  WM_NOTIFY̏

----------------------------------------------------------------------------*/

void mainwnd_OnNotify(int id, NMHDR* pnmh)
{
	switch (id)
	{
	//TAB
	case ID_TAB:
		switch (pnmh->code)
		{
		case TCN_SELCHANGE:
			tab_OnSelChange();
			break;
		}
		break;

	//TREE
	case ID_TREE:
		switch (pnmh->code)
		{
		case NM_DBLCLK:
		case NM_RETURN:
			open_ita();
			break;

		case TVN_KEYDOWN:
			switch (((NMTVKEYDOWN*)pnmh)->wVKey)
			{
			case 'A':
				if (GetKeyState(VK_CONTROL) & 0x8000)
					add_favorite_ita();
				break;
			case 'B':
				if (GetKeyState(VK_CONTROL) & 0x8000)
					open_ita_by_browser();
				break;
			case 'N':
				if (GetKeyState(VK_CONTROL) & 0x8000)
					show_add_ita_dlg();
				break;
			case VK_DELETE:
				del_ita();
				break;
			case VK_TAB:
				if ((GetKeyState(VK_CONTROL) & 0x8000) && !(GetKeyState(VK_SHIFT) & 0x8000))
					select_next_tab();
				else if ((GetKeyState(VK_CONTROL) & 0x8000) && (GetKeyState(VK_SHIFT) & 0x8000))
					select_prev_tab();
				break;
			}
			break;
		}
		break;

	//LIST
	case ID_LIST:
		switch (pnmh->code)
		{
        case LVN_COLUMNCLICK:
			surelist_OnColumnClick(((NMLISTVIEW*)pnmh)->iSubItem);
            break;

		case NM_DBLCLK:
		case NM_RETURN:
			open_sure();
			break;

		case LVN_KEYDOWN:
			switch (((NMLVKEYDOWN*)pnmh)->wVKey)
			{
			case 'A':
				if (GetKeyState(VK_CONTROL) & 0x8000)
					add_favorite_sure();
				break;
			case 'B':
				if (GetKeyState(VK_CONTROL) & 0x8000)
					open_sure_by_browser();
				break;
			case 'F':
				if (GetKeyState(VK_CONTROL) & 0x8000)
					SetFocus(hwnd_edit);
				break;
			case 'R':
				if (GetKeyState(VK_CONTROL) & 0x8000)
					open_ita();
				break;
			case VK_DELETE:
				del_favorite_sure();
				break;
			case VK_TAB:
				if (!(GetKeyState(VK_CONTROL) & 0x8000) && !(GetKeyState(VK_SHIFT) & 0x8000))
					SetFocus(hwnd_edit);
				if ((GetKeyState(VK_CONTROL) & 0x8000) && !(GetKeyState(VK_SHIFT) & 0x8000))
					select_next_tab();
				else if ((GetKeyState(VK_CONTROL) & 0x8000) && (GetKeyState(VK_SHIFT) & 0x8000))
					select_prev_tab();
				break;
			case VK_RIGHT:
				if (GetKeyState(VK_CONTROL) & 0x8000)
					make_surelist(-1);
				break;
			case VK_LEFT:
				if (GetKeyState(VK_CONTROL) & 0x8000)
					make_surelist(-2);
				break;
			}
			break;
		}
		break;
	}
}


/*----------------------------------------------------------------------------

  mainwnd_OnCommand

  WM_COMMAND̏

----------------------------------------------------------------------------*/

void mainwnd_OnCommand(WORD notify, WORD id, HWND hwnd)
{
	switch (id)
	{
	//X^uύX
	case IDM_TTAB_DEFAULT:
		select_tab(1);
		make_surelist(0);
		break;
	case IDM_TTAB_FAVORITE:
		select_tab(1);
		make_surelist(1);
		break;
	case IDM_TTAB_RECENT:
		select_tab(1);
		make_surelist(2);
		break;

	//c[
	case IDM_ADD_FAVORITE_ITA:
		add_favorite_ita();
		break;
	case IDM_DEL_ITA:
		del_ita();
		break;
	case IDM_OPEN_ITA_BY_BROWSER:
		open_ita_by_browser();
		break;
	case IDM_ADD_ITA:
		show_add_ita_dlg();
		break;
	case IDM_ITA_PROPERTY:
		show_ita_property();
		break;

	//XXg
	case IDM_ADD_FAVORITE_SURE:
		add_favorite_sure();
		break;
	case IDM_DEL_FAVORITE_SURE:
		del_favorite_sure();
		break;
	case IDM_OPEN_SURE_BY_BROWSER:
		open_sure_by_browser();
		break;
	case IDM_RELOAD:
		open_ita();
		break;
	case IDM_CHECK_SURE:
		check_sure(false);
		break;
	case IDM_CHECK_ALL_SURE:
		check_sure(true);
		break;
	case IDM_IMPORT_DAT:
		import_dat();
		break;
	case IDM_EXPORT_DAT:
		export_dat();
		break;
	case IDM_SURE_PROPERTY:
		show_sure_property();
		break;
	}
}


/*----------------------------------------------------------------------------

  mainwnd_OnSysCommand

  WM_SYSCOMMAND̏

----------------------------------------------------------------------------*/

BOOL mainwnd_OnSysCommand(int cmd)
{
    switch (cmd)
	{
	case IDM_OPTION:
        show_option_propsheet(0);
		if (psheet_ok)
			save_ini();
		break;
	case IDM_ABOUT:
		DialogBox(instance, MAKEINTRESOURCE(IDD_ABOUT),
			                                      hwnd_main, dlg_about_proc);
		break;
	default:
		return FALSE;
    }
	return TRUE;
}


/*----------------------------------------------------------------------------

  mainwnd_OnDrawItem

  WM_DRAWITEM̏

----------------------------------------------------------------------------*/

void mainwnd_OnDrawItem(UINT id, DRAWITEMSTRUCT *lpdis)
{
	COLORREF c;
	HBRUSH hbr;

	if (id == ID_LAMP)
	{
		c = (COLORREF)GetWindowLong(lpdis->hwndItem, GWL_USERDATA);
		DrawEdge(lpdis->hDC, &lpdis->rcItem, EDGE_SUNKEN, BF_RECT);
		hbr = CreateSolidBrush(c);
		FillRect(lpdis->hDC, &lpdis->rcItem, hbr);
		DeleteObject(hbr);
	}
}


/*----------------------------------------------------------------------------

  mainwnd_OnTimer

  WM_TIMEȐ

----------------------------------------------------------------------------*/

void mainwnd_OnTimer(UINT id)
{
	COLORREF c;

	switch (id)
	{
	case IDT_LAMPBLINK:
		if (handle_open_url == NULL && handle_get_thread == NULL && handle_check_thread == NULL)
		{
			c = GetSysColor(COLOR_3DFACE);
			KillTimer(hwnd_main, id);
			timer_id = 0;
		}
		else
		{
			c = (COLORREF)GetWindowLong(hwnd_lamp, GWL_USERDATA);
			if (c == GetSysColor(COLOR_3DFACE))
				c = RGB(0x00, 0xFF, 0x00);
			else
				c = GetSysColor(COLOR_3DFACE);
		}
		SetWindowLong(hwnd_lamp, GWL_USERDATA, c);
		InvalidateRect(hwnd_lamp, NULL, FALSE);
		break;
	}
}


/*----------------------------------------------------------------------------

  mainwnd_OnViewerCallback

  UM_VIEWER_CALLBACK̏

----------------------------------------------------------------------------*/

void mainwnd_OnViewerCallback(WPARAM wp, LPARAM lp)
{
	char cmdline[256];

	switch (wp)
	{
	//KEYDOWN
	case GVIEWER_CALLBACK_KEYDOWN:
		if (lp == VK_TAB && (GetKeyState(VK_CONTROL) & 0x8000))
		{
			if (!(GetKeyState(VK_SHIFT) & 0x8000))
				select_next_tab();
			else
				select_prev_tab();
		}
		else if (lp == 'W' && (GetKeyState(VK_CONTROL) & 0x8000))
		{
			del_tab(TabCtrl_GetCurSel(hwnd_tab));
		}
		break;

	case GVIEWER_CALLBACK_VSCROLL:
		(get_tab_param(TabCtrl_GetCurSel(hwnd_tab)))->top_line = lp;
		break;

	//ADDFAVORITE
	case GVIEWER_CALLBACK_ADDFAVORITE:
		if (viewer->get_type() != 255)
		{
			surelist_fav->insert(
				surelist_fav->count(),
				viewer->get_server(),
				viewer->get_bbs(),
				viewer->get_key(),
				viewer->get_title(),
				0,
				viewer->get_type(),
				"");
			save_thread();
			if (list_type == 1)
				make_surelist(1);
		}
		break;

	case GVIEWER_CALLBACK_OPENBYBROWSER:
		strcpy(cmdline, "exec.exe ");
		viewer->get_url(cmdline + 9);
		WinExec(cmdline, SW_SHOWNORMAL);
		break;

	case GVIEWER_CALLBACK_ONHYPERLINK:
		SendMessage(hwnd_status, SB_SETTEXT, 255 | 0, lp);
		break;

	case GVIEWER_CALLBACK_CLICKHYPERLINK:
		open_tab((char*)lp, 0, NULL);
		break;

	case GVIEWER_CALLBACK_POSTMESSAGE:
		save_ini();
		open_tab((char*)lp, 0, NULL);
		break;

	case GVIEWER_CALLBACK_OPENFIND:
		if (hwnd_find == NULL)
		{
			memset(&fr, 0, sizeof(FINDREPLACE));
			fr.lStructSize = sizeof(FINDREPLACE);
			fr.hwndOwner = hwnd_main;
			fr.hInstance = instance;
			fr.lpstrFindWhat = search_string;
			fr.wFindWhatLen = sizeof(search_string);
			fr.Flags = FR_HIDEMATCHCASE | FR_HIDEWHOLEWORD | FR_DOWN;
			hwnd_find = FindText(&fr);
		}
		break;
	}
}


/*----------------------------------------------------------------------------

  mainwnd_OnInetCallback

  UM_INET_CALLBACK̏

----------------------------------------------------------------------------*/

void mainwnd_OnInetCallback(UINT message_id, LPARAM lp)
{
	tab_OnInetCallback(message_id, lp);
}


/*----------------------------------------------------------------------------
  show_option_propsheet
----------------------------------------------------------------------------*/

void show_option_propsheet(int spage)
{
    PROPSHEETPAGE psp[3];
    PROPSHEETHEADER psh;

    psp[0].dwSize = sizeof(PROPSHEETPAGE);
    psp[0].dwFlags = PSP_USETITLE;
    psp[0].hInstance = instance;
    psp[0].pszTemplate = MAKEINTRESOURCE(IDD_OPTION_GENERAL);
    psp[0].pszIcon = NULL;
    psp[0].pfnDlgProc = dlg_general_Proc;
    psp[0].pszTitle = "S";
    psp[0].lParam = 0;
    psp[0].pfnCallback = NULL;

    psp[1].dwSize = sizeof(PROPSHEETPAGE);
    psp[1].dwFlags = PSP_USETITLE;
    psp[1].hInstance = instance;
    psp[1].pszTemplate = MAKEINTRESOURCE(IDD_OPTION_TAB);
    psp[1].pszIcon = NULL;
    psp[1].pfnDlgProc = dlg_tab_Proc;
    psp[1].pszTitle = "^u";
    psp[1].lParam = 0;
    psp[1].pfnCallback = NULL;

    psp[2].dwSize = sizeof(PROPSHEETPAGE);
    psp[2].dwFlags = PSP_USETITLE;
    psp[2].hInstance = instance;
    psp[2].pszTemplate = MAKEINTRESOURCE(IDD_OPTION_STYLE);
    psp[2].pszIcon = NULL;
    psp[2].pfnDlgProc = dlg_style_Proc;
    psp[2].pszTitle = "\";
    psp[2].lParam = 0;
    psp[2].pfnCallback = NULL;

    psh.dwSize = sizeof(PROPSHEETHEADER);
    psh.dwFlags = PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE;
    psh.hwndParent = hwnd_main;
    psh.hInstance = instance;
    psh.pszIcon = NULL;
    psh.pszCaption = "IvV";
    psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
    psh.nStartPage = spage;
    psh.ppsp = (LPCPROPSHEETPAGE)&psp;
    psh.pfnCallback = NULL;

    PropertySheet(&psh);
}


/*----------------------------------------------------------------------------
  dlg_general_Proc
----------------------------------------------------------------------------*/

BOOL CALLBACK dlg_general_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    OPENFILENAME ofn;
    char* _log_save[] = {"ׂ", "Cɓƍŋߓǂ񂾃X"};
	static char log_dir_bk[MAX_PATH];
	static char _log_dir[MAX_PATH];
	char _image_file[MAX_PATH];
	char tmp[10];
	int i;

	switch (msg)
	{
	case WM_INITDIALOG:
		for (i = 0; i < 2; i++)
			ComboBox_AddString(GetDlgItem(hwnd, IDC_LOG_SAVE), _log_save[i]);
		ComboBox_SetCurSel(GetDlgItem(hwnd, IDC_LOG_SAVE), log_save);
		
		Edit_SetText(GetDlgItem(hwnd, IDC_LOG_DIR), log_dir);
		strcpy(log_dir_bk, log_dir);

		wsprintf(tmp, "%d", trecent_max);
		Edit_SetText(GetDlgItem(hwnd, IDC_TRECENT_MAX), tmp);
		SendDlgItemMessage(hwnd, IDC_SPIN2, UDM_SETRANGE, 0, MAKELONG(50, 5));

		Button_SetCheck(GetDlgItem(hwnd, IDC_CUSTOM_ICON), (strlen(image_file) == 0 ? FALSE : TRUE));
		Edit_SetText(GetDlgItem(hwnd, IDC_IMAGE_FILE), image_file);
		SendMessage(hwnd, WM_COMMAND, MAKELPARAM(IDC_CUSTOM_ICON, 0), 0);

		set_window_pos_best(GetParent(hwnd));

		Button_SetCheck(GetDlgItem(hwnd, IDC_PROXY_CHK), (proxy_status? TRUE : FALSE));
		if( strlen(write_proxy)>0){
			Edit_SetText(GetDlgItem(hwnd, IDC_PROXY_W ),write_proxy);
		}
		if( strlen(read_proxy)>0){
			Edit_SetText(GetDlgItem(hwnd, IDC_PROXY_R ),read_proxy);
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wp))
		{
		case IDC_LOG_DIR_REF:
			BROWSEINFO  bi;
			LPITEMIDLIST idl;

			Edit_GetText(GetDlgItem(hwnd, IDC_LOG_DIR), _log_dir, MAX_PATH);
			if (!strchr(_log_dir, '\\'))
			{
				GetCurrentDirectory(MAX_PATH, _log_dir);
				strcat(_log_dir, "\\");
				Edit_GetText(GetDlgItem(hwnd, IDC_LOG_DIR), _log_dir + strlen(_log_dir), MAX_PATH);
			}
			bi.hwndOwner = hwnd;
			bi.pidlRoot = NULL;
			bi.pszDisplayName = _log_dir;
			bi.lpszTitle = "LbVۑfBNg̎w";
			bi.ulFlags = BIF_RETURNONLYFSDIRS; 
			bi.lpfn = BrowseCallbackProc;
			bi.lParam = (LPARAM)_log_dir;
			bi.iImage = 0;
			idl = SHBrowseForFolder(&bi);
			if (idl != NULL)
			{
				SHGetPathFromIDList(idl, _log_dir);
				CoTaskMemFree(idl);
				Edit_SetText(GetDlgItem(hwnd, IDC_LOG_DIR), _log_dir);
			}
			break;

		case IDC_CUSTOM_ICON:
			if (Button_GetCheck(GetDlgItem(hwnd, IDC_CUSTOM_ICON)))
			{
				EnableWindow(GetDlgItem(hwnd, IDC_IMAGE_FILE), TRUE);
				EnableWindow(GetDlgItem(hwnd, IDC_IMAGE_FILE_REF), TRUE);
			}
			else
			{
				EnableWindow(GetDlgItem(hwnd, IDC_IMAGE_FILE), FALSE);
				EnableWindow(GetDlgItem(hwnd, IDC_IMAGE_FILE_REF), FALSE);
				Edit_SetText(GetDlgItem(hwnd, IDC_IMAGE_FILE), "");
			}
			break;

		case IDC_IMAGE_FILE_REF:
			Edit_GetText(GetDlgItem(hwnd, IDC_IMAGE_FILE), _image_file, MAX_PATH);
			if (strlen(_image_file) == 0)
			{
				change_to_moduledir();
				GetCurrentDirectory(MAX_PATH, _image_file);
				strcat(_image_file, "\\*.bmp");
			}
			memset(&ofn, 0, sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hwnd_list;
			ofn.lpstrFilter = "rbg}bv (*.bmp)\0*.bmp\0ׂẴt@C (*.*)\0*.*\0\0";
			ofn.lpstrFile = _image_file;
			ofn.nMaxFile = MAX_PATH;
			ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			ofn.lpstrDefExt = "bmp";
			ofn.lpstrFileTitle = NULL;
			ofn.lpstrTitle = "JX^C[Wt@C̎w";
			if (GetOpenFileName(&ofn))
			{
				Edit_SetText(GetDlgItem(hwnd, IDC_IMAGE_FILE), _image_file);
			}
			break;

		case IDC_ITARELOAD:
			if (italist_2ch->get(NULL))
			{
				change_to_moduledir();
				italist_2ch->save();
				MessageBox(
					hwnd,
					"擾ɐ܂",
					"",
					MB_ICONINFORMATION | MB_OK);
			}
			else
			{
				MessageBox(
					hwnd,
					italist_2ch->get_error(),
					"s",
					MB_ICONWARNING | MB_OK);
			}
			break;
		}
		case IDC_PROXY_CHK:
			if( IsDlgButtonChecked(hwnd, IDC_PROXY_CHK) == BST_CHECKED){
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_WS),TRUE);
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_RS),TRUE);
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_W),TRUE);
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_R),TRUE);
			}else{
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_WS),FALSE);
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_RS),FALSE);
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_W),FALSE);
				EnableWindow(GetDlgItem(hwnd,IDC_PROXY_R),FALSE);
			}
		break;

    case WM_NOTIFY:
        switch (((NMHDR *)lp)->code)
        {
        case PSN_APPLY:

			log_save = ComboBox_GetCurSel(GetDlgItem(hwnd, IDC_LOG_SAVE));

            Edit_GetText(GetDlgItem(hwnd, IDC_TRECENT_MAX), tmp, 10);
            trecent_max = atoi(tmp);
            if (trecent_max < 5)
                trecent_max = 5;
            else if (trecent_max > 50)
                trecent_max = 50;

			Edit_GetText(GetDlgItem(hwnd, IDC_LOG_DIR), log_dir, MAX_PATH);
			if (strcmp(log_dir, log_dir_bk) != 0)
			{
				if (MessageBox(
					hwnd,
					"VLbVfBNgɊ̃LbVڂ܂H",
					"LbV̈ړ",
					MB_YESNO) == IDYES)
				{
					HANDLE h;
					WIN32_FIND_DATA wfd;
					char newfile[MAX_PATH];

					change_to_moduledir();
					SetCurrentDirectory(log_dir_bk);

					if ((h =  FindFirstFile("*.*", &wfd)) != INVALID_HANDLE_VALUE)
					{
						do
						{
							wsprintf(newfile, "%s\\%s", log_dir, wfd.cFileName);
							MoveFile(wfd.cFileName, newfile);
						}
						while (FindNextFile(h, &wfd));
						FindClose(h);
					}
					change_to_moduledir();
				}
			}
			Edit_GetText(GetDlgItem(hwnd, IDC_IMAGE_FILE), image_file, MAX_PATH);
			if( IsDlgButtonChecked(hwnd, IDC_PROXY_CHK) == BST_CHECKED){
				proxy_status = TRUE;
				if( Edit_GetTextLength(GetDlgItem(hwnd, IDC_PROXY_W))>0){
					Edit_GetText(GetDlgItem(hwnd, IDC_PROXY_W),write_proxy,256);
				}else{
					strcpy(write_proxy,"");
				}
				if( Edit_GetTextLength(GetDlgItem(hwnd, IDC_PROXY_R))>0){
					Edit_GetText(GetDlgItem(hwnd, IDC_PROXY_R),read_proxy,256);
				}else{
					strcpy(read_proxy,"");
				}
			}else{
				proxy_status = FALSE;
				strcpy( write_proxy,"");
				strcpy( read_proxy,"");
			}
				
            psheet_ok = true;
            break;
        case PSN_RESET:
            psheet_ok = false;
            break;
        }
        break;

    default:
        return FALSE;
    }
    return TRUE;
}


/*----------------------------------------------------------------------------
  BrowseCallbackProc
----------------------------------------------------------------------------*/

int CALLBACK BrowseCallbackProc(HWND hwnd, UINT msg, LPARAM lp, LPARAM data)
{
    if (msg == BFFM_INITIALIZED)
	{
        SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, data);
    }
    return 0;
}


/*----------------------------------------------------------------------------
  dlg_tab_Proc
----------------------------------------------------------------------------*/

BOOL CALLBACK dlg_tab_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	char tmp[10];

	switch (msg)
	{
	case WM_INITDIALOG:
		wsprintf(tmp, "%d", tab_max_strlen);
		Edit_SetText(GetDlgItem(hwnd, IDC_TAB_MAX_STRLEN), tmp);
		SendDlgItemMessage(hwnd, IDC_SPIN1, UDM_SETRANGE, 0, MAKELONG(100, 10));
		Button_SetCheck(GetDlgItem(hwnd, IDC_AUTOMOVE_ITA),   tab_automove_ita);
		Button_SetCheck(GetDlgItem(hwnd, IDC_AUTOMOVE_SURE),  tab_automove_sure);
		Button_SetCheck(GetDlgItem(hwnd, IDC_AUTOMOVE_CHECK), tab_automove_check);
		break;
    case WM_NOTIFY:
        switch (((NMHDR *)lp)->code)
        {
        case PSN_APPLY:
            Edit_GetText(GetDlgItem(hwnd, IDC_TAB_MAX_STRLEN), tmp, 10);
            tab_max_strlen = atoi(tmp);
            if (tab_max_strlen < 10)
                tab_max_strlen = 10;
            else if (tab_max_strlen > 100)
                tab_max_strlen = 100;
			tab_automove_ita   = Button_GetCheck(GetDlgItem(hwnd, IDC_AUTOMOVE_ITA));
			tab_automove_sure  = Button_GetCheck(GetDlgItem(hwnd, IDC_AUTOMOVE_SURE));
			tab_automove_check = Button_GetCheck(GetDlgItem(hwnd, IDC_AUTOMOVE_CHECK));
            psheet_ok = true;
            break;
        case PSN_RESET:
            psheet_ok = false;
            break;
        }
        break;

    default:
        return FALSE;
    }
    return TRUE;
}


/*----------------------------------------------------------------------------
  dlg_style_Proc
----------------------------------------------------------------------------*/

BOOL CALLBACK dlg_style_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static HFONT font_bo;
	static HFONT font_it;
	static HFONT font_ul;
	HFONT hfont;
	LOGFONT lf;
	HDC hdc;

	switch (msg)
	{
	case WM_INITDIALOG:
		hwnd_dlg = hwnd;
		hfont = (HFONT)SendDlgItemMessage(hwnd, IDC_BO1, WM_GETFONT, 0, 0);

		//BOLD{^̃tHgύX
		GetObject(hfont, sizeof(LOGFONT), (LPVOID)&lf);
		lf.lfWeight = FW_BOLD;
		font_bo = CreateFontIndirect(&lf);
		SendDlgItemMessage(hwnd, IDC_BO1, WM_SETFONT, (WPARAM)font_bo, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_BO2, WM_SETFONT, (WPARAM)font_bo, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_BO3, WM_SETFONT, (WPARAM)font_bo, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_BO4, WM_SETFONT, (WPARAM)font_bo, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_BO5, WM_SETFONT, (WPARAM)font_bo, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_BO6, WM_SETFONT, (WPARAM)font_bo, MAKELPARAM(TRUE, 0));
		//Italic{^̃tHgύX
		GetObject(hfont, sizeof(LOGFONT), (LPVOID)&lf);
		lf.lfWeight = FW_BOLD;
		lf.lfItalic = TRUE;
		font_it = CreateFontIndirect(&lf);
		SendDlgItemMessage(hwnd, IDC_IT1, WM_SETFONT, (WPARAM)font_it, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_IT2, WM_SETFONT, (WPARAM)font_it, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_IT3, WM_SETFONT, (WPARAM)font_it, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_IT4, WM_SETFONT, (WPARAM)font_it, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_IT5, WM_SETFONT, (WPARAM)font_it, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_IT6, WM_SETFONT, (WPARAM)font_it, MAKELPARAM(TRUE, 0));
		//Underline{^̃tHgύX
		GetObject(hfont, sizeof(LOGFONT), (LPVOID)&lf);
		lf.lfWeight = FW_BOLD;
		lf.lfUnderline = TRUE;
		font_ul = CreateFontIndirect(&lf);
		SendDlgItemMessage(hwnd, IDC_UL1, WM_SETFONT, (WPARAM)font_ul, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_UL2, WM_SETFONT, (WPARAM)font_ul, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_UL3, WM_SETFONT, (WPARAM)font_ul, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_UL4, WM_SETFONT, (WPARAM)font_ul, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_UL5, WM_SETFONT, (WPARAM)font_ul, MAKELPARAM(TRUE, 0));
		SendDlgItemMessage(hwnd, IDC_UL6, WM_SETFONT, (WPARAM)font_ul, MAKELPARAM(TRUE, 0));

		//`FbN{bNX
		CheckDlgButton(hwnd, IDC_BO1, viewer->body_bo);
		CheckDlgButton(hwnd, IDC_IT1, viewer->body_it);
		CheckDlgButton(hwnd, IDC_UL1, viewer->body_ul);

		CheckDlgButton(hwnd, IDC_BO2, viewer->link_bo);
		CheckDlgButton(hwnd, IDC_IT2, viewer->link_it);
		CheckDlgButton(hwnd, IDC_UL2, viewer->link_ul);

		//CheckDlgButton(hwnd, IDC_ON3, viewer->numb_on);
		CheckDlgButton(hwnd, IDC_BO3, viewer->numb_bo);
		CheckDlgButton(hwnd, IDC_IT3, viewer->numb_it);
		CheckDlgButton(hwnd, IDC_UL3, viewer->numb_ul);

		CheckDlgButton(hwnd, IDC_ON4, viewer->name_on);
		CheckDlgButton(hwnd, IDC_BO4, viewer->name_bo);
		CheckDlgButton(hwnd, IDC_IT4, viewer->name_it);
		CheckDlgButton(hwnd, IDC_UL4, viewer->name_ul);

		CheckDlgButton(hwnd, IDC_ON5, viewer->date_on);
		CheckDlgButton(hwnd, IDC_BO5, viewer->date_bo);
		CheckDlgButton(hwnd, IDC_IT5, viewer->date_it);
		CheckDlgButton(hwnd, IDC_UL5, viewer->date_ul);

		CheckDlgButton(hwnd, IDC_ON6, viewer->idid_on);
		CheckDlgButton(hwnd, IDC_BO6, viewer->idid_bo);
		CheckDlgButton(hwnd, IDC_IT6, viewer->idid_it);
		CheckDlgButton(hwnd, IDC_UL6, viewer->idid_ul);

		CheckDlgButton(hwnd, IDC_MAILOUT, viewer->mailout);

		//F{^RGBl֘At
		SetWindowLong(GetDlgItem(hwnd, IDC_COL1), GWL_USERDATA, viewer->body_cl);
		SetWindowLong(GetDlgItem(hwnd, IDC_COL2), GWL_USERDATA, viewer->link_cl);
		SetWindowLong(GetDlgItem(hwnd, IDC_COL3), GWL_USERDATA, viewer->numb_cl);
		SetWindowLong(GetDlgItem(hwnd, IDC_COL4), GWL_USERDATA, viewer->name_cl);
		SetWindowLong(GetDlgItem(hwnd, IDC_COL5), GWL_USERDATA, viewer->date_cl);
		SetWindowLong(GetDlgItem(hwnd, IDC_COL6), GWL_USERDATA, viewer->idid_cl);
		SetWindowLong(GetDlgItem(hwnd, IDC_COLB), GWL_USERDATA, viewer->back_cl);

		//tHgXg
		memcpy(&lf_optdlg, &viewer->font, sizeof(LOGFONT));
		hdc = GetDC(viewer->get_handle());
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = 128;
		EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)enum_font_proc1, 0, 0);
		ReleaseDC(viewer->get_handle(), hdc);

		//݂̃tHgI
		SendDlgItemMessage(hwnd, IDC_FACENAME, CB_SELECTSTRING, 0, (LPARAM)lf_optdlg.lfFaceName);
		dlg_style_makesizebox();
		break;

	case WM_DRAWITEM:
		dlg_style_OnDrawItem(hwnd, wp, (DRAWITEMSTRUCT*)lp);
		break;

	case WM_COMMAND:
		dlg_style_OnCommand(hwnd, HIWORD(wp), LOWORD(wp), (HWND)lp);
		break;

    case WM_NOTIFY:
        switch (((NMHDR *)lp)->code)
        {
        case PSN_APPLY:
			DeleteObject(font_bo);
			DeleteObject(font_it);
			DeleteObject(font_ul);
			viewer->set_font(&lf_optdlg);
			viewer->set_body_flag(
				IsDlgButtonChecked(hwnd_dlg, IDC_BO1),
				IsDlgButtonChecked(hwnd_dlg, IDC_IT1),
				IsDlgButtonChecked(hwnd_dlg, IDC_UL1));
			viewer->set_link_flag(
				IsDlgButtonChecked(hwnd_dlg, IDC_BO2),
				IsDlgButtonChecked(hwnd_dlg, IDC_IT2),
				IsDlgButtonChecked(hwnd_dlg, IDC_UL2));
			viewer->set_numb_flag(
				true,//IsDlgButtonChecked(hwnd_dlg, IDC_ON3),
				IsDlgButtonChecked(hwnd_dlg, IDC_BO3),
				IsDlgButtonChecked(hwnd_dlg, IDC_IT3),
				IsDlgButtonChecked(hwnd_dlg, IDC_UL3));
			viewer->set_name_flag(
				IsDlgButtonChecked(hwnd_dlg, IDC_ON4),
				IsDlgButtonChecked(hwnd_dlg, IDC_BO4),
				IsDlgButtonChecked(hwnd_dlg, IDC_IT4),
				IsDlgButtonChecked(hwnd_dlg, IDC_UL4));
			viewer->set_date_flag(
				IsDlgButtonChecked(hwnd_dlg, IDC_ON5),
				IsDlgButtonChecked(hwnd_dlg, IDC_BO5),
				IsDlgButtonChecked(hwnd_dlg, IDC_IT5),
				IsDlgButtonChecked(hwnd_dlg, IDC_UL5));
			viewer->set_idid_flag(
				IsDlgButtonChecked(hwnd_dlg, IDC_ON6),
				IsDlgButtonChecked(hwnd_dlg, IDC_BO6),
				IsDlgButtonChecked(hwnd_dlg, IDC_IT6),
				IsDlgButtonChecked(hwnd_dlg, IDC_UL6));
			viewer->mailout = (IsDlgButtonChecked(hwnd_dlg, IDC_MAILOUT) ? true : false);
			viewer->set_color(
				GetWindowLong(GetDlgItem(hwnd, IDC_COL1), GWL_USERDATA),
				GetWindowLong(GetDlgItem(hwnd, IDC_COL2), GWL_USERDATA),
				GetWindowLong(GetDlgItem(hwnd, IDC_COL3), GWL_USERDATA),
				GetWindowLong(GetDlgItem(hwnd, IDC_COL4), GWL_USERDATA),
				GetWindowLong(GetDlgItem(hwnd, IDC_COL5), GWL_USERDATA),
				GetWindowLong(GetDlgItem(hwnd, IDC_COL6), GWL_USERDATA),
				GetWindowLong(GetDlgItem(hwnd, IDC_COLB), GWL_USERDATA));
            psheet_ok = true;
            break;
        case PSN_RESET:
            psheet_ok = false;
            break;
        }
        break;

	default:
		return FALSE;
	}
	return TRUE;
}


/*----------------------------------------------------------------------------
  dlg_style_OnCommand
----------------------------------------------------------------------------*/

void dlg_style_OnCommand(HWND hwnd, WORD nofity, WORD id, HWND hwnd_ctl)
{
    static DWORD dwCustColors[16];
	CHOOSECOLOR cc;
	LOGFONT lf;
	HDC hdc;
	int lpy;

	switch (id)
	{
	//tHgI
	case IDC_FACENAME:
	case IDC_FONTSIZE:
		if (nofity == CBN_SELENDOK)
		{
			if (id == IDC_FACENAME)
				dlg_style_makesizebox();

			hdc = GetDC(viewer->get_handle());
			memset(&lf, 0, sizeof(LOGFONT));
			lf.lfCharSet = 128;
			lpy = GetDeviceCaps(hdc, LOGPIXELSY);
			EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)enum_font_proc3, lpy, 0);
			ReleaseDC(viewer->get_handle(), hdc);

			InvalidateRect(hwnd, NULL, TRUE);
		}
		break;

	//FI
	case IDC_COL1:
	case IDC_COL2:
	case IDC_COL3:
	case IDC_COL4:
	case IDC_COL5:
	case IDC_COL6:
	case IDC_COLB:
		ZeroMemory(&cc, sizeof(CHOOSECOLOR));
		cc.lStructSize = sizeof(CHOOSECOLOR);
		cc.hwndOwner = hwnd;
		cc.lpCustColors = dwCustColors;
		cc.rgbResult = GetWindowLong(hwnd_ctl, GWL_USERDATA);
		cc.Flags = CC_RGBINIT | CC_FULLOPEN;
		if (ChooseColor(&cc))
		{
			SetWindowLong(hwnd_ctl, GWL_USERDATA, (LONG)cc.rgbResult);
			InvalidateRect(hwnd, NULL, TRUE);
		}
		break;
	}
}


/*----------------------------------------------------------------------------
  dlg_style_OnDrawItem
----------------------------------------------------------------------------*/
void dlg_style_OnDrawItem(HWND hwnd, UINT id, DRAWITEMSTRUCT* lpdis)
{
	char* sample[] = { "{łłBB",
		               "http://hogehoge/",
					   "1001",
					   "",
					   "01/08/30 20:33",
					   "ID:a1BcdeF3" };
	COLORREF cl;
	COLORREF bk;
	HBRUSH hbr;
	HFONT hfont;
	HFONT holdfont;
	int btn_ctl;
	int sidx;

	if (id == IDC_PRE1)      { btn_ctl = IDC_COL1; sidx = 0; }
	else if (id == IDC_PRE2) { btn_ctl = IDC_COL2; sidx = 1; }
	else if (id == IDC_PRE3) { btn_ctl = IDC_COL3; sidx = 2; }
	else if (id == IDC_PRE4) { btn_ctl = IDC_COL4; sidx = 3; }
	else if (id == IDC_PRE5) { btn_ctl = IDC_COL5; sidx = 4; }
	else if (id == IDC_PRE6) { btn_ctl = IDC_COL6; sidx = 5; }

	cl = GetWindowLong(GetDlgItem(hwnd, btn_ctl), GWL_USERDATA);
	bk = GetWindowLong(GetDlgItem(hwnd, IDC_COLB), GWL_USERDATA);

	hbr = CreateSolidBrush(bk);
	FillRect(lpdis->hDC, &lpdis->rcItem, hbr);
	DeleteObject(hbr);

	hfont = CreateFontIndirect(&lf_optdlg);
	holdfont = (HFONT)SelectObject(lpdis->hDC, hfont);
	SetTextColor(lpdis->hDC, cl);
	SetBkColor(lpdis->hDC, bk);
	DrawText(lpdis->hDC, sample[sidx], -1, &lpdis->rcItem,
		                             DT_CENTER | DT_SINGLELINE | DT_VCENTER);
	SelectObject(lpdis->hDC, holdfont);
	DeleteObject(hfont);
}


/*----------------------------------------------------------------------------
  dlg_style_makesizebox
----------------------------------------------------------------------------*/

void dlg_style_makesizebox(void)
{
	LOGFONT lf;
	HDC hdc;
	int cursel;
	char tmp[8];
	int fonttype;
	int lpy;
	int i;

	hdc = GetDC(viewer->get_handle());
	lpy = GetDeviceCaps(hdc, LOGPIXELSY);

	cursel = SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_GETCURSEL, 0, 0);
	fonttype = SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_GETITEMDATA, cursel, 0);
	SendDlgItemMessage(hwnd_dlg, IDC_FONTSIZE, CB_RESETCONTENT, 0, 0);

	if (fonttype & TRUETYPE_FONTTYPE)
	{
		for (i = 6; i <= 24; i++)
		{
			wsprintf(tmp, "%d", i);
			SendDlgItemMessage(hwnd_dlg, IDC_FONTSIZE, CB_ADDSTRING, 0, (LPARAM)tmp);
		}
	}
	else
	{
		memset(&lf, 0, sizeof(LOGFONT));
		lf.lfCharSet = 128;
		SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_GETLBTEXT, cursel, (LPARAM)lf.lfFaceName);
		EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)enum_font_proc2, lpy, 0);

	}

	//݂̃TCYI
	wsprintf(tmp, "%d", -MulDiv(lf_optdlg.lfHeight, 72, lpy));
	SendDlgItemMessage(hwnd_dlg, IDC_FONTSIZE, CB_SELECTSTRING, 0, (LPARAM)tmp);

	ReleaseDC(viewer->get_handle(), hdc);
}


/*----------------------------------------------------------------------------
  enum_font_proc1
----------------------------------------------------------------------------*/

int CALLBACK enum_font_proc1(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme,
							                        int fonttype, LPARAM lp)
{
	int cnt;

	if (*lpelfe->elfLogFont.lfFaceName != '@')
	{
		SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_ADDSTRING,
							     0, (LPARAM)lpelfe->elfLogFont.lfFaceName);
		cnt = SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_GETCOUNT, 0, 0);
		SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_SETITEMDATA,
			                                            cnt - 1, fonttype);
	}
	return TRUE;
}


/*----------------------------------------------------------------------------
  enum_font_proc2
----------------------------------------------------------------------------*/

int CALLBACK enum_font_proc2(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme,
							                        int fonttype, LPARAM lp)
{
	char tmp[8];

	wsprintf(tmp, "%d", MulDiv(lpelfe->elfLogFont.lfHeight, 72, (int)lp));
	SendDlgItemMessage(hwnd_dlg, IDC_FONTSIZE, CB_ADDSTRING, 0, (LPARAM)tmp);
	return TRUE;
}


/*----------------------------------------------------------------------------
  enum_font_proc3
----------------------------------------------------------------------------*/

int CALLBACK enum_font_proc3(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme,
							                        int fonttype, LPARAM lp)
{
	char facename[64];
	char size[8];
	int cursel;
	int height;

	cursel = SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_GETCURSEL, 0, 0);
	SendDlgItemMessage(hwnd_dlg, IDC_FACENAME, CB_GETLBTEXT, cursel, (LPARAM)facename);
	cursel = SendDlgItemMessage(hwnd_dlg, IDC_FONTSIZE, CB_GETCURSEL, 0, 0);
	SendDlgItemMessage(hwnd_dlg, IDC_FONTSIZE, CB_GETLBTEXT, cursel, (LPARAM)size);
	height = -MulDiv(atoi(size), (int)lp, 72);

	if (strcmp(lpelfe->elfLogFont.lfFaceName, facename) == 0)
	{
		memcpy(&lf_optdlg, &lpelfe->elfLogFont, sizeof(LOGFONT));
		lf_optdlg.lfHeight = height;
		lf_optdlg.lfWidth = 0;
		return FALSE;
	}
	return TRUE;
}


/*----------------------------------------------------------------------------
  dlg_about_proc
----------------------------------------------------------------------------*/

BOOL CALLBACK dlg_about_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
	case WM_INITDIALOG:
		set_window_pos_best(hwnd);
		break;
	case WM_COMMAND:
		if (LOWORD(wp) == IDOK || LOWORD(wp) == IDCANCEL)
			EndDialog(hwnd,  LOWORD(wp));
		break;
	default:
		return FALSE;
	}
	return TRUE;
}


/*--------------------------------------------------------------------------
 
  create_imagelist

  C[WXg쐬

--------------------------------------------------------------------------*/

HIMAGELIST create_imagelist(void)
{
	HIMAGELIST imagelist;
	HBITMAP bitmap;

	imagelist = ImageList_Create(16, 16, ILC_COLOR8 | ILC_MASK, 10, 0);
	ImageList_SetBkColor(imagelist, GetSysColor(COLOR_WINDOW));
	if ((bitmap = (HBITMAP)LoadImage(NULL, image_file, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE)) != NULL)
	{
		ImageList_AddMasked(imagelist, bitmap, RGB(0xFF, 0x00, 0xFF));
		DeleteObject(bitmap);
	}
	else
	{
		return NULL;
	}
	return imagelist;
}


/*--------------------------------------------------------------------------
 
  create_lamp

  ANZXv쐬

--------------------------------------------------------------------------*/

void create_lamp(void)
{
	hwnd_lamp = CreateWindowEx(
		WS_EX_STATICEDGE,
		"STATIC",
		NULL,
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | SS_OWNERDRAW,
		0, 0, 0, 0,
		hwnd_main,
		(HMENU)ID_LAMP,
		instance,
		NULL);

	SetWindowLong(hwnd_lamp, GWL_USERDATA, GetSysColor(COLOR_3DFACE));
}




/*--------------------------------------------------------------------------

  create_edit

  GfBbgRg[쐬

--------------------------------------------------------------------------*/

void create_edit(void)
{
	HDC hdc;
	HFONT holdfont;
	SIZE size;

	hwnd_edit = CreateWindowEx(
		WS_EX_CLIENTEDGE,
		"EDIT",
		"",
		WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP |
		ES_LEFT | ES_AUTOHSCROLL,
		0, 0, 0, 0,
		hwnd_main,
		(HMENU)ID_EDIT,
		instance,
		NULL
	);

	SetWindowFont(hwnd_edit, GetStockObject(DEFAULT_GUI_FONT), FALSE);

	hdc = GetDC(hwnd_edit);
	holdfont = (HFONT)SelectObject(hdc, GetStockObject(DEFAULT_GUI_FONT));
	GetTextExtentPoint32(hdc, "A", 1, &size);
	edit_height = size.cy + 8;
	SelectObject(hdc, holdfont);
	ReleaseDC(hwnd_edit, hdc);

    //TuNX
	org_edit_proc = (FARPROC)GetWindowLong(hwnd_edit, GWL_WNDPROC);
	SetWindowLong(hwnd_edit, GWL_WNDPROC, (LONG)edit_proc);
}
LRESULT CALLBACK edit_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	char keyword[256];

    switch (msg)
	{
	case WM_KEYDOWN:
		if ((int)wp == VK_RETURN)
		{
			Edit_GetText(hwnd_edit, keyword, sizeof(keyword));
			if (strlen(keyword) == 0)
				return 0;
			find_sure(keyword);
			return 0;
		}
		else if ((int)wp == VK_TAB)
		{
			if (IsWindowVisible(hwnd_list))
				SetFocus(hwnd_list);
			/*else
				SetFocus(viewer->get_handle());*/
			return 0;
		}
		break;
    }
    return (CallWindowProc((WNDPROC)org_edit_proc, hwnd, msg, wp, lp));
}


/*--------------------------------------------------------------------------

  create_status

  Xe[^Xo[쐬

--------------------------------------------------------------------------*/

void create_status(void)
{
	hwnd_status = CreateStatusWindow(
		WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS |
		CCS_BOTTOM | SBARS_SIZEGRIP,
		"",
		hwnd_main,
		ID_STATUS);
	SendMessage(hwnd_status, SB_SIMPLE, TRUE, 0);
}


/*--------------------------------------------------------------------------

  set_control_pos

  Rg[̔zu

--------------------------------------------------------------------------*/

void set_control_pos(void)
{
	RECT r;
	int cx;
	int cy;

	GetClientRect(hwnd_main, &r);
	cx = r.right;
	cy = r.bottom;

	//Xe[^Xo[
	SendMessage(hwnd_status, WM_SIZE, 0, MAKELPARAM(cx, cy));
	GetWindowRect(hwnd_status, &r);
	cy -= (r.bottom - r.top);

	//lamp̃TCY
	SetWindowPos(
		hwnd_lamp, NULL,
		0,
		0,
		lamp_width,
		tab_height + 1,
		SWP_NOACTIVATE | SWP_NOZORDER);

	//TAB̃TCY
    SetWindowPos(
		hwnd_tab, HWND_BOTTOM,
		lamp_width,
		0,
		cx - lamp_width,
		cy,//tab_height - 2,
		SWP_NOACTIVATE/* | SWP_NOZORDER*/);

	//
	if (IsWindowVisible(hwnd_tree))
	{
		SetWindowPos(
			hwnd_tree, NULL,
			0,
			tab_height + 1,
			cx,
			cy - tab_height - 1,
			SWP_NOACTIVATE | SWP_NOZORDER);
	}
	else if (IsWindowVisible(hwnd_list))
	{
		SetWindowPos(
			hwnd_list, NULL,
			0,
			tab_height + 1,
			cx,
			cy - tab_height - edit_height - 1,
			SWP_NOACTIVATE | SWP_NOZORDER);
		SetWindowPos(
			hwnd_edit, NULL,
			0,
			cy - edit_height,
			cx,
			edit_height,
			SWP_NOACTIVATE | SWP_NOZORDER);
	}
	else
	{
	    viewer->set_size(cx, cy - tab_height /*- edit_height*/ - 1);
		/*SetWindowPos(
			hwnd_edit, NULL,
			0,
			cy - edit_height,
			cx,
			edit_height,
			SWP_NOACTIVATE | SWP_NOZORDER);*/
	}
}
