/***************************************************************************
  GickoViewer.cpp

  Copyright (C) 2001 Hachimaki. All rights reserved.
  Licensed under the GPL(v2).
***************************************************************************/

#include "GickoViewer.h"
#include "process.h"
#include "resource.h"
#include <windowsx.h>
#include <zmouse.h>

//117 modify
extern BOOL proxy_status;
extern char write_proxy[256];
extern char read_proxy[256];

/*--------------------------------------------------------------------------
  RXgN^
--------------------------------------------------------------------------*/

GViewer::GViewer(void)
{
	hwnd_this = NULL;
	hwnd_gtgt = NULL;
	gtgt_no = -1;
	onmouse_ui_idx = USHRT_MAX;
	top_line = 0;

	//drag parameter
	dragstart_pt.x = -1;
	dragstart_pt.y = -1;
	dragend_pt.x = -1;
	dragend_pt.y = -1;
	dragging = false;

	//draw parameter
	font.lfHeight = -12;
	font.lfWidth = 0;
	font.lfEscapement = 0;
	font.lfOrientation = 0;
	font.lfWeight = 400;
	font.lfItalic = 0;
	font.lfUnderline = 0;
	font.lfStrikeOut = 0;
	font.lfCharSet = 128;
	font.lfOutPrecision = 3;
	font.lfClipPrecision = 2;
	font.lfQuality = 1;
	font.lfPitchAndFamily = 50;
	strcpy(font.lfFaceName, "lr oSVbN");

	font_cy = 0;
	indent = 40;

	body_bo = 0; body_it = 0; body_ul = 0; 
	link_bo = 0; link_it = 0; link_ul = 1; 
	numb_bo = 0; numb_it = 0; numb_ul = 0; 
	name_bo = 1; name_it = 0; name_ul = 0; 
	date_bo = 0; date_it = 0; date_ul = 0; 
	idid_bo = 0; idid_it = 0; idid_ul = 0; 
	
	numb_on = 1;
	name_on = 1;
	date_on = 1;
	idid_on = 1;
	mailout = false;

	body_cl = RGB(0x00, 0x00, 0x00);
	link_cl = RGB(0x00, 0x80, 0xFF);
	numb_cl = RGB(0xFF, 0x00, 0x80);
	name_cl = RGB(0x00, 0x80, 0x00);
	date_cl = RGB(0xC0, 0xC0, 0xC0);
	idid_cl = RGB(0xC0, 0xC0, 0xC0);
	back_cl = RGB(0xEF, 0xEF, 0xEF);
}


/*--------------------------------------------------------------------------
  create
--------------------------------------------------------------------------*/

bool GViewer::create(HWND hwnd_parent, UINT id, UINT cb)
{
    WNDCLASSEX wc;
	HINSTANCE instance = 0;
	char class_name[] = "Gicko viewer";

	//oϐ
	instance = (HINSTANCE)GetWindowLong(hwnd_parent, GWL_HINSTANCE);
    
	//
	UM_MOUSEWHEEL = RegisterWindowMessage(MSH_MOUSEWHEEL);

	//EBhENXo^
	wc.cbSize           = sizeof(WNDCLASSEX);
    wc.style            = 0;
    wc.lpfnWndProc      = (WNDPROC)proc;
    wc.cbClsExtra       = 0;
    wc.cbWndExtra       = 0;
    wc.hInstance        = instance;
    wc.hIcon            = NULL;
    wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground    = NULL;//(HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName     = NULL;
    wc.lpszClassName    = class_name;
    wc.hIconSm          = NULL;

    if (!RegisterClassEx(&wc))
		return false;

	//EBhE쐬
	CreateWindowEx(
		WS_EX_CLIENTEDGE,
		class_name,
		"aaa",
        WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VSCROLL | WS_VISIBLE,
        0,
		0,
		100,
		100,
		hwnd_parent,
		(HMENU)id,
		instance,
		(LPVOID)this);

	if (hwnd_this == NULL)
		return false;

	callback = cb;
	_makestyle();

	//gtgtEBhENXo^
	wc.cbSize           = sizeof(WNDCLASSEX);
    wc.style            = 0;
    wc.lpfnWndProc      = (WNDPROC)gtgtwnd_Proc;
    wc.cbClsExtra       = 0;
    wc.cbWndExtra       = 0;
    wc.hInstance        = instance;
    wc.hIcon            = NULL;
    wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground    = NULL;//(HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName     = NULL;
    wc.lpszClassName    = "gtgtwnd";
    wc.hIconSm          = NULL;

    if (!RegisterClassEx(&wc))
		return false;

	//gtgtEBhE쐬
	CreateWindowEx(
		0,
		"gtgtwnd",
		"",
        WS_POPUP | WS_BORDER | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
        0,
		0,
		0,
		0,
		NULL,
		NULL,
		instance,
		(LPVOID)this);

	if (hwnd_gtgt == NULL)
		return false;

	return true;
}


/*--------------------------------------------------------------------------
  proc
--------------------------------------------------------------------------*/

LRESULT CALLBACK GViewer::proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    GViewer* p_this;

    p_this = (GViewer*)GetWindowLong(hwnd, GWL_USERDATA);
	if (msg ==  WM_NCCREATE)
	{
		LPCREATESTRUCT lpcs = (LPCREATESTRUCT)lp;
		p_this = (GViewer*)(lpcs->lpCreateParams);
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)p_this);
	}
	return p_this->viewer_proc(hwnd, msg, wp, lp);
/*
    p_this = (GViewer*)(GetProp(hwnd, "this"));

	if (!p_this)
	{
		if (msg == WM_NCCREATE)
		{
			p_this = (GViewer*)(((LPCREATESTRUCT)lp)->lpCreateParams);
			SetProp(hwnd, "this", (HANDLE)p_this);
		}
		else
		{
			return 0;
		}
	}
	return p_this->viewer_proc(hwnd, msg, wp, lp);
*/
}


/*--------------------------------------------------------------------------
  viewer_proc
--------------------------------------------------------------------------*/

LRESULT GViewer::viewer_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    PAINTSTRUCT ps;
    POINT pt;
    HDC hdc;
	LONG ret = 0;

	if (msg == UM_MOUSEWHEEL)
		msg = WM_MOUSEWHEEL;

	switch (msg)
	{
	case WM_NCCREATE:
		return TRUE;

	case WM_CREATE:
		hwnd_this = hwnd;
		return 0;

	case WM_DESTROY:
        PostQuitMessage(0);
		//RemoveProp(hwnd, "this");
        return 0;

	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		on_paint(hdc);
		EndPaint(hwnd, &ps);
		return 0;

	case WM_SIZE:
		on_size(wp, LOWORD(lp), HIWORD(lp));
		return 0;

	case WM_VSCROLL:
		on_vscroll(LOWORD(wp), (short int)HIWORD(wp), (HWND)lp);  
		return 0;

	case WM_MOUSEMOVE:
		pt.x = LOWORD(lp); pt.y = HIWORD(lp);
		on_mousemove(wp, pt);
		return 0;
		
	case WM_LBUTTONDOWN:
		pt.x = LOWORD(lp); pt.y = HIWORD(lp);
		on_lbuttondown(wp, pt);
		return 0;
		
	case WM_LBUTTONUP:
		pt.x = LOWORD(lp); pt.y = HIWORD(lp);
		on_lbuttonup(wp, pt);
		return 0;
		
	case WM_KEYDOWN:
		on_keydown((int)wp, lp);
		return 0;
		
	case WM_COMMAND:
		on_command(HIWORD(wp), LOWORD(wp), (HWND)lp);
		return 0;
		
	case WM_CONTEXTMENU:
		on_contextmenu((HWND)wp, LOWORD(lp), HIWORD(lp));
		return 0;
		
	case WM_MOUSEWHEEL:
		if ((signed)wp > 0)
			on_vscroll(SB_THUMBPOSITION, top_line - 5, NULL);
		else if ((signed)wp < 0)
			on_vscroll(SB_THUMBPOSITION, top_line + 5, NULL);
		return 0;
	}
    return DefWindowProc(hwnd, msg, wp, lp);
}


/*--------------------------------------------------------------------------
  on_paint
--------------------------------------------------------------------------*/

void GViewer::on_paint(HDC hdc)
{
	HDC hdc_mem;
	HBITMAP hbitmap;
	HBITMAP holdbitmap;
	HBRUSH hbr;
	RECT cr;
	UINT line;
	int y;

	//BITMAP쐬
	GetClientRect(hwnd_this, &cr);
	hdc_mem = CreateCompatibleDC(hdc);
	hbitmap = CreateCompatibleBitmap(hdc, cr.right, cr.bottom);
	holdbitmap = (HBITMAP)SelectObject(hdc_mem, hbitmap);

	//hԂ
	hbr = CreateSolidBrush(back_cl);
	FillRect(hdc_mem, &cr, hbr);
	DeleteObject(hbr);

	SetBkColor(hdc_mem, back_cl);

	copybuff.erase();
	la.clear();

	line = top_line;
	y = 0;

	while (line < doc.size() && y < cr.bottom)
	{
		draw_line(line, hdc_mem, y, true);
		line++;
		y += font_cy;
	}

    BitBlt(hdc, 0, 0, cr.right, cr.bottom, hdc_mem, 0, 0, SRCCOPY);
    SelectObject(hdc_mem, holdbitmap);
    DeleteObject(hbitmap);
    DeleteDC(hdc_mem);
}


/*--------------------------------------------------------------------------
  on_size
--------------------------------------------------------------------------*/

void GViewer::on_size(UINT type, int x, int y)
{
	set_vscrollbar();
}


/*--------------------------------------------------------------------------
  on_vscroll
--------------------------------------------------------------------------*/

void GViewer::on_vscroll(UINT code, short int pos, HWND hwnd)
{
	SCROLLINFO si;

	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_PAGE | SIF_RANGE;
	GetScrollInfo(hwnd_this, SB_VERT, &si);
	
	switch (code)
	{
	case SB_LINEUP:
		top_line -= 1;
		break;
	case SB_LINEDOWN:
		top_line += 1;
		break;
	case SB_PAGEUP:
		top_line -= (si.nPage - 1);
		break;
	case SB_PAGEDOWN:
		top_line += (si.nPage - 1);
		break;
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		top_line = pos;
		break;
	case SB_ENDSCROLL:
		return;
	}

	if (top_line < si.nMin)
		top_line = si.nMin;

	if (top_line > si.nMax - (signed)si.nPage + 2)
		top_line = si.nMax - (signed)si.nPage + 2;

	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_POS;
	si.nPos = top_line;
	SetScrollInfo(hwnd_this, SB_VERT, &si, TRUE);
	send_callback(GVIEWER_CALLBACK_VSCROLL, top_line);

	memset(&dragstart_pt, 0, sizeof(POINT));
	memset(&dragend_pt, 0, sizeof(POINT));

	InvalidateRect(hwnd_this, NULL, FALSE);
}


/*--------------------------------------------------------------------------
  on_mousemove
--------------------------------------------------------------------------*/

void GViewer::on_mousemove(DWORD key, POINT pt)
{
	int st;
	SIZE sz;
	UINT i;

	if (dragging)
	{
		dragend_pt.x = pt.x;
		dragend_pt.y = pt.y / font_cy * font_cy;
		InvalidateRect(hwnd_this, NULL, FALSE);
		return;
	}
	
	//NɃ}EX邩`FbN
	for (i = 0; i < la.size(); i++)
	{
		if (PtInRect(&la[i].r, pt))
		{
			SetCursor(LoadCursor(NULL, IDC_HAND));

			if (onmouse_ui_idx == la[i].ui)
				return;

			onmouse_ui_idx = la[i].ui;
			send_callback(GVIEWER_CALLBACK_ONHYPERLINK, (LPARAM)docurl[onmouse_ui_idx].c_str());

			//XN|bvAbv
			if ((st = atoi(docurl[onmouse_ui_idx].c_str())) > 0)
			{
				if (!IsWindowVisible(hwnd_gtgt) || st - 1 != gtgt_no)
				{
					gtgt_no = st - 1;
					gtgtwnd_get_size(&sz);
					ClientToScreen(hwnd_this, &pt);
					pt.y -= sz.cy;
					if (pt.y < 0)
						pt.y = 0;
					SetWindowPos(hwnd_gtgt, HWND_TOP, pt.x, pt.y, sz.cx, sz.cy,
								              SWP_NOACTIVATE | SWP_SHOWWINDOW);
					return;
				}
			}
			if (IsWindowVisible(hwnd_gtgt))
			{
				ShowWindow(hwnd_gtgt, SW_HIDE);
			}
			return;
		}
	}

	//Ȃ
	if (IsWindowVisible(hwnd_gtgt))
	{
		ShowWindow(hwnd_gtgt, SW_HIDE);
	}
	if (onmouse_ui_idx != USHRT_MAX)
	{
		onmouse_ui_idx = USHRT_MAX;
		SetCursor(LoadCursor(NULL, IDC_ARROW));
		send_callback(GVIEWER_CALLBACK_ONHYPERLINK, (LPARAM)"");
	}
}


/*--------------------------------------------------------------------------
  on_lbuttondown
--------------------------------------------------------------------------*/

void GViewer::on_lbuttondown(DWORD key, POINT pt)
{
	if (onmouse_ui_idx != USHRT_MAX)
	{
		if (atoi(docurl[onmouse_ui_idx].c_str()) > 0)
		{
			on_vscroll(SB_THUMBPOSITION, get_noline(atoi(docurl[onmouse_ui_idx].c_str())), NULL);
		}
		else
		{
			send_callback(GVIEWER_CALLBACK_CLICKHYPERLINK, (LPARAM)docurl[onmouse_ui_idx].c_str());
		}
		SetCursor(LoadCursor(NULL, IDC_HAND));
		return;
	}

	dragstart_pt.x = dragend_pt.x = pt.x;
	dragstart_pt.y = dragend_pt.y = pt.y / font_cy * font_cy;
	dragging = true;
	InvalidateRect(hwnd_this, NULL, FALSE);
}


/*--------------------------------------------------------------------------
  on_lbuttonup
--------------------------------------------------------------------------*/

void GViewer::on_lbuttonup(DWORD key, POINT pt)
{
	if (dragging)
	{
		dragging = false;
		if (dragstart_pt.y == dragend_pt.y && dragstart_pt.x == dragend_pt.x)
		{
			dragstart_pt.x = -1;
		}
	}
}


/*--------------------------------------------------------------------------
  on_keydown
--------------------------------------------------------------------------*/

void GViewer::on_keydown(int key, UINT data)
{
	bool ctrl = ((GetKeyState(VK_CONTROL) & 0x8000) ? true : false);

	switch (key)
	{
	case VK_UP:
		on_vscroll(SB_LINEUP, 0, NULL);
		break;
	case VK_DOWN:
		on_vscroll(SB_LINEDOWN, 0, NULL);
		break;
	case VK_PRIOR:
		on_vscroll(SB_PAGEUP, 0, NULL);
		break;
	case VK_NEXT:
		on_vscroll(SB_PAGEDOWN, 0, NULL);
		break;
	case VK_HOME:
		on_vscroll(SB_THUMBPOSITION, 0, NULL);
		break;
	case VK_END:
		on_vscroll(SB_THUMBPOSITION, SHRT_MAX, NULL);
		break;
	case 'C':
		if (ctrl)
			PostMessage(hwnd_this, WM_COMMAND, MAKELONG(IDM_COPY, 0), 0);
		return;
	case 'F':
		if (ctrl)
			PostMessage(hwnd_this, WM_COMMAND, MAKELONG(IDM_FIND, 0), 0);
		return;
	case 'R':
		if (ctrl)
			PostMessage(hwnd_this, WM_COMMAND, MAKELONG(IDM_WRITE, 0), 0);
		return;
	case 'A':
		if (ctrl)
			PostMessage(hwnd_this, WM_COMMAND, MAKELONG(IDM_ADDFAVORITE, 0), 0);
		return;
	case 'B':
		if (ctrl)
			PostMessage(hwnd_this, WM_COMMAND, MAKELONG(IDM_OPENBYBROWSER, 0), 0);
		return;
	default:
		send_callback(GVIEWER_CALLBACK_KEYDOWN, key);
		return;
	}
}


/*--------------------------------------------------------------------------
  on_command
--------------------------------------------------------------------------*/

void GViewer::on_command(WORD notify, WORD id, HWND hwnd)
{
	char tmp[1024];

	switch (id)
	{
	case IDM_COPY:
		copy_to_clipboard();
		break;

	case IDM_FIND:
		send_callback(GVIEWER_CALLBACK_OPENFIND, 0);
		break;

	case IDM_WRITE:
		DialogBoxParam(
			(HINSTANCE)GetWindowLong(hwnd_this, GWL_HINSTANCE),
			MAKEINTRESOURCE(IDD_POST),
			hwnd_this,
			dlg_post_proc,
			(LPARAM)this);
		break;

	case IDM_ADDFAVORITE:
		send_callback(GVIEWER_CALLBACK_ADDFAVORITE, 0);
		break;

	case IDM_OPENBYBROWSER:
		send_callback(GVIEWER_CALLBACK_OPENBYBROWSER, 0);
		break;

	case IDM_READCGIVER:
		wsprintf(tmp, "read.cgi ver%s", cgiver);
		MessageBox(hwnd_this, tmp, "read.cgi ver", MB_OK);
		break;

	case IDM_URL_COPY:
		copybuff = docurl[onmouse_ui_idx];
		copy_to_clipboard();
		break;

	case IDM_URL_OPENBYBROWSER:
		wsprintf(tmp,"exec.exe %s", docurl[onmouse_ui_idx].c_str());
		WinExec(tmp, SW_SHOWNORMAL);
		break;

	case IDM_URL_CHECK:
		wsprintf(tmp,"exec.exe %s%s", BCCHECKER_URL, docurl[onmouse_ui_idx].c_str());
		WinExec(tmp, SW_SHOWNORMAL);
		break;
	}
}


/*--------------------------------------------------------------------------
  on_contextmenu
--------------------------------------------------------------------------*/

void GViewer::on_contextmenu(HWND hwnd, WORD x, WORD y)
{
	HMENU menu;
	MENUITEMINFO mii;
	char tmp[32];
	int i;

	menu = CreatePopupMenu();
	mii.cbSize = sizeof(MENUITEMINFO);
	i = 0;

	if (onmouse_ui_idx == USHRT_MAX)
	{
		strcpy(tmp, "Rs[(&S)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = MFS_ENABLED;
		mii.wID = IDM_COPY;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		strcpy(tmp, "(&S)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = MFS_ENABLED;
		mii.wID = IDM_FIND;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		strcpy(tmp, "X(&R)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = (type != 255 ? MFS_ENABLED : MFS_DISABLED);
		mii.wID = IDM_WRITE;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		mii.fMask = MIIM_TYPE;
		mii.fType = MFT_SEPARATOR;
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		strcpy(tmp, "Cɓɒǉ(&A)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = MFS_ENABLED;
		mii.wID = IDM_ADDFAVORITE;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		strcpy(tmp, "uEUŊJ(&B)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = (type != 255 ? MFS_ENABLED : MFS_DISABLED);
		mii.wID = IDM_OPENBYBROWSER;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		mii.fMask = MIIM_TYPE;
		mii.fType = MFT_SEPARATOR;
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		strcpy(tmp, "read.cgi ver(&I)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = (type != 255 ? MFS_ENABLED : MFS_DISABLED);
		mii.wID = IDM_READCGIVER;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;
	}
	else
	{
		strcpy(tmp, "uEUŊJ(&O)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = MFS_ENABLED;
		mii.wID = IDM_URL_OPENBYBROWSER;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		strcpy(tmp, "uN`FbN(&B)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = MFS_ENABLED;
		mii.wID = IDM_URL_CHECK;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		mii.fMask = MIIM_TYPE;
		mii.fType = MFT_SEPARATOR;
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;

		strcpy(tmp, "URLRs[(&C)");
		mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
		mii.fType = MFT_STRING;
		mii.fState = MFS_ENABLED;
		mii.wID = IDM_URL_COPY;
		mii.dwTypeData = tmp;
		mii.cch = strlen(tmp);
		InsertMenuItem(menu, i, TRUE, &mii);
		i++;
	}
	
	//j[\
	TrackPopupMenu(menu, TPM_LEFTALIGN | TPM_LEFTBUTTON, x, y, 0, hwnd_this, NULL);

	//j[폜
	DestroyMenu(menu);
}


/*--------------------------------------------------------------------------
  set_vscrollbar
--------------------------------------------------------------------------*/

void GViewer::set_vscrollbar(void)
{
	RECT cr;

	if (font_cy == 0)
		return;
	
	GetClientRect(hwnd_this, &cr);

	//cXN[o[
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_RANGE | SIF_PAGE | SIF_POS;
	si.nMin = 0;
	si.nMax = doc.size() - 1;
	si.nPage = cr.bottom / font_cy;
	si.nPos = top_line;
	SetScrollInfo(hwnd_this, SB_VERT, &si, TRUE);
}


/*--------------------------------------------------------------------------
  open
--------------------------------------------------------------------------*/

bool GViewer::open(const char* url, const char* log_dir, bool direct, UINT _top_line)
{
	GUrl gurl;
	Res re;
	FILE* fp;
	char logfile[MAX_PATH];
	char _title[256];
	time_t t;
	UINT no;
	UINT i;

	doc.clear();
	docurl.clear();

	//URL`FbN
	if (!direct)
	{
		if (gurl.split(url))
		{
			strcpy(server, gurl.server);
			strcpy(bbs, gurl.bbs);
			strcpy(key, gurl.key);
			type = gurl.type;

			//Ot@C
			if (type == 0)
			{
				sprintf(logfile, "%s\\%s%s.dat", log_dir, bbs, key);
			}
			else
			{
				char* p;
				sprintf(logfile, "%s\\%s_%s_%s", log_dir, server, bbs, key);
				while ((p = strchr(logfile, '.')) != NULL) *p = '_';
				while ((p = strchr(logfile, '/')) != NULL) *p = '_';
				strcat(logfile, ".dat");
			}
		}
		else
		{
			return false;
		}
	}
	else
	{
		strcpy(server, "");
		strcpy(bbs, "");
		strcpy(key, "");
		type = 255;
		sprintf(logfile, "%s\\%s", log_dir, url);
	}

	//Ot@CI[v
	if ((fp = fopen(logfile, "r")) == NULL)
		return false;

	//^Cg擾
	if (!get_title_from_log(fp, _title))
	{
		sprintf(error_message, "ERROR: OɃ^CgȂ(%s)", logfile);
		fclose(fp);
		return false;
	}
	title = _title;

	//X擾
	i = 0;
	while ((no = get_res_from_log(fp, re)) != UINT_MAX)
	{
		if (no > i)
		{
			add_hokan(i, no - 1);
			i = no;
		}
		res_to_doc(no, re);
		t = re.wtime;
		i++;
	}
	if (i != 0 && t != 0 && type != 255)
		add_kousin(i);
	
	fclose(fp);

	top_line = _top_line;
	if (top_line > (signed)doc.size())
		top_line = doc.size();

	if (IsWindowVisible(hwnd_this))
	{
		InvalidateRect(hwnd_this, NULL, FALSE);
		set_vscrollbar();
	}

	return true;
}


/*--------------------------------------------------------------------------
  show
--------------------------------------------------------------------------*/

void GViewer::show(bool flag)
{
	if (flag)
		ShowWindow(hwnd_this, SW_SHOWNORMAL);
	else
		ShowWindow(hwnd_this, SW_HIDE);
}


/*--------------------------------------------------------------------------
  set_pos
--------------------------------------------------------------------------*/

void GViewer::set_pos(int x, int y)
{
	SetWindowPos(hwnd_this, NULL, x, y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
}


/*--------------------------------------------------------------------------
  set_size
--------------------------------------------------------------------------*/

void GViewer::set_size(int w, int h)
{
	SetWindowPos(hwnd_this, NULL, 0, 0, w, h, SWP_NOZORDER | SWP_NOMOVE);
}


/*--------------------------------------------------------------------------
  set_font
--------------------------------------------------------------------------*/

void GViewer::set_font(const LOGFONT* newlf)
{
	memcpy(&font, newlf, sizeof(LOGFONT));
	_makestyle();
	if (IsWindowVisible(hwnd_this))
	{
		InvalidateRect(hwnd_this, NULL, FALSE);
		set_vscrollbar();
	}
}


/*--------------------------------------------------------------------------
  set_`_flag
--------------------------------------------------------------------------*/

void GViewer::set_body_flag(char bo, char it, char ul)
{
	body_bo = bo; body_it = it; body_ul = ul;
	_makestyle();
}
void GViewer::set_link_flag(char bo, char it, char ul)
{
	link_bo = bo; link_it = it; link_ul = ul;
	_makestyle();
}
void GViewer::set_numb_flag(char on, char bo, char it, char ul)
{
	numb_on = on; numb_bo = bo; numb_it = it; numb_ul = ul;
	_makestyle();
}
void GViewer::set_name_flag(char on, char bo, char it, char ul)
{
	name_on = on; name_bo = bo; name_it = it; name_ul = ul;
	_makestyle();
}
void GViewer::set_date_flag(char on, char bo, char it, char ul)
{
	date_on = on; date_bo = bo; date_it = it; date_ul = ul;
	_makestyle();
}
void GViewer::set_idid_flag(char on, char bo, char it, char ul)
{
	idid_on = on; idid_bo = bo; idid_it = it; idid_ul = ul;
	_makestyle();
}

	
/*--------------------------------------------------------------------------
  set_color
--------------------------------------------------------------------------*/

void GViewer::set_color(COLORREF bo, COLORREF li, COLORREF nu,
						   COLORREF na, COLORREF da, COLORREF id,
						   COLORREF bk)
{
	body_cl = bo;
	link_cl = li;
	numb_cl = nu;
	name_cl = na;
	date_cl = da;
	idid_cl = id;
	back_cl = bk;
	_makestyle();
}


/*----------------------------------------------------------------------------
  dlg_post_proc
----------------------------------------------------------------------------*/

BOOL CALLBACK GViewer::dlg_post_proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    GViewer* p_this = (GViewer*)GetWindowLong(hwnd, GWL_USERDATA);
	char name[64];
	char mail[64];
	char mes[1024];
	UINT i;

	if (msg != WM_INITDIALOG && p_this == NULL)
		return FALSE;

	switch (msg)
	{
	case WM_INITDIALOG:
		p_this = (GViewer*)lp;
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)p_this);
		strcpy(mes,  p_this->get_title());
		strcat(mes, "ւ̃X");
		SetWindowText(hwnd, mes);

		ComboBox_LimitText(GetDlgItem(hwnd, IDC_NAME), sizeof(name)-1);
		ComboBox_LimitText(GetDlgItem(hwnd, IDC_MAIL), sizeof(mail)-1);
		Edit_LimitText(GetDlgItem(hwnd, IDC_MSG),  sizeof(mes)-1);

		for(i = 0; i < p_this->post_name.size(); i++)
			ComboBox_AddString(GetDlgItem(hwnd, IDC_NAME), p_this->post_name[i].c_str());
		ComboBox_SetCurSel(GetDlgItem(hwnd, IDC_NAME), 0);
		for(i = 0; i < p_this->post_mail.size(); i++)
			ComboBox_AddString(GetDlgItem(hwnd, IDC_MAIL), p_this->post_mail[i].c_str());
		ComboBox_SetCurSel(GetDlgItem(hwnd, IDC_MAIL), 0);
		break;

    case WM_COMMAND:
		switch (LOWORD(wp))
		{
		case IDOK:
		case IDCANCEL:
			EndDialog(hwnd, LOWORD(wp));
			break;
		case IDC_SUBMIT:
			EnableWindow(GetDlgItem(hwnd, IDC_SUBMIT), FALSE);
			GetDlgItemText(hwnd, IDC_NAME, name, sizeof(name));
			GetDlgItemText(hwnd, IDC_MAIL, mail, sizeof(mail));
			GetDlgItemText(hwnd, IDC_MSG,  mes,  sizeof(mes));
			if (p_this->post_res(name, mail, mes))
			{
				//Oƃ[L
				if ((i = ComboBox_GetCurSel(GetDlgItem(hwnd, IDC_NAME))) == CB_ERR)
				{
					if (p_this->post_name.size() == 0)
						p_this->post_name.push_back(name);
					else
						p_this->post_name.insert(&p_this->post_name[0], name);
				}
				else
				{
					p_this->post_name.erase(&p_this->post_name[i]);
					p_this->post_name.insert(&p_this->post_name[0], name);
				}
				if ((i = ComboBox_GetCurSel(GetDlgItem(hwnd, IDC_MAIL))) == CB_ERR)
				{
					if (p_this->post_mail.size() == 0)
						p_this->post_mail.push_back(mail);
					else
						p_this->post_mail.insert(&p_this->post_mail[0], mail);
				}
				else
				{
					p_this->post_mail.erase(&p_this->post_mail[i]);
					p_this->post_mail.insert(&p_this->post_mail[0], mail);
				}
				//open
				p_this->get_url(mes);
				p_this->send_callback(GVIEWER_CALLBACK_POSTMESSAGE, (LPARAM)mes);
				EndDialog(hwnd, LOWORD(wp));
			}
			break;
		}
		EnableWindow(GetDlgItem(hwnd, IDC_SUBMIT), TRUE);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/*----------------------------------------------------------------------------
  post_res
----------------------------------------------------------------------------*/

bool GViewer::post_res(const char* name, const char* mail, char* mes)
{
    HINTERNET hInternet;
    HINTERNET hHttpSession;
    HINTERNET hHttpRequest;
	char _server[128];
	char _object[256];
	char submit_name[] = "";
	char encode_submit_name[64];
	char encode_name[256];
	char encode_mail[256];
	char encode_mes[2048];
	char send_str[4096];
	char referer[256];
	char* buff;
	char* p;
	size_t buffsize;
	DWORD asize;
	DWORD readlen;
	bool ret = true;

	strcpy(_server, server);
	if ((p = strchr(_server, '/')) != NULL)
	{
		*p = '\0';
		sprintf(_object, "/%s", p + 1);
	}
	else
	{
		strcpy(_object, "");
	}
	if (type == 0)
	{
		strcat(_object, "/test/bbs.cgi");
	}
	else
	{
		strcat(_object, "/bbs/write.cgi");
	}

    //WinInet
	if( !proxy_status){
    hInternet = InternetOpen(
        AGENT,
        INTERNET_OPEN_TYPE_PRECONFIG,
        NULL,
        NULL,
        0);
	}else{
		if( strlen(write_proxy)>0){
//ProxyΉ
			hInternet = InternetOpen(
				AGENT,
				INTERNET_OPEN_TYPE_PROXY,
				write_proxy,
				NULL,
				0);
		}else{
			hInternet = InternetOpen(
				AGENT,
				INTERNET_OPEN_TYPE_PRECONFIG,
				NULL,
				NULL,
				0);
		}
	}
    //T[o֐ڑ
    hHttpSession = InternetConnect(
        hInternet,
        _server,
        INTERNET_DEFAULT_HTTP_PORT,
        NULL,
        NULL,
        INTERNET_SERVICE_HTTP,
        0,
        0);

    //HTTPNGXg쐬
	get_url(referer);
    hHttpRequest = HttpOpenRequest(
        hHttpSession,
        "POST",
        _object,
        NULL,
		referer,
        NULL,
        INTERNET_FLAG_RESYNCHRONIZE,
        0);

	urlencode(submit_name, encode_submit_name);
	urlencode(name, encode_name);
	urlencode(mail, encode_mail);
	urlencode(mes, encode_mes);
	if (type == 0)
	{
		sprintf(send_str, "submit=%s&FROM=%s&mail=%s&MESSAGE=%s&bbs=%s&key=%s&time=%ld",
			encode_submit_name,
			encode_name,
			encode_mail,
			encode_mes,
			bbs,
			key,
			time(NULL));
	}
	else
	{
		sprintf(send_str, "submit=%s&NAME=%s&MAIL=%s&MESSAGE=%s&BBS=%s&KEY=%s&TIME=%ld",
			encode_submit_name,
			encode_name,
			encode_mail,
			encode_mes,
			bbs,
			key,
			time(NULL));
	}

	//Send
    HttpSendRequest(
        hHttpRequest,
        NULL,
        0,
        send_str,
        strlen(send_str));

	//HTML̎M
	InternetQueryDataAvailable(hHttpRequest, &asize, 0, 0);
	buff = NULL;
	buffsize = 0;
	while (asize > 0)
    {
		if (buff == NULL)
			buff = (char*)malloc(asize);
		else
			buff = (char*)realloc(buff, (buffsize + asize));
        
        InternetReadFile(hHttpRequest, (buff + buffsize), asize, &readlen);
		buffsize += asize;

    	InternetQueryDataAvailable(hHttpRequest, &asize, 0, 0);
	}

	//G[H
	if (strstr(buff, "dqqnq"))
	{
		char* p1;
		char* p2;
		if ((p1 = strstr(buff, "<body")) != NULL)
		{
			if ((p1 = strstr(p1, "dqqnq")) != NULL)
			{
				if ((p2 = strchr(p1, '<')) != NULL)
					*p2 = '\0';
				MessageBox(NULL, p1, NULL, MB_ICONWARNING | MB_OK);
			}
			else
				MessageBox(NULL, buff, NULL, MB_ICONWARNING | MB_OK);
		}
		else
			MessageBox(NULL, buff, NULL, MB_ICONWARNING | MB_OK);
		ret = false;
	}

	//
	free(buff);
	InternetCloseHandle(hHttpRequest);
    InternetCloseHandle(hHttpSession);
    InternetCloseHandle(hInternet);
	return ret;
}


/*----------------------------------------------------------------------------
  urlencode
----------------------------------------------------------------------------*/

void GViewer::urlencode(const char* in, char *out)
{
	UINT i;
	char* p2 = out;

	for (i = 0; i < strlen(in); i++)
	{
		if ((*(in + i) >= '0' && *(in + i) <= '9') ||
			(*(in + i) >= 'A' && *(in + i) <= 'Z') ||
			(*(in + i) >= 'a' && *(in + i) <= 'z'))
		{
			*p2 = *(in + i);
			p2++;
		}
		else
		{
			sprintf(p2, "%%%02x", (unsigned char)(*(in + i)));
			p2 += 3;
		}
	}
	*p2 = '\0';
}


/*--------------------------------------------------------------------------
  gtgtwnd_Proc
--------------------------------------------------------------------------*/

LRESULT CALLBACK GViewer::gtgtwnd_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    GViewer* p_this;
	PAINTSTRUCT ps;
	HDC hdc;

    p_this = (GViewer*)GetWindowLong(hwnd, GWL_USERDATA);

    switch (msg)
    {
	case WM_NCCREATE:
		{
			LPCREATESTRUCT lpcs = (LPCREATESTRUCT)lp;
			p_this = (GViewer*)(lpcs->lpCreateParams);
			SetWindowLong(hwnd, GWL_USERDATA, (LONG)p_this);
			p_this->hwnd_gtgt = hwnd;
		}
		return TRUE;
    case WM_PAINT:
        hdc = BeginPaint(hwnd, &ps);
        p_this->gtgtwnd_OnPaint(hdc);
        EndPaint(hwnd, &ps);
        return 0;
	}
    return DefWindowProc(hwnd, msg, wp, lp);
}


/*--------------------------------------------------------------------------
  gtgtwnd_OnPaint
--------------------------------------------------------------------------*/

void GViewer::gtgtwnd_OnPaint(HDC hdc)
{
	HBRUSH hbr;
	RECT r;
	UINT line;
	int y;

	GetClientRect(hwnd_gtgt, &r);
	hbr = CreateSolidBrush(back_cl);
	FillRect(hdc, &r, hbr);
	DeleteObject(hbr);
	SetBkColor(hdc, back_cl);

	line = get_noline(gtgt_no + 1);
	y = 0;

	do
	{
		draw_line(line, hdc, y * font_cy, false);
		line++;
		y++;
	}
	while (line < doc.size() && doc[line].si[0] != 2 && doc[line].si[0] != 6);
}


/*--------------------------------------------------------------------------
  gtgtwnd_get_size
--------------------------------------------------------------------------*/

void GViewer::gtgtwnd_get_size(SIZE* size)
{
	HFONT hfont;
	HFONT holdfont;
	HDC hdc;
	SIZE sz;
	UINT line;
	UINT i;
	int maxx;
	int x;
	int y;

	hdc = GetDC(hwnd_this);

	line = get_noline(gtgt_no + 1);
	maxx = 0;
	y = 0;

	do
	{
		x = indent;
		for (i = 0; i < doc[line].st.size(); i++)
		{
			hfont = CreateFontIndirect(&style[doc[line].si[i]].font);
			holdfont = (HFONT)SelectObject(hdc, hfont);
			GetTextExtentPoint32(hdc, doc[line].str.substr(doc[line].st[i]).c_str(), doc[line].ln[i], &sz);
			SelectObject(hdc, holdfont);
			DeleteObject(hfont);
			x += sz.cx;
		}
		if (maxx < x)
			maxx = x;
		y += font_cy;
		line++;
	}
	while (line < doc.size() && doc[line].si[0] != 2 && doc[line].si[0] != 6);

	size->cx = maxx + 2;
	size->cy = y + 2;

	ReleaseDC(hwnd_this, hdc);
}


/*----------------------------------------------------------------------------
  res_to_doc
----------------------------------------------------------------------------*/

void GViewer::res_to_doc(int no, Res& re)
{
	Line line;
	char tmp[256];
	struct tm* ptm;
	string str;
	UINT pos1;
	UINT pos2;
	UINT pos3;
	UINT i;

	//ԍ
	if (numb_on)
	{
		sprintf(tmp, "%d:", no + 1);
		sprintf(tmp, "%-4s", tmp);
		line.add(tmp, 2);
	}
	//O
	if (name_on)
	{
		convert_er(re.name);
		if (re.mail.size() > 0 && !mailout)
		{
			sprintf(tmp, "mailto:%s", re.mail.c_str());
			docurl.push_back(tmp);
			line.add(re.name.c_str(), 1, docurl.size() - 1);
		}
		else
		{
			line.add(re.name.c_str(), 3);
		}
		if (mailout && re.mail.size() > 0)
		{
			sprintf(tmp, "mailto:%s", re.mail.c_str());
			docurl.push_back(tmp);
			wsprintf(tmp, "<%s>", re.mail.c_str());
			line.add(tmp, 1, docurl.size() - 1);
		}
	}
	//e
	if (date_on)
	{
		if (re.wtime != 0)
		{
			ptm = localtime(&re.wtime);
			wsprintf(
				tmp,
				" :%02d/%02d/%02d %02d:%02d (%s)",
				ptm->tm_year - 100,
				ptm->tm_mon + 1,
				ptm->tm_mday,
				ptm->tm_hour,
				ptm->tm_min,
				"\0\0\0\0\0\0y\0" + ptm->tm_wday * 3);
			line.add(tmp, 4);
		}
	}
	//ID
	if (idid_on && strlen(re.id) > 0)
	{
		wsprintf(tmp, " ID:%s", re.id);
		line.add(tmp, 5);
	}
	doc.push_back(line);
	
	//X
	for (i = 0; i < re.text.size(); i++)
	{
		line.clear();
		pos1 = 0;
		pos2 = 0;
		
		//convert_er(re.text[i]);
		
		while (pos1 < re.text[i].size())
		{
			//hyper link
			/**
			*<A HREF="string">string</A>@ string 𔲂o2ch̃N
			*ȊÕN`FbNA`FbNzɏo
			*
			*strnicmp --- 啶ʂȂŐ擪nڂ܂Ŕr
			*re.text[i].substr(pos1.n).c_str() -- z񂩂noẴ|C^Ԃ
			*
			*/
			if (*re.text[i].substr(pos1, 1).c_str() == ' '){
				while( *re.text[i].substr(pos1, 1).c_str() == ' '){
					pos1++;
				}
			}
			if (strnicmp(re.text[i].substr(pos1, 4).c_str(), "ttp:", 4) == 0 ||
				strnicmp(re.text[i].substr(pos1, 4).c_str(), "www.",4 ) == 0)
			{
				UINT dummypos;
				
				dummypos = pos1;
				
				//[a-zA-Z0-9./-+#_?~&%=^@:;̊ԃ[v
				while( *re.text[i].substr(dummypos,1).c_str() == '#' ||
					   *re.text[i].substr(dummypos,1).c_str() == '%' ||
					   *re.text[i].substr(dummypos,1).c_str() == '&' ||
					  (*re.text[i].substr(dummypos,1).c_str() >= '*' && *re.text[i].substr(dummypos,1).c_str() <= ';') ||
					  (*re.text[i].substr(dummypos,1).c_str() >= '@' && *re.text[i].substr(dummypos,1).c_str() <= 'Z') ||
					  (*re.text[i].substr(dummypos,1).c_str() >= '^' && *re.text[i].substr(dummypos,1).c_str() <= '_') ||
					  (*re.text[i].substr(dummypos,1).c_str() >= 'a' && *re.text[i].substr(dummypos,1).c_str() <= 'z') ||
					   *re.text[i].substr(dummypos,1).c_str() == '~' ){
						dummypos++;
				}
				if( *re.text[i].substr(dummypos,1).c_str() == '\0'){
					if( strnicmp(re.text[i].substr(pos1, 4).c_str(), "ttp:", 4) == 0 ){
						sprintf( tmp,"h%s",re.text[i].substr(pos1,dummypos - pos1).c_str());
					}else if( strnicmp(re.text[i].substr(pos1, 4).c_str(), "www.",4 ) == 0){
						sprintf( tmp,"http://%s",re.text[i].substr(pos1,dummypos - pos1).c_str());
					}

					check_res_pointer(tmp);
					docurl.push_back(tmp);

					str = re.text[i].substr(pos1, dummypos - pos1).c_str();
					convert_er(str);
					line.add(str.c_str(), 1, docurl.size() - 1);

					pos1 = dummypos;
				}else{
					pos1 = dummypos;
				}
			}
			if (strnicmp(re.text[i].substr(pos1, 8).c_str(), "<a href=", 8) == 0 ||
				strnicmp(re.text[i].substr(pos1, 9).c_str(), "<A target", 9) == 0)
			{
				//get url
				if (strnicmp(re.text[i].substr(pos1, 8).c_str(), "<a href=", 8) == 0)
					pos1 += 8;
				else
					pos1 = re.text[i].find("HREF=", pos1) + 5;
				if (*re.text[i].substr(pos1, 1).c_str() == '"')
				{
					pos1++;
					pos2 = re.text[i].find('"', pos1);
				}
				else
				{
					pos2 = re.text[i].find(' ', pos1);
					if ((pos3 = re.text[i].find('>', pos1)) < pos2)
						pos2 = pos3;
				}
				strcpy(tmp, re.text[i].substr(pos1, pos2 - pos1).c_str());
				check_res_pointer(tmp);
				//get link text
				pos1 = re.text[i].find('>', pos2) + 1;
				if ((pos2 = re.text[i].find("</a>", pos1)) == -1)
					pos2 = re.text[i].find("</A>", pos1);
				
				docurl.push_back(tmp);
				str = re.text[i].substr(pos1, pos2 - pos1).c_str();
				convert_er(str);
				line.add(str.c_str(), 1, docurl.size() - 1);

				pos1 = pos2 + 4;
				continue;
			}

			
			//res pointer '>' or ''
			if (*re.text[i].substr(pos1, 1).c_str() == '>' ||
				strncmp(re.text[i].substr(pos1, 4).c_str(), "&gt;", 4) == 0 ||
				strncmp(re.text[i].substr(pos1, 2).c_str(), "", 2) == 0)
			{
				if (*re.text[i].substr(pos1, 1).c_str() == '>')
				{
					if (*re.text[i].substr(pos1 + 1, 1).c_str() == '>')
						pos2 = pos1 + 2;
					else
						pos2 = pos1 + 1;
				}
				else if (strncmp(re.text[i].substr(pos1, 4).c_str(), "&gt;", 4) == 0)
				{
					if (strncmp(re.text[i].substr(pos1 + 4, 4).c_str(), "&gt;", 4) == 0)
						pos2 = pos1 + 8;
					else
						pos2 = pos1 + 4;
				}
				else
				{
					pos2 = pos1 + 2;
				}
				strcpy(tmp, "");
				while (pos2 < re.text[i].size() &&
					   *re.text[i].substr(pos2, 1).c_str() >= '0' &&
					   *re.text[i].substr(pos2, 1).c_str() <= '9')
				{
					sprintf(tmp, "%s%c", tmp, *re.text[i].substr(pos2, 1).c_str());
					pos2++;
				}
				if (atoi(tmp) > 0)
				{
					check_res_pointer(tmp);
					docurl.push_back(tmp);
					str = re.text[i].substr(pos1, pos2 - pos1).c_str();
					convert_er(str);
					line.add(str.c_str(), 1, docurl.size() - 1);

					pos1 = pos2;
					continue;
				}
			}

			//normal text
			pos2 = UINT_MAX;
			if ((pos3 = re.text[i].find("<a href=", pos1)) < pos2)
				pos2 = pos3;
			if ((pos3 = re.text[i].find("<A HREF=", pos1)) < pos2)
				pos2 = pos3;
			if ((pos3 = re.text[i].find("<A target", pos1)) < pos2)
				pos2 = pos3;
			if ((pos3 = re.text[i].find(">", pos1))  < pos2 && pos3 != pos1)
				pos2 = pos3;
			if ((pos3 = re.text[i].find("&gt;", pos1))  < pos2 && pos3 != pos1)
				pos2 = pos3;
			if ((pos3 = re.text[i].find("", pos1)) < pos2 && pos3 != pos1)
				pos2 = pos3;
			if ((pos3 = re.text[i].find("ttp:",pos1)) <pos2 ){
				if( *((re.text[i].substr(pos3,1).c_str())-1) != 'h' ){
					pos2 = pos3;
				}
			}
			if ((pos3 = re.text[i].find("www.",pos1)) <pos2 ){
				if( *((re.text[i].substr(pos3,1).c_str())-1) != '/' ){
					pos2 = pos3;
				}
			}
			str = re.text[i].substr(pos1, pos2 - pos1).c_str();
			convert_er(str);
			line.add(str.c_str(), 0);

			pos1 = pos2;
		}
		if (line.str.size() == 0)
			line.add("", 0);
		doc.push_back(line);
	}
}

/*----------------------------------------------------------------------------
  check_res_pointer
----------------------------------------------------------------------------*/

void GViewer::check_res_pointer(char* tmp)
{
	int no;

	if (strncmp(tmp, "..", 2) == 0)
	{
		if (!strstr(tmp, "START="))
			return;
		no = atoi(strstr(tmp, "START=") + 6);
	}
	else
	{
		no = atoi(tmp);
	}

	if (no == 0)
		return;

	if (get_noline(no) != -1)
	{
		wsprintf(tmp, "%d", no);
	}
	else
	{
		if (type == 0)
			sprintf(tmp, "http://%s/test/read.cgi/%s/%s/%d",
				server,
				bbs,
				key,
				no);
		else
			sprintf(tmp, "http://%s/bbs/read.cgi?BBS=%s&KEY=%s&START=%d&END=%d&NOFIRST=TRUE",
				server,
				bbs,
				key,
				no,
				no);
	}
}


/*----------------------------------------------------------------------------
  add_hokan
----------------------------------------------------------------------------*/

void GViewer::add_hokan(int st, int to)
{
	Line line;
	char tmp[256];

	if (type == 0)
		sprintf(tmp, "http://%s/test/read.cgi/%s/%s/%d-%d",
		server,
		bbs,
		key,
		st + 1,
		to + 1);
	else
		sprintf(tmp, "http://%s/bbs/read.cgi?BBS=%s&KEY=%s&START=%d&END=%d&NOFIRST=TRUE",
		server,
		bbs,
		key,
		st + 1,
		to + 1);

	docurl.push_back(tmp);
	
	sprintf(tmp, "%d ` %d 擾", st + 1, to + 1);
	line.add(tmp, 6, docurl.size() - 1);
	doc.push_back(line);
	
	line.clear();
	line.add("", 0);
	doc.push_back(line);
	doc.push_back(line);
}


/*----------------------------------------------------------------------------
  add_kousin
----------------------------------------------------------------------------*/

void GViewer::add_kousin(int st)
{
	Line line;
	char tmp[256];

	if (type == 0)
		sprintf(tmp, "http://%s/test/read.cgi/%s/%s/%d-", server, bbs, key, st + 1);
	else
		sprintf(tmp, "http://%s/bbs/read.cgi?BBS=%s&KEY=%s&START=%d&NOFIRST=TRUE", server, bbs, key, st + 1);

	docurl.push_back(tmp);
	line.add("XV擾", 6, docurl.size() - 1);
	doc.push_back(line);
}


/*--------------------------------------------------------------------------
  findstring
--------------------------------------------------------------------------*/

bool GViewer::findstring(FINDREPLACE* pfr)
{
	UINT line;
	UINT i;

	//Ɍ
    if ((pfr->Flags & FR_FINDNEXT) && (pfr->Flags & FR_DOWN))
	{
		line = top_line + 1;
		if (line >= doc.size())
			return false;

		while (line < doc.size())
		{
			for (i = 0; i < doc[line].str.size(); i++)
			{
				if (strnicmp(doc[line].str.substr(i).c_str(), pfr->lpstrFindWhat, strlen(pfr->lpstrFindWhat)) == 0)
				{
					on_vscroll(SB_THUMBPOSITION, line, NULL);
					return true;
				}
			}
			line++;
		}
	}
	//Ɍ
	else if ((pfr->Flags & FR_FINDNEXT) && !(pfr->Flags & FR_DOWN))
	{
		line = top_line - 1;
		if (line < 0)
			return false;

		while (line >= 0)
		{
			for (i = 0; i < doc[line].str.size(); i++)
			{
				if (strnicmp(doc[line].str.substr(i).c_str(), pfr->lpstrFindWhat, strlen(pfr->lpstrFindWhat)) == 0)
				{
					on_vscroll(SB_THUMBPOSITION, line, NULL);
					return true;
				}
			}
			line--;
		}
	}

	return false;
}


/*----------------------------------------------------------------------------
  draw_line
----------------------------------------------------------------------------*/

int GViewer::draw_line(int line, HDC hdc, int y, bool add_la)
{
	LinkArea _la;
	POINT* sp;
	POINT* ep;
	HFONT hfont;
	HFONT holdfont;
	SIZE size;
	bool sel;
	RECT r;
	int x;
	UINT i;

	if (doc[line].str.size() == 0)
		return 0;
		
	if (doc[line].si[0] == 2 || doc[line].si[0] == 6)
		x = 0;
	else
		x = indent;

	for (i = 0; i < doc[line].st.size(); i++)
	{
		hfont = CreateFontIndirect(&style[doc[line].si[i]].font);
		holdfont = (HFONT)SelectObject(hdc, hfont);
		SetTextColor(hdc, style[doc[line].si[i]].color);

		TextOut(hdc, x, y, doc[line].str.substr(doc[line].st[i]).c_str(), doc[line].ln[i]);
		GetTextExtentPoint32(hdc, doc[line].str.substr(doc[line].st[i]).c_str(), doc[line].ln[i], &size);
		SelectObject(hdc, holdfont);
		DeleteObject(hfont);

		if (doc[line].ui[i] != USHRT_MAX && add_la)
		{
			SetRect(&_la.r, x, y, x + size.cx, y + font_cy);
			_la.ui = doc[line].ui[i];
			la.push_back(_la);
		}

		if (dragstart_pt.x != -1)
		{
			sel = false;
			if ((dragstart_pt.y > dragend_pt.y) || (dragstart_pt.y == dragend_pt.y && dragstart_pt.x > dragend_pt.x))
			{
				sp = &dragend_pt;
				ep = &dragstart_pt;
			}
			else
			{
				sp = &dragstart_pt;
				ep = &dragend_pt;
			}
			if (sp->y < y && ep->y > y)
			{
				sel = true;
			}
			else if (sp->y == y && ep->y == y)
			{
				if (sp->x <= x && ep->x >= x + size.cx)
					sel = true;
			}
			else if (sp->y == y && sp->x <= x)
			{
				sel = true;
			}
			else if (ep->y == y && ep->x >= x + size.cx)
			{
				sel = true;
			}
			if (sel)
			{
				SetRect(&r, x, y, x + size.cx, y + size.cy);
				InvertRect(hdc, &r);
				copybuff += doc[line].str.substr(doc[line].st[i], doc[line].ln[i]).c_str();
				if (i == doc[line].st.size() - 1)
					copybuff += '\n';
			}
		}

		x += size.cx;
	}

	return x;
}


/*----------------------------------------------------------------------------
  _makestyle
----------------------------------------------------------------------------*/

void GViewer::_makestyle(void)
{
	SIZE size;
	HDC hdc = GetDC(hwnd_this);
	HFONT hfont = CreateFontIndirect(&font);
	HFONT holdfont = (HFONT)SelectObject(hdc, hfont);
	GetTextExtentPoint32(hdc, "A", 1, &size);
	SelectObject(hdc, holdfont);
	DeleteObject(hfont);
	ReleaseDC(hwnd_this, hdc);
	font_cy = size.cy;

	memcpy(&style[0].font, &font, sizeof(LOGFONT));
	if (body_bo) style[0].font.lfWeight = FW_BOLD;
	if (body_it) style[0].font.lfItalic = TRUE;
	if (body_ul) style[0].font.lfUnderline = TRUE;
	style[0].color = body_cl;

	memcpy(&style[1].font, &font, sizeof(LOGFONT));
	if (link_bo) style[1].font.lfWeight = FW_BOLD;
	if (link_it) style[1].font.lfItalic = TRUE;
	if (link_ul) style[1].font.lfUnderline = TRUE;
	style[1].color = link_cl;

	memcpy(&style[2].font, &font, sizeof(LOGFONT));
	if (numb_bo) style[2].font.lfWeight = FW_BOLD;
	if (numb_it) style[2].font.lfItalic = TRUE;
	if (numb_ul) style[2].font.lfUnderline = TRUE;
	style[2].color = numb_cl;

	memcpy(&style[3].font, &font, sizeof(LOGFONT));
	if (name_bo) style[3].font.lfWeight = FW_BOLD;
	if (name_it) style[3].font.lfItalic = TRUE;
	if (name_ul) style[3].font.lfUnderline = TRUE;
	style[3].color = name_cl;

	memcpy(&style[4].font, &font, sizeof(LOGFONT));
	if (date_bo) style[4].font.lfWeight = FW_BOLD;
	if (date_it) style[4].font.lfItalic = TRUE;
	if (date_ul) style[4].font.lfUnderline = TRUE;
	style[4].color = date_cl;

	memcpy(&style[5].font, &font, sizeof(LOGFONT));
	if (idid_bo) style[5].font.lfWeight = FW_BOLD;
	if (idid_it) style[5].font.lfItalic = TRUE;
	if (idid_ul) style[5].font.lfUnderline = TRUE;
	style[5].color = idid_cl;

	memcpy(&style[6].font, &font, sizeof(LOGFONT));
	style[6].font.lfWeight = FW_BOLD;
	style[6].font.lfUnderline = TRUE;
	style[6].color = RGB(0xFF, 0x00, 0x00);
}


/*----------------------------------------------------------------------------
  get_noline
----------------------------------------------------------------------------*/

int GViewer::get_noline(int no)
{
	UINT i;

	for (i = 0; i < doc.size(); i++)
	{
		if (doc[i].str.size() == 0)
			continue;

		if (doc[i].si[0] == 2 && atoi(doc[i].str.c_str()) == no)
		{
			return i;
		}
	}

	return -1;
}


/*----------------------------------------------------------------------------
  copy_to_clipboard
----------------------------------------------------------------------------*/

void GViewer::copy_to_clipboard(void)
{
    HGLOBAL hGlobal;
	char* buff;

	if (copybuff.size() == 0)
		return;

    if ((hGlobal = GlobalAlloc(GHND, copybuff.size())) == NULL)
		return;

    buff = (char*)GlobalLock(hGlobal);
	memcpy(buff, copybuff.c_str(), copybuff.size());
    GlobalUnlock(hGlobal);

    if (OpenClipboard(hwnd_this) == 0)
	{
        GlobalFree(hGlobal);
        return;
    }
    EmptyClipboard();
    SetClipboardData(CF_TEXT, hGlobal);
    CloseClipboard();
   
	return;
}


/*----------------------------------------------------------------------------
  send_callback
----------------------------------------------------------------------------*/

void GViewer::send_callback(WPARAM wp, LPARAM lp)
{
	SendMessage(GetParent(hwnd_this), callback, wp, lp);
}
