/***************************************************************************
  ItaTree.cpp

  Copyright (C) 2001 Hachimaki. All rights reserved.
  Licensed under the GPL(v2).
***************************************************************************/

#include "GBCommon.h"
#include <process.h>


//NX`
class GGetNameCategory : public GBase
{
public:
	bool get(const char* url, char* title, char* category)
	{
		char* buff;
		char* token;
		UINT buffsize;

/*		if      (strstr(url, "auto"))     strcpy(category, "ԁEoCN");
		else if (strstr(url, "computer")) strcpy(category, "p\RElbg");
		else if (strstr(url, "game"))     strcpy(category, "Q[");
		else if (strstr(url, "movie"))    strcpy(category, "TVEfE{");
		else if (strstr(url, "music"))    strcpy(category, "|\Ey");
		else if (strstr(url, "shop"))     strcpy(category, "VbsO");
		else if (strstr(url, "sports"))   strcpy(category, "EX|[c");
		else if (strstr(url, "travel"))   strcpy(category, "sEn");
		else if (strstr(url, "business")) strcpy(category, "rWlXEo");
		else if (strstr(url, "study"))    strcpy(category, "lEȊw");
		else if (strstr(url, "news"))     strcpy(category, "j[XE");
		else*/                              strcpy(category, "");

		strcpy(title, "");
		if ((buff = get_html(url, &buffsize)) == NULL)
			return false;
		token = strtok(buff, "<>");
		while (token != NULL)
		{
			if (stricmp(token, "TITLE") == 0)
			{
				if ((token = strtok(NULL, "<>")) != NULL)
				{
					strcpy(title, token);
					break;
				}
			}
			token = strtok(NULL, "<>");
		}
		free(buff);

		if (strlen(title) == 0)
			return false;
		return true;
	};
};

//OQ
extern HINSTANCE instance;
extern HWND hwnd_main;
extern HWND hwnd_tree;
extern HWND hwnd_list;
extern HANDLE handle_get_thread;
extern UINT timer_id;
extern GItaList* italist_fav;
extern GItaList* italist_2ch;
extern GItaList* italist_etc;
extern GSureList* surelist_def;
extern int list_type;
extern BOOL tab_automove_ita;
extern char image_file[MAX_PATH];

//O[oϐ
static HTREEITEM item_rclick;

//֐vg^Cv
static BOOL CALLBACK dlg_addita_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
static BOOL CALLBACK dlg_itaprop_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
static LPARAM get_tree_param(HTREEITEM item);
static UINT WINAPI threadentry_get_sure(void* data);


/*--------------------------------------------------------------------------
 
  create_itatree

  c[Rg[쐬

--------------------------------------------------------------------------*/

void create_itatree(void)
{
	hwnd_tree = CreateWindowEx(
		WS_EX_CLIENTEDGE,
		WC_TREEVIEW,
		"",
		WS_CHILD | WS_CLIPSIBLINGS | WS_TABSTOP | WS_VISIBLE |
		TVS_HASLINES /*| TVS_HASBUTTONS | TVS_LINESATROOT*/ | TVS_SHOWSELALWAYS,
		0, 0, 0, 0,
		hwnd_main,
		(HMENU)ID_TREE,
		instance,
		NULL);
}


/*--------------------------------------------------------------------------
 
  set_itatree_image

  C[WXgZbg

--------------------------------------------------------------------------*/

void set_itatree_image(void)
{
	HIMAGELIST imagelist;
	HBITMAP bitmap;

	if (strlen(image_file) != 0)
	{
		if ((imagelist = create_imagelist()) != NULL)
		{
			TreeView_SetImageList(hwnd_tree, imagelist, TVSIL_NORMAL);
			return;
		}
	}

	imagelist = ImageList_Create(16, 16, ILC_COLOR8 | ILC_MASK, 10, 0);
	ImageList_SetBkColor(imagelist, GetSysColor(COLOR_WINDOW));
	bitmap = LoadBitmap(instance, MAKEINTRESOURCE(IDB_IMAGELIST));
	ImageList_AddMasked(imagelist, bitmap, RGB(0xFF, 0x00, 0xFF));
	DeleteObject(bitmap);

	TreeView_SetImageList(hwnd_tree, imagelist, TVSIL_NORMAL);
}


/*--------------------------------------------------------------------------
 
  itatree_OnContextMenu

  ENbNj[\

--------------------------------------------------------------------------*/

void itatree_OnContextMenu(WORD x, WORD y)
{
	TVHITTESTINFO tree_ht;
	HTREEITEM item;
	MENUITEMINFO mii;
	LPARAM param;
	HMENU menu1;
	HMENU menu2;
	RECT r;

	//}EX̃ACe擾
	if (x == USHRT_MAX && y == USHRT_MAX)
	{
		item = TreeView_GetSelection(hwnd_tree);
		TreeView_GetItemRect(hwnd_tree, item, &r, TRUE);
		MapWindowPoints(hwnd_tree, HWND_DESKTOP, (POINT*)&r, 2);
		x = (USHORT)r.left;
		y = (USHORT)r.bottom;
	}
	else
	{
		tree_ht.pt.x = x;
		tree_ht.pt.y = y;
		ScreenToClient(hwnd_tree, &tree_ht.pt);
		if ((item = TreeView_HitTest(hwnd_tree, &tree_ht)) == NULL)
			return;
		TreeView_Select(hwnd_tree, item, TVGN_CARET);
	}
	param = get_tree_param(item);

	//j[\
	menu1 = LoadMenu(instance, MAKEINTRESOURCE(IDR_ITA_TREE_POPUP));
	menu2 = GetSubMenu(menu1, 0);
	mii.cbSize = sizeof(mii);

	if (LOWORD(param) == USHRT_MAX)
	{
		mii.fMask = MIIM_STATE;
		mii.fState = MFS_DISABLED;
		SetMenuItemInfo(menu2, IDM_ADD_FAVORITE_ITA, FALSE, &mii);
		SetMenuItemInfo(menu2, IDM_OPEN_ITA_BY_BROWSER, FALSE, &mii);
		SetMenuItemInfo(menu2, IDM_ITA_PROPERTY, FALSE, &mii);
		if (HIWORD(param) == 0)
			SetMenuItemInfo(menu2, IDM_DEL_ITA, FALSE, &mii);
	}

	if (HIWORD(param) == 0)
	{
		mii.fMask = MIIM_STATE;
		mii.fState = MFS_DISABLED;
		SetMenuItemInfo(menu2, IDM_ADD_FAVORITE_ITA, FALSE, &mii);
	}
	TrackPopupMenu(menu2, TPM_LEFTALIGN | TPM_LEFTBUTTON, x, y, 0, hwnd_main, NULL);
	DestroyMenu(menu1);
}


/*--------------------------------------------------------------------------

  make_itatree

  c[쐬

--------------------------------------------------------------------------*/

void make_itatree(void)
{
	TVINSERTSTRUCT tvi;
	HTREEITEM cat_item;
	char catg[MAX_CATG_NAME];
	char name[MAX_ITA_NAME];
	UINT i;

	LockWindowUpdate(hwnd_tree);
	TreeView_DeleteAllItems(hwnd_tree);

	//Cɓ
	strcpy(catg, "Cɓ");
	tvi.hParent = TVI_ROOT;
	tvi.hInsertAfter = TVI_LAST;
	tvi.item.mask = TVIF_TEXT | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
	tvi.item.state = TVIS_BOLD | TVIS_EXPANDED;
	tvi.item.stateMask = tvi.item.state;
	tvi.item.pszText = catg;
	tvi.item.cchTextMax = strlen(catg);
	tvi.item.iImage = 2;
	tvi.item.iSelectedImage = 2;
	tvi.item.lParam = MAKELPARAM(USHRT_MAX, 0);
	cat_item = TreeView_InsertItem(hwnd_tree, &tvi);
	TreeView_SelectItem(hwnd_tree, cat_item);
	
	for (i = 0; i < italist_fav->count(); i++)
	{
		tvi.hParent = cat_item;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
		strcpy(name, italist_fav->get_name(i));
		tvi.item.pszText = name;
		tvi.item.cchTextMax = strlen(name);
		tvi.item.iImage = 3;
		tvi.item.iSelectedImage = 3;
		tvi.item.lParam = MAKELPARAM(i, 0);
		TreeView_InsertItem(hwnd_tree, &tvi);
	}

	//2channel.brd
	strcpy(catg, "");
	for (i = 0; i < italist_2ch->count(); i++)
	{
		if (strcmp(italist_2ch->get_category(i), catg) != 0)
		{
			strcpy(catg, italist_2ch->get_category(i));
			tvi.hParent = TVI_ROOT;
			tvi.hInsertAfter = TVI_LAST;
			tvi.item.mask = TVIF_TEXT | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
			tvi.item.state = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.stateMask = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.pszText = catg;
			tvi.item.cchTextMax = strlen(catg);
			tvi.item.iImage = 0;
			tvi.item.iSelectedImage = 0;
			tvi.item.lParam = MAKELPARAM(USHRT_MAX, 1);
			cat_item = TreeView_InsertItem(hwnd_tree, &tvi);
		}
		
		tvi.hParent = cat_item;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
		strcpy(name, italist_2ch->get_name(i));
		tvi.item.pszText = name;
		tvi.item.cchTextMax = strlen(name);
		tvi.item.iImage = 1;
		tvi.item.iSelectedImage = 1;
		tvi.item.lParam = MAKELPARAM(i, 1);
		TreeView_InsertItem(hwnd_tree, &tvi);
	}

	//etc.brd
	strcpy(catg, "");
	for (i = 0; i < italist_etc->count(); i++)
	{
		if (strcmp(italist_etc->get_category(i), catg) != 0)
		{
			strcpy(catg, italist_etc->get_category(i));
			tvi.hParent = TVI_ROOT;
			tvi.hInsertAfter = TVI_LAST;
			tvi.item.mask = TVIF_TEXT | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
			tvi.item.state = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.stateMask = TVIS_BOLD | TVIS_EXPANDED;
			tvi.item.pszText = catg;
			tvi.item.cchTextMax = strlen(catg);
			tvi.item.iImage = 0;
			tvi.item.iSelectedImage = 0;
			tvi.item.lParam = MAKELPARAM(USHRT_MAX, 2);
			cat_item = TreeView_InsertItem(hwnd_tree, &tvi);
		}
		
		tvi.hParent = cat_item;
		tvi.hInsertAfter = TVI_LAST;
		tvi.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
		strcpy(name, italist_etc->get_name(i));
		tvi.item.pszText = name;
		tvi.item.cchTextMax = strlen(name);
		tvi.item.iImage = 1;
		tvi.item.iSelectedImage = 1;
		tvi.item.lParam = MAKELPARAM(i, 2);
		TreeView_InsertItem(hwnd_tree, &tvi);
	}

	LockWindowUpdate(NULL);
}


/*--------------------------------------------------------------------------
 
  open_ita

  JiX擾j

--------------------------------------------------------------------------*/

void open_ita(void)
{
	unsigned int taddr;
	HTREEITEM item;
	LPARAM param;

	if ((item = TreeView_GetSelection(hwnd_tree)) == NULL)
		return;

	param = get_tree_param(item);
	if (LOWORD(param) == USHRT_MAX)
		return;

	if (tab_automove_ita)
		select_tab(1);

	if (handle_get_thread != NULL)
	{
		if (!TerminateThread(handle_get_thread, 0))
		{
			return;
		}
		CloseHandle(handle_get_thread);
	}
	handle_get_thread = (HANDLE)_beginthreadex(NULL, 0,
		                     threadentry_get_sure, (void*)param, 0, &taddr);
}


/*--------------------------------------------------------------------------
 
  open_ita_by_browser

  uEUŊJ

--------------------------------------------------------------------------*/

void open_ita_by_browser(void)
{
	HTREEITEM item;
	LPARAM param;
	char cmdline[512];

	if ((item = TreeView_GetSelection(hwnd_tree)) == NULL)
		return;

	param = get_tree_param(item);
	if (LOWORD(param) != USHRT_MAX)
	{
		strcpy(cmdline, "exec.exe ");
		switch (HIWORD(param))
		{
		case 0: italist_fav->get_topurl(LOWORD(param), cmdline + 9); break;
		case 1: italist_2ch->get_topurl(LOWORD(param), cmdline + 9); break;
		case 2: italist_etc->get_topurl(LOWORD(param), cmdline + 9); break;
		}
		WinExec(cmdline, SW_SHOWNORMAL);
	}
}


/*--------------------------------------------------------------------------
 
  del_ita

  ̍폜

--------------------------------------------------------------------------*/

void del_ita(void)
{
	HTREEITEM item;
	TVITEM tvi;
	LPARAM param;
	GItaList* italist;
	char message[256];
	char catg[MAX_CATG_NAME];
	UINT i;

	if ((item = TreeView_GetSelection(hwnd_tree)) == NULL)
		return;

	param = get_tree_param(item);
	switch (HIWORD(param))
	{
	case 0: italist = italist_fav; break;
	case 1: italist = italist_2ch; break;
	case 2: italist = italist_etc; break;
	}

	if (LOWORD(param) != USHRT_MAX)
	{
		//ACe폜
		wsprintf(message, "u%sv폜Ă낵łH", italist->get_name(LOWORD(param)));
		if (MessageBox(hwnd_tree, message, "̍폜", MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
		{
			italist->del(LOWORD(param));
		}
	}
	else
	{
		//JeS폜
		tvi.hItem = item;
		tvi.mask = TVIF_TEXT;
		tvi.pszText = catg;
		tvi.cchTextMax = sizeof(catg);
		TreeView_GetItem(hwnd_tree, &tvi);

		wsprintf(message, "u%svȉ̃ACeׂč폜Ă낵łH", catg);
		if (MessageBox(hwnd_tree, message, "JeS̍폜", MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
		{
			for (i = 0; i < italist->count(); i++)
			{
				if (strcmp(italist->get_category(i), catg) == 0)
				{
					italist->del(i);
					i = 0;
				}
			}
		}
	}
	italist->save();
	make_itatree();
}


/*--------------------------------------------------------------------------
 
  add_favorite_ita

  Cɓɒǉ

--------------------------------------------------------------------------*/

void add_favorite_ita(void)
{
	HTREEITEM item;
	GItaList* italist;
	LPARAM param;
	int idx;
	UINT i;

	if ((item = TreeView_GetSelection(hwnd_tree)) == NULL)
		return;

	if ((param = get_tree_param(item)) == -1)
		return;

	switch (HIWORD(param))
	{
	case 0: return;
	case 1: italist = italist_2ch; break;
	case 2: italist = italist_etc; break;
	}
	idx = LOWORD(param);

	//ɂCɓɑ݂邩H
	for (i = 0; i < italist_fav->count(); i++)
	{
		if (strcmp(italist->get_server(idx), italist_fav->get_server(i)) == 0 &&
			strcmp(italist->get_bbs(idx),    italist_fav->get_bbs(i))    == 0)
		{
			return;
		}
	}
	
	italist_fav->add(
		italist->get_name(idx),
		"Cɓ",
		italist->get_server(idx),
		italist->get_bbs(idx),
		0);

	italist_fav->save();
	make_itatree();
}


/*--------------------------------------------------------------------------
 
  show_addita_dlg

  ǉ_CAO\

--------------------------------------------------------------------------*/

void show_add_ita_dlg(void)
{
	if (DialogBox(instance, MAKEINTRESOURCE(IDD_ADD_ITA), hwnd_tree, dlg_addita_Proc) == IDOK)
		make_itatree();
}


/*--------------------------------------------------------------------------
 
  show_ita_property

  vpeB\

--------------------------------------------------------------------------*/

void show_ita_property(void)
{
	if (DialogBox(instance, MAKEINTRESOURCE(IDD_ITA_PROPERTY), hwnd_tree, dlg_itaprop_Proc) == IDOK)
		make_itatree();
}


/*--------------------------------------------------------------------------
 
  dlg_addita_Proc

  ǉ_CAOEvV[W

--------------------------------------------------------------------------*/

BOOL CALLBACK dlg_addita_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	GGetNameCategory* ggnc;
	GItaList* italist_all[3];
	GItaList* italist;
	HWND h;
	char category[MAX_CATG_NAME];
	char name[MAX_ITA_NAME];
	char server[MAX_SERVER_NAME];
	char bbs[MAX_BBS_NAME];
	char topurl[256];
	char* token;
	UINT i;
	UINT j;

	switch (msg)
	{
	case WM_INITDIALOG:
		Edit_LimitText(GetDlgItem(hwnd, IDC_TOPURL),       sizeof(topurl) - 1);
		Edit_LimitText(GetDlgItem(hwnd, IDC_ITA_NAME),     sizeof(name) - 1);
		ComboBox_LimitText(GetDlgItem(hwnd, IDC_CATEGORY), sizeof(category) - 1);

		h = GetDlgItem(hwnd, IDC_CATEGORY);
		italist_all[0] = italist_fav;
		italist_all[1] = italist_2ch;
		italist_all[2] = italist_etc;
		for (i = 0; i < 3; i++)
		{
			strcpy(category, "");
			for (j = 0; j < italist_all[i]->count(); j++)
			{
				if (strcmp(category, italist_all[i]->get_category(j)) != 0)
				{
					strcpy(category, italist_all[i]->get_category(j));
					ComboBox_AddString(h, category);
					ComboBox_SetItemData(h, ComboBox_GetCount(h) - 1, (LPARAM)italist_all[i]);
				}
			}
		}
		ComboBox_SetCurSel(h, 0);
		set_window_pos_best(hwnd);
		break;

	case WM_COMMAND:
		switch (LOWORD(wp))
		{
		//擾
		case IDC_AUTOGET:
			h = GetDlgItem(hwnd, IDC_TOPURL);
			Edit_GetText(h, topurl, sizeof(topurl));
			if (strlen(topurl) == 0) { SetFocus(h); break; }

			EnableWindow(GetDlgItem(hwnd, IDC_TOPURL), FALSE);
			EnableWindow(GetDlgItem(hwnd, IDC_AUTOGET), FALSE);
			EnableWindow(GetDlgItem(hwnd, IDC_ITA_NAME), FALSE);
			EnableWindow(GetDlgItem(hwnd, IDC_CATEGORY), FALSE);


			SetTimer(hwnd, IDT_GETNAMECATEGORY, 500, NULL);
			break;

		//OK
		case IDOK:
			h = GetDlgItem(hwnd, IDC_TOPURL);
			Edit_GetText(h, topurl, sizeof(topurl));
			if (strlen(topurl) == 0) { SetFocus(h); break; }

			token = strtok(topurl, "/");
			if (strchr(token, ':') != NULL)
				token = strtok(NULL, "/");
			strcpy(server, token);
			if ((token = strtok(NULL, "/")) == NULL)  { SetFocus(h); break; }
			strcpy(bbs, token);
			if ((token = strtok(NULL, "/")) != NULL && strchr(token, '.') == NULL)
			{
				strcat(server, "/");
				strcat(server, bbs);
				strcpy(bbs, token);
			}

			h = GetDlgItem(hwnd, IDC_ITA_NAME);
			Edit_GetText(h, name, sizeof(name));
			if (strlen(name) == 0) { SetFocus(h); break; }

			h = GetDlgItem(hwnd, IDC_CATEGORY);
			ComboBox_GetText(h, category, sizeof(category));
			if (strlen(category) == 0) { SetFocus(h); break; }
			if (ComboBox_GetCurSel(h) == CB_ERR)
				italist = italist_etc;
			else
				italist = (GItaList*)ComboBox_GetItemData(h, ComboBox_GetCurSel(h));

			italist->add(name, category, server, bbs, 0);
			italist->save();

		//CANCEL
		case IDCANCEL:
			EndDialog(hwnd,  LOWORD(wp));
			break;
		}
		break;

	case WM_TIMER:
		//擾
		KillTimer(hwnd, IDT_GETNAMECATEGORY);
		Edit_GetText(GetDlgItem(hwnd, IDC_TOPURL), topurl, sizeof(topurl));
		ggnc = new GGetNameCategory();
		if (ggnc->get(topurl, name, category))
		{
			Edit_SetText(GetDlgItem(hwnd, IDC_ITA_NAME), name);
			//Edit_SetText(GetDlgItem(hwnd, IDC_CATEGORY), category);
		}
		else
		{
			MessageBox(hwnd, "擾s", NULL, MB_OK | MB_ICONWARNING);
		}

		EnableWindow(GetDlgItem(hwnd, IDC_TOPURL), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_AUTOGET), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_ITA_NAME), TRUE);
		EnableWindow(GetDlgItem(hwnd, IDC_CATEGORY), TRUE);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/*--------------------------------------------------------------------------
 
  dlg_itaprop_Proc

  vpeB_CAOEvV[W

--------------------------------------------------------------------------*/

BOOL CALLBACK dlg_itaprop_Proc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static GItaList* italist;
	static int idx;
	char category[MAX_CATG_NAME];
	char name[MAX_ITA_NAME];
	char server[MAX_SERVER_NAME];
	char bbs[MAX_BBS_NAME];
	HTREEITEM item;
	LPARAM param;
	HWND h;

	switch (msg)
	{
	case WM_INITDIALOG:
		Edit_LimitText(GetDlgItem(hwnd, IDC_ITA_NAME), sizeof(name) - 1);
		Edit_LimitText(GetDlgItem(hwnd, IDC_CATEGORY), sizeof(category) - 1);
		Edit_LimitText(GetDlgItem(hwnd, IDC_SERVER), sizeof(server) - 1);
		Edit_LimitText(GetDlgItem(hwnd, IDC_BBS), sizeof(bbs) - 1);

		if ((item = TreeView_GetSelection(hwnd_tree)) == NULL)
			return false;
		param = get_tree_param(item);
		switch (HIWORD(param))
		{
		case 0: italist = italist_fav; break;
		case 1: italist = italist_2ch; break;
		case 2: italist = italist_etc; break;
		}
		idx = LOWORD(param);
		Edit_SetText(GetDlgItem(hwnd, IDC_ITA_NAME), italist->get_name(idx));
		Edit_SetText(GetDlgItem(hwnd, IDC_CATEGORY), italist->get_category(idx));
		Edit_SetText(GetDlgItem(hwnd, IDC_SERVER), italist->get_server(idx));
		Edit_SetText(GetDlgItem(hwnd, IDC_BBS), italist->get_bbs(idx));
		set_window_pos_best(hwnd);
		break;

	case WM_COMMAND:
		switch (LOWORD(wp))
		{
		//OK
		case IDOK:
			h = GetDlgItem(hwnd, IDC_ITA_NAME);
			Edit_GetText(h, name, sizeof(name));
			if (strlen(name) == 0) { SetFocus(h); break; }
			
			h = GetDlgItem(hwnd, IDC_CATEGORY);
			Edit_GetText(h, category, sizeof(category));
			if (strlen(name) == 0) { SetFocus(h); break; }

			h = GetDlgItem(hwnd, IDC_SERVER);
			Edit_GetText(h, server, sizeof(server));
			if (strlen(server) == 0) { SetFocus(h); break; }

			h = GetDlgItem(hwnd, IDC_BBS);
			Edit_GetText(h, bbs, sizeof(bbs));
			if (strlen(bbs) == 0) { SetFocus(h); break; }

			italist->modify(idx, name, category, server, bbs);
			italist->save();
			
		//CANCEL
		case IDCANCEL:
			EndDialog(hwnd,  LOWORD(wp));
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/*--------------------------------------------------------------------------
 
  get_tree_param

  c[ACelParam擾

--------------------------------------------------------------------------*/

LPARAM get_tree_param(HTREEITEM item)
{
	TVITEM tvi;

	tvi.hItem = item;
	tvi.mask = TVIF_PARAM;
	TreeView_GetItem(hwnd_tree, &tvi);
	return tvi.lParam;
}


/*--------------------------------------------------------------------------
 
  threadentry_get_sure

  Xꗗ擾邽߂̃Xbh֐

--------------------------------------------------------------------------*/

unsigned int WINAPI threadentry_get_sure(void* data)
{
	GItaList* italist;
	char from[MAX_FROM_NAME];
	int idx;

	if (timer_id == 0)
		timer_id = SetTimer(hwnd_main, IDT_LAMPBLINK, 1000, NULL);

	list_type = 0;
	make_surelist(0);
	
	switch (HIWORD((LPARAM)data))
	{
	case 0: italist = italist_fav; break;
	case 1: italist = italist_2ch; break;
	case 2: italist = italist_etc; break;
	}
	idx = LOWORD((LPARAM)data);
	strcpy(from, italist->get_name(idx));
	
	//擾
	if (!surelist_def->get(italist->get_server(idx), italist->get_bbs(idx), from))
	{
		//s
/*		ListView_DeleteAllItems(hwnd_list);
    
		item.mask = LVIF_TEXT;
		item.pszText = NULL;
		item.iItem = 0;
		item.iSubItem = 0;
		ListView_InsertItem(hwnd_list, &item);
		
		wsprintf(tmp, "G[F%s", italist_2ch->get_error());
		item.pszText = tmp;
		item.iItem = 0;
		item.iSubItem = 1;
		ListView_SetItem(hwnd_list, &item);*/
	}
	else
	{
		if (list_type == 0)
			make_surelist(0);
	}

	CloseHandle(handle_get_thread);
	handle_get_thread = NULL;
	if (list_type == 0)
		make_surelist(0);
	_endthreadex(0);
	return 0;
}
